#include "CmisAgent.h"
#include "Coordinator.h"


// DestinationGms methods

int  DestinationGms::set (void* val)
{
    DestAddressVal* newAddr = (DestAddressVal*) val;
    if (!newAddr)
	return NOTOK;

    if (newAddr -> da_type == DA_MSD)
	newAddr -> da_msd = CMISAgent::getInstance()->getThisAssoc();

    setval(newAddr);
    return OK;
}


// eventForwardingDiscriminator methods

int eventForwardingDiscriminator::createRR (AVA*& err, void*, int)
{
    // reject creation if mandatory destination attribute was not supplied
    if (!destination() -> get()) {
	err = new AVA(m_missingAttributeValue, "destination");
	return NOTOK;
    }

    // call the parent class createRR method
    if (discriminator::createRR(err) == NOTOK)
        return NOTOK;

    // register with the Coordinator to optimise wake-ups
    Coordinator::getInstance()->registerReportObj();

    return OK;
}


int eventForwardingDiscriminator::deleteRR (AVA*& err, void* info,
						Bool checkOnly, int)
{
    // deregister with the Coordinator
    if (!checkOnly)
	Coordinator::getInstance()->deregisterReportObj();

    return discriminator::deleteRR(err, info, checkOnly);
}

