/*
* NAME
*   TimePeriod.inc.h
*
* DESCRIPTION
*   ISO/IEC 10164-11 TimePeriod Attribute from supporting ASN.1 defns
*
* AUTHOR
*   Jim Reilly
*   Technical Research Centre of Finland
*   icm.group@tel.vtt.fi
*/

public:

    // redefine Attr::set(void*) to check if
    // new value units is supported
    // i.e. units secs ... days

    inline int set(void* newval) {
      type_Monitor_TimePeriod* tp = (type_Monitor_TimePeriod*)newval;
      if ( (tp->offset == type_Monitor_TimePeriod_milliSeconds) ||
           (tp->offset == type_Monitor_TimePeriod_microSeconds) ||
           (tp->offset == type_Monitor_TimePeriod_nanoSeconds)  ||
           (tp->offset == type_Monitor_TimePeriod_picoSeconds)
      ) {
        return NOTOK;	// units < seconds are not supported
      } else {
        return Attr::set(newval);
      }
    }

    inline TimePeriod() {
      type_Monitor_TimePeriod* tp = new type_Monitor_TimePeriod;
      tp->offset=type_Monitor_TimePeriod_seconds;
      tp->un.seconds=60;
      setval(tp);
    }

    inline TimePeriod(type_Monitor_TimePeriod* tp)
    { set(tp); }

