//
// NAME
//   monitorMetric.inc.h
//
// DESCRIPTION
//   for monitorMetric MOC, via OSIMIS GDMO compiler
//   (based on ISO/IEC 10164-11 Monitor Objects MIB)
//   -- derived from scanner --
//
// AUTHOR
//   Jim Reilly
//   Technical Research Centre of Finland
//   icm.group@tel.vtt.fi
//

private:

#define DERIVEDGAUGETHLDHIGH	65535	// a stupid guess
#define DERIVEDGAUGETHLDLOW	0	// a stupid guess

	Bool			_bNoPreviousCounterValue;
					// for Rate Counter conversions

        int			_gaugeType;
					// what type of local gauge we use
					// OV_INTEGER or OV_REAL


	/*********************************************************
         *
	 * These are set only once by createRR but are used
	 * later during e.g. updateDerivedGauge() or buildReport().
         *
         *********************************************************/

	DN			_dnObservedObjectInstance;
	int			_typeObservedObjectInstance;
	MO*			_pmoObserved;
					// dn an ptr of observed MO
        OID			_oidObservedAttribute;
	Attr*			_pvObservedMOattribute;
					// oid and attr inside observed MO
	char*			_strObservedAttribute;
					// name of attr inside observed MO
					// i.e. name2oid(_oidObservedAttribute)
protected:

#define OA_COUNTER		1
#define OA_GAUGE		2
#define OA_SNMPGAUGE		3

        int			_observedAttrType;
					// what type of attribute we observe
					// OA_GAUGE or OA_COUNTER

	Attr*			_qosAlarmGauge;
	OID			_qosAlarmThldOid;

        /***********************************************************/

protected:
	type_SMI_AlarmInfo*	_thldAlarmInfo;
					// also used by derived classes for
					// their AlarmInfo notifications ?

        inline int		gaugeType() { return _gaugeType; }

        int			set (CMISModifyOp, int, int, void*, AVA*&,
					Bool = False, int = -1);
	int			buildReport(int, int, void*&, Bool&);
					// redefine these inherited MO methods 

	void			updateDerivedGauge();
					// update from Real Resource

        type_SMI_AlarmInfo*	_thldAlarmInfo_alloc();
					// alloc space for Threshold Notif:s

	void*			forceGet (MO* pmo, OID oid);
					// force a get to occur "now"
					// on the Real Resource

public:
	int			createRR(AVA*&, void* = NULLVD, int = -1);
	int			deleteRR(AVA*&, void* = NULLVD,
						Bool = False, int = -1);

	inline int		wakeUp (char*)
                                  { updateDerivedGauge(); return OK; }
					// what to do when we get a scheduled
					// wakeup (POLL real resource)

