//
// NAME
//   monitoringSupportMode1.inc.h
//
// DESCRIPTION
//   for monitoringSupportMode1 MOC, via OSIMIS GDMO compiler
//   This class inherits from the monitoringSupport
//   and has the functionality to read the two lists and
//   find the observed attributes.
//
// IMPLEMENTORS
//   George Mykoniatis
//   NTUA
//   mykoniat@ektor.ntua.gr
//

private:

// For the quality of Service Alarm
   type_SMI_AlarmInfo*           _thldAlarmInfo_alloc();

   int 		DecomposeAttrList();	// Decomposes AttrList string
   int 		CheckConsistency();     // Checks Consistency
   int		CheckObservedMOs();	// Checks the MOs for existance 
					// every time a wake up has happened
   int 		StartUp();		// Starts the object 
   int 		CheckFirstTime();	// Checks for errors when observation 
					// is initiated
   int 		InitObservedAttrs();    // Creates and initialise
					// the observed attrs

   MIDListVal*	_oidlist;		// head of attributeIdList
   MNListVal* 	_dnlist; 		// head of ObjectInstanceList
   int		_typeMO;

protected:
   int	  	set (CMISModifyOp, int, int, void*, AVA*&, Bool = False, int = -1);
   int         createRR (AVA*&, void* = NULLVD, int = -1);

public:
   inline int  wakeUp (char*)              
           { monitoringSupport::update(); return OK; }
