//
// NAME
//   sumdefs.h
//
// DESCRIPTION
//   definitions for algorithms
//
// IMPLEMENTORS
//   George Mykoniatis
//   NTUA
//   mykoniat@ektor.ntua.gr
//

#ifndef _SUMDEFS_H_
#define _SUMDEFS_H_

// --------------------------------------------
// Constants related to the operations applied
// on the observed attributes
// --------------------------------------------
#define ALG_FindSum              1
#define ALG_FindDiv              2
#define ALG_FindMean             3
#define ALG_FindProb             4
#define ALG_FindSpecialSum       5
#define ALG_FindProd             6
#define ALG_FindSubstraction     7


// ------------------------------------------------------------------
// Constants for the algorithms used by sumstats
// ------------------------------------------------------------------
#define SUMSTAT_NTHNG   0
#define SUMSTAT_UWMA    1     // Uniform weighted moving average
#define SUMSTAT_EWMA    2     // Exponential weighted moving average
#define SUMSTAT_WMA     3     // Weighted moving average

// ------------------------------------------------------------------

#endif
