//
// NAME
//   sumstat.h
//
// DESCRIPTION
//   definition of the class for the statistics
//   of the Monitoring Support objects
//
// IMPLEMENTORS
//   George Mykoniatis
//   NTUA
//   mykoniat@ektor.ntua.gr
//

#include <stdio.h>
#include <math.h>

#include "sumdefs.h"

#ifndef _SUMSTAT_
#define _SUMSTAT_

class sumstats
{
private:
  double *array;		    	// Pointer to buffer
  double result;	        	// Result
  int    period;		    	// sampling period
  int    window;		    	// Window size
  int    no_of_samples;			// Holds the number of samples
  int    buffer_flag;			// If true, shows that the buffer
				        // has been filled with samples
				        // and the derived result is correct
  int    algorithm;		    	// Contains the applied algorithm
  int    index;             		// Index in the array

  // Variables used by the algorithms
  double prev_val;          		// Previous value of EWMA

  double apply_algorithm(); 		// Updates result;

public:
  int initialize(int window, int period,int algorithm, double initial_value);
  ~sumstats();
  int append_value(double sample);
  void print_sumstats();
  double get_last_value();    

  double get_result()        { return result; }
  int    get_status()        { return buffer_flag; }
  int    get_no_of_samples() { return no_of_samples; }
  int    get_algorithm()     { return algorithm; }
  int    get_period()        { return period; }
};

#endif
