//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// AdministrativeState.h

// By George Pavlou, February 1991


#ifndef _AdministrativeState_h_
#define _AdministrativeState_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class AdministrativeState : public Attr
{
protected:
    inline PE	 _encode ()		{ return AdministrativeState_encode(
					  (AdminStateVal*) getval()); }
    inline void* _decode (PE pe)	{return AdministrativeState_decode(pe);}
    inline void	 _free ()		{ free((char*) getval()); }
    inline char* _print ()		{ return attrv2str(getval(), (PRINT_FNX)
					  AdministrativeState_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return AdministrativeState_cmp(
					(AdminStateVal*)v1,(AdminStateVal*)v2);}
public:
    inline void	set (AdminStateVal newState)
					{ AdminStateVal* state =
					  (AdminStateVal*) getval();
					  *state = newState; replval(state); }
    inline int	set (void* val)		{ set(*(AdminStateVal*) val);
					  return OK; }
    inline char* getSyntax ()		{ return "AdministrativeState"; }

    inline AdministrativeState ()	{ AdminStateVal* state = new
					  AdminStateVal; *state = as_unlocked;
					  setval(state); }
    inline AdministrativeState (AdminStateVal myState)
					{ AdminStateVal* state =
					  new AdminStateVal; *state = myState;
					  setval(state); }
};


#endif
