//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// AvailabilityStatus.h

// By Saleem Bhatti


#ifndef _AvailabilityStatus_h_
#define _AvailabilityStatus_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class AvailabilityStatus : public Attr {

protected :

    PE   _encode();
    void *_decode(PE);
    void _free();
    void* _parse (char*);
    char* _print ();

public :

    int add(void *);
    int remove(void *);

    Bool filter(int, void *);

    int add(int);       // internal use only
    int remove(int);    // internal use only
    Bool isMember(int); // internal use only

    char * getSyntax();

    AvailabilityStatus(); // default is {} (empty set)
    AvailabilityStatus(AvailabilityStatusValue *);
};

inline PE
AvailabilityStatus::_encode()
{ return(encodeAvailabilityStatus((AvailabilityStatusValue *) getval())); }

inline void *
AvailabilityStatus::_decode(PE pe)
{ return((void *) decodeAvailabilityStatus(pe)); }

inline void *
AvailabilityStatus::_parse (char* str)
{ return parseAvailabilityStatus(str); }

inline char *
AvailabilityStatus::_print()
{ return(attrv2str(getval(), (PRINT_FNX) printAvailabilityStatus)); }

inline void
AvailabilityStatus::_free()
{ freeAvailabilityStatus((AvailabilityStatusValue *) getval()); }

inline char *
AvailabilityStatus::getSyntax()
{ return "AvailabilityStatus"; }


#endif
