//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// Bool.h

// By George Pavlou, February 1991


#ifndef _Bool_h_
#define _Bool_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class Boolean : public Attr
{
protected:
    inline PE	 _encode ()		{ return bool_enc((Bool*) getval()); }
    inline void* _decode (PE pe)	{ return bool_dec(pe); }
    inline void	 _free ()		{ free((char*) getval()); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) bool_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return int_cmp((int*) v1, (int*) v2);}
public:
    inline Bool getbool ()		{ return *(Bool*) getval(); }
    inline void	set (Bool val)		{ Bool* v = (Bool*) getval();
					  *v = val; replval(v); }
    inline int	set (void* val)		{ set(*(Bool*) val); return OK; }

    inline	Boolean ()		{ Bool* v = new Bool; *v = False;
					  setval(v); }
    inline	Boolean (Bool val)	{ Bool* v = new Bool; *v = val;
					  setval(v); }
};


#endif
