//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// Counter.cc

// By George Pavlou


#include <stdlib.h>
#include "msap.h"
#include "Counter.h"



Switch  Counter::set (int newVal)
{
    int* value = (int*) getval();
    int prevVal = *value;
    *value = newVal;
    replval(value);	// we use the same allocated int
    if (threshold)
	return threshold -> check(*value, prevVal);
    return Off;
}


Switch  Counter::increment (int incr)
{
    int* value = (int*) getval();
    int prevVal = *value;
    *value += incr;
    replval(value);	// as in set
    if (threshold)
	return threshold -> check(*value, prevVal);
    return Off;
}

