//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// CounterThld.cc

// By George Pavlou, February 1991


#include <stdlib.h>
#include "msap.h"
#include "CounterThld.h"


Switch  CounterThreshold::check (int val, int prev)
{
    CounterThresholdVal* cthld = (CounterThresholdVal*) getval();
    Switch trigger = Off;

    for (register CounterThresholdVal* cur = cthld; cur; cur = cur -> ct_next)
	if (val >= cur -> ct_compLevel && prev < cur -> ct_compLevel) {
	    if (cur -> ct_notifyOnOff != On)
		continue;
	    trigger = On;	// triggered, adjust comparison level
	    if (cur -> ct_offsetVal)
		cur -> ct_compLevel +=
		((val - cur -> ct_compLevel) / cur -> ct_offsetVal + 1)
		* cur -> ct_offsetVal;
	}

    if (trigger == On)
	replval(cthld);

    return trigger;
}


int  CounterThreshold::add (int level, int offset, Switch onoff)
{
    CounterThresholdVal* elem = new CounterThresholdVal;
    elem -> ct_compLevel   = level;
    elem -> ct_offsetVal   = offset;
    elem -> ct_notifyOnOff = onoff;
    elem -> ct_next	   = NULL;

    return Attr::add(elem);
}


int  CounterThreshold::setDefault (void* val)
{
    if (val == NULLVD)
	return NOTOK;

    CounterThresholdVal* cthld = (CounterThresholdVal*) val;
    if (counter)
	cthld->ct_compLevel = (*(int*) counter->get() / cthld->ct_offsetVal + 1)
			* cthld->ct_offsetVal;
    setval(cthld);
    return OK;
}

