//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// DNList.h

// By George Pavlou, February 1991


#ifndef _DNList_h_
#define _DNList_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class DNList : public Attr
{
protected:
    inline PE	  _encode ()		{ return DNList_encode(
					  (type_SMI_DistinguishedNameList*) getval()); }
    inline void*  _decode (PE pe)	{ return DNList_decode(pe);}
    inline void	  _free ()		{ DNList_free(
					  (type_SMI_DistinguishedNameList*) getval()); }
    inline void*  _parse (char* str)	{ return DNList_parse(str);}
    inline char*  _print ()		{ return attrv2str(getval(),
					 (PRINT_FNX) DNList_print);}
    inline void** _getelem (void* v)	{ return (void**)
				          DNList_getelem(
					  (type_SMI_DistinguishedNameList*) v); }
    inline void** _getnext (void* v)	{ return (void**)
				          DNList_getnext(
					  (type_SMI_DistinguishedNameList*) v); }

public:
    inline DNList ()			{ setval(NULL); }
};


#endif
