//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// DName.h

// By George Pavlou, February 1991


#ifndef _DName_h_
#define _DName_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class DName : public Attr
{
protected:
    inline PE    _encode ()		{ return dn_enc((DN) getval()); }
    inline void* _decode (PE pe)	{ return dn_dec(pe); }
    inline void  _free ()		{ dn_free((DN) getval()); }
    inline void* _parse (char* str)	{ return str2dn(str); }
    inline char* _print ()		{ return attrv2str(getval(),
                                          (PRINT_FNX) dn_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return dn_cmp((DN) v1, (DN) v2); }
public:
    inline DName ()			{ setval(NULLDN); }
    inline DName (DN mydn)		{ setval(mydn); }
};


#endif
