//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// Destination.cc

// By George Pavlou, May 1995


#include <stdlib.h>
#include "msap.h"
#include "Destination.h"


void  DestinationAddress::multipleAetStateSetUp ()
{
    _multipleAetState = new Array(5);
    register type_SMI_AETitleList* cur =
		((struct type_SMI_Destination*) getval())->un.multipleAET;

    for (register i = 0; cur; i++, cur = cur->next) {
	Bool* state = new Bool;
	*state = True;
	_multipleAetState->add(state);
    }
}


void  DestinationAddress::multipleAetStateReset ()
{
    if (_multipleAetState) {
	_multipleAetState->clear();
	delete _multipleAetState;
	multipleAetStateSetUp();
    }
}


int  DestinationAddress::set (void* newVal)
{
    Attr::set(newVal);
    _wasSet = True;

    if (((type_SMI_Destination*) newVal)->offset ==
					type_SMI_Destination_multipleAET)
	if (!_multipleAetState)
	    multipleAetStateSetUp();
	else
	    multipleAetStateReset();
    else
    if (_multipleAetState) {
	_multipleAetState->clear();
	delete _multipleAetState;
	_multipleAetState = NULLARRAY;
    }

    if (_msd > 0)
	_msd = -1;
    return OK;
}


DestinationAddress::DestinationAddress (type_SMI_Destination* myAddr)
{
    setval(myAddr);
    _msd = -1;
    _wasSet = False;

    if (myAddr->offset == type_SMI_Destination_multipleAET)
	multipleAetStateSetUp();
}


DestinationAddress::DestinationAddress ()
{
    struct type_SMI_Destination* dest = new type_SMI_Destination;
    dest->offset = type_SMI_Destination_singleAET;
    dest->un.singleAET = new type_SMI_AETitle;
    dest->un.singleAET->title = oid_cpy(str2oid("0.0"));
    dest->un.singleAET->qualifier = strdup("thisAssociation");
    setval(dest);
    _msd = -1;
    _wasSet = False;
    _multipleAetState = NULLARRAY;
}


DestinationAddress::~DestinationAddress ()
{
    if (_multipleAetState) {
	_multipleAetState->clear();
	delete _multipleAetState;
    }
}

