//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// LogFullAction.h

// By Saleem Bhatti


#ifndef _LogFullAction_h_
#define _LogFullAction_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class LogFullAction : public Attr {

protected :

    PE   _encode();
    void *_decode(PE);
    void _free();
    void* _parse (char*);
    char* _print ();
    int	 _compare (void*, void*);

public :

    void set(LogFullActionValue);
    int set(void*);

    LogFullAction(); // default is lfa_wrap (0)
    LogFullAction(LogFullActionValue);
};

inline PE
LogFullAction::_encode()
{ return(encodeLogFullAction((LogFullActionValue *) getval())); }

inline void *
LogFullAction::_decode(PE pe)
{ return((void *) decodeLogFullAction(pe)); }

inline void
LogFullAction::_free()
{ freeLogFullAction((LogFullActionValue *) getval()); }

inline void *
LogFullAction::_parse(char* str)
{ return parseLogFullAction(str); }

inline char *
LogFullAction::_print()
{ return(attrv2str(getval(), (PRINT_FNX) printLogFullAction)); }

inline int
LogFullAction:: _compare(void* v1, void* v2)
{ return OperationalState_cmp((OperStateVal*) v1, (OperStateVal*) v2); }

inline void
LogFullAction::set(LogFullActionValue v)
{ LogFullActionValue *val = (LogFullActionValue *) getval();
  *val = v; replval(val); }

inline int
LogFullAction::set (void* v)
{ set(*(LogFullActionValue *) v); return OK; }


#endif
