//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// ObjectInstance.h

// By George Pavlou, February 1991


#ifndef _ObjectInstance_h_
#define _ObjectInstance_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class ObjectInstance : public Attr
{
protected:
    inline PE	 _encode ()		{ return ObjectInstance_encode(
							(MN) getval()); }
    inline void* _decode (PE pe)	{ return ObjectInstance_decode(pe); }
    inline void	 _free ()		{ ObjectInstance_free((MN) getval()); }
    inline void* _parse (char* str)	{ return ObjectInstance_parse(str); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) ObjectInstance_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return ObjectInstance_cmp(
							(MN) v1, (MN) v2); }
public:
    inline DN	 getDN ()		{ MN mn = (MN) getval();
					  return mn ? mn->mn_dn : NULLDN; }
    inline void	 setDN (DN dn, int type = MN_LOCALDN)
					{ MN mn = new MName; mn->mn_type = type;
					  mn->mn_dn = dn; setval(mn); }
					  
    inline ObjectInstance ()		{ setDN(NULLDN); }
    inline ObjectInstance (DN dn, int type = MN_LOCALDN)
					{ setDN(dn, type); }
};


#endif
