//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// OperationalState.h

// By George Pavlou, February 1991


#ifndef _OperationalState_h_
#define _OperationalState_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class OperationalState : public Attr
{
protected:
    inline PE	 _encode ()		{ return OperationalState_encode(
					  (OperStateVal*) getval()); }
    inline void* _decode (PE pe)	{ return OperationalState_decode(pe); }
    inline void	 _free ()		{ free((char*) getval()); }
    inline char* _print ()		{ return attrv2str(getval(), (PRINT_FNX)
					  OperationalState_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return OperationalState_cmp(
					  (OperStateVal*)v1,(OperStateVal*)v2);}
public:
    inline void	set (OperStateVal newState)
					{ OperStateVal* state = (OperStateVal*)
					  getval(); *state = newState;
					  replval(state); }
    inline int	set (void* val)		{ set(*(OperStateVal*) val);
					  return OK; }
    inline char* getSyntax ()		{ return "OperationalState"; }

    inline OperationalState ()		{ OperStateVal* state =
					  new OperStateVal; *state=os_enabled;
					  setval(state); }
    inline OperationalState (OperStateVal myState)
					{ OperStateVal* state =
					  new OperStateVal; *state = myState;
					  setval(state); }
};


#endif
