//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// Scope.h

// By George Pavlou, July 1994


#ifndef _Scope_h_
#define _Scope_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


/*
 * the class name cannot be Scope as there is the MO::Scope() method
 * while CMISScope is the name of the encapsulated C struct (mparm.h)
 */

class MScope : public Attr
{
    void	 init();

protected:
    inline PE	 _encode ()		{ return CMISScope_encode(
					  (CMISScope*) getval()); }
    inline void* _decode (PE pe)	{ return CMISScope_decode(pe); }
    inline void	 _free ()		{ free((char*) getval());}
    inline void* _parse (char* str)	{ return str2scope(str); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) CMISScope_print); }
public:
    inline int setScope (int type, int level = 0)
					{ CMISScope* sc = (CMISScope*) getval();
					  sc->sc_type = type;
					  sc->sc_level = level; replval(sc); }
    int	set (void*);

    inline MScope ()			{ init(); }
    inline MScope (int type, int level = 0) { init(); setScope(type, level); }
};


#endif
