//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// SimpleNameType.cc

// By George Pavlou, July 1994


#include <stdlib.h>
#include "msap.h"
#include "Error.h"
#include "SimpleNameType.h"


int  SimpleNameType::setType (int type)
{
    SimpleNameTypeVal* val = (SimpleNameTypeVal*) getval();

    if (val->sn_type == type)
	return OK;

    switch (type) {
    case SN_NUMBER:
    {
	for (register char* cp = val->sn_string; *cp != '\0'; cp++)
	    if (!isdigit(*cp))
		return NOTOK;
	int i = *cp ? atoi(val->sn_string) : 0;
	free(val->sn_string);
	val->sn_number = i;
    }
	break;

    case SN_STRING:
    {
	char buf[128];
	sprintf(buf, "%d", val->sn_number);
	val->sn_string = strdup(buf);
    }
	break;

    default:
	return NOTOK;
    }

    replval(val);
    return OK;
}


int  SimpleNameType::setNumber (int num)
{
    SimpleNameTypeVal* val = (SimpleNameTypeVal*) getval();

    if (val->sn_type == SN_STRING) {
	free(val->sn_string);
	val->sn_type = SN_NUMBER;
    }
    val->sn_number = num;
    replval(val);
    return OK;
}


int  SimpleNameType::setString (char* str)
{
    SimpleNameTypeVal* val = (SimpleNameTypeVal*) getval();

    if (val->sn_type == SN_STRING)
        free(val->sn_string);
    else	// SN_NUMBER
	val->sn_type = SN_STRING;
    val->sn_string = strdup(str);
    replval(val);
    return OK;
}

