//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// SimpleNameType.h

// By George Pavlou, Saleem Bhatti, February 1991


#ifndef _SimpleNameType_h_
#define _SimpleNameType_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class SimpleNameType : public Attr
{
    inline void	 init ()		{ SimpleNameTypeVal* val =
					  new SimpleNameTypeVal;
					  val->sn_type = SN_STRING;
					  val->sn_string = strdup("");
					  setval(val); }
protected:
    inline PE	 _encode ()		{ return SimpleNameType_encode(
					  (SimpleNameTypeVal*) getval()); }
    inline void* _decode (PE pe)	{ return SimpleNameType_decode(pe); }
    inline void	 _free ()		{ SimpleNameType_free(
					  (SimpleNameTypeVal*) getval()); }
    inline void* _parse (char* str)	{ return SimpleNameType_parse(str); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) SimpleNameType_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return SimpleNameType_cmp(
					  (SimpleNameTypeVal*) v1,
					  (SimpleNameTypeVal*) v2); }
public:
    int		setType (int);
    int		setNumber (int);
    int		setString (char*);

    inline int	getType ()		{ return ((SimpleNameTypeVal*) getval())
					  -> sn_type; }
    inline int	getNumber ()		{ SimpleNameTypeVal* val =
					  (SimpleNameTypeVal*) getval();
					  return val->sn_type == SN_NUMBER ?
					  val->sn_number : -99; }
    inline char* getString ()		{ SimpleNameTypeVal* val =
					  (SimpleNameTypeVal*) getval();
					  return val->sn_type == SN_STRING ?
					  val->sn_string : NULLCP; }

    inline SimpleNameType (int val)	{ init(); setNumber(val); }
    inline SimpleNameType (char* val)	{ init(); setString(val); }
    inline SimpleNameType ()		{ init(); }
};


#endif
