//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// StringList.h

// By George Pavlou, February 1991


#ifndef _StringList_h_
#define _StringList_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class StringList : public Attr
{
protected:
    inline PE     _encode ()		{ return GraphicStringList_encode(
                                          (StringListVal*) getval()); }
    inline void*  _decode (PE pe)	{ return GraphicStringList_decode(pe); }

    inline void   _free ()		{  StringList_free(
                                           (StringListVal*) getval()); }
    inline void*  _parse (char* str)	{ return StringList_parse(str); }
    inline char*  _print ()		{ return attrv2str(getval(),
                                          (PRINT_FNX) StringList_print); }
    inline int    _compare (void* v1, void* v2)
                                        { return StringListVal_cmp(
                                          (StringListVal*) v1,
					  (StringListVal*) v2); }
    inline void*  _getelem (void* v)    { return (void*) StringList_getelem(
					  (StringListVal*) v); }
    inline void** _getnext (void* v)    { return (void**) StringList_getnext(
					  (StringListVal*) v); }

public:
    inline int  addval (char* val)	{ StringListVal* elem =
					  new StringListVal;
					  elem->string = strdup(val);
					  elem->next = NULL; return add(elem); }
    inline int  rmval (char* val)	{ StringListVal elem;
					  elem.string = val;
					  elem.next=NULL; return remove(&elem);}

    inline      StringList ()		{ setval(NULL); }
    inline      StringList (char* val)	{ addval(val); }

};


#endif
