/*
 * Copyright (c) 1992 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London,
 * London, England. Neither the name of the University, nor its
 * registered trademark, UCL, may be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*/
/****************************************************************/
/*
	ExecPar.cc

	Interpreter Parser module (includes Lex and Yacc)

	Note:	this software uses multiple lex and yacc parses.
		Because yacc and lex communicate via a variable
		yylval of type YYSTYPE, the yacc and lex C code
		must be compiled in the same module so that they
		can both access yylval, without it being a global
		variable (ie it is a static variable).

		This is a bit horrible! Oh for a public domain
		version of yacc++ and lex++!

	Author: J.Cowan		(j.cowan@.cs.ucl.ac.uk)
*/
/****************************************************************/

#include <stdio.h>
#if defined(__GNUG__)
#include <std.h>
#endif
#include <stdlib.h>
#ifndef	__MSDOS__
#ifdef	__GNUG__
#include <string.h>
#else
#include <strings.h>
#endif
#endif

#include "DebugMem.h"
#include "SymExec.h"

/****************************************************************/

#define	USEFLEX	1

/****************************************************************/

int	ExecLine;	/* Line number */

/****************************************************************/

#include "ExecYacc.cc"

#ifdef	USEFLEX

#include "ExecLex.cc"

#endif

/****************************************************************/
/* End of module */
/****************************************************************/

