//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// IsodeICC.h - the Internal Communications Controller for ISODE managed objects

// By George Pavlou, February 1991


#ifndef _ISODE_ICC_
#define _ISODE_ICC_


#include <unistd.h>
#ifndef _MPKT_H_
#define	_MPKT_H_
#ifndef	ICR1
#include <isode/mpkt.h>
#else
#include <isode/ll/mpkt.h>
#endif
#endif

#ifndef _GENERIC_KS_
#include "GenericKS.h"
#endif


class IsodeICC : public KS
{
    static IsodeICC*  _instance;
    int		     _port;
    int		     _nobjs;

    int		     initialisePort ();
    void	     closePort ();

public:
    static IsodeICC*  getInstance ();
    int		     getNObjects ();
    int		     registerMO (MO*, char*, RDN);
    int		     deregisterMO (MO*);
    int		     readCommEndpoint (int);
    int		     shutdown (int);

    IsodeICC ();
    ~IsodeICC();
};

inline IsodeICC*  IsodeICC::getInstance ()	{ return _instance; }
inline int  IsodeICC::getNObjects ()	{ return _nobjs; }
inline void IsodeICC::closePort ()	{ if (_port != -1) close(_port);
					  _port = -1; }
inline int IsodeICC::shutdown (int)	{ closePort(); return OK; }
inline IsodeICC::IsodeICC ()		{ _instance = this;
					  _port = -1; _nobjs = 0; }
inline IsodeICC::~IsodeICC ()		{ closePort(); _instance = NULL; }

#endif
