//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// ListIterator.h - generic linked list iterator

// By George Pavlou, February 1991


#ifndef _LIST_ITERATOR_
#define _LIST_ITERATOR_


#ifndef _GEN_LIST_
#include "GenList.h"
#endif


class ListIterator
{
    Link*  link;
    List*  list;
    Bool   last;

public:
    void	setList (List*);
    void*	getNext ();
    Bool	finished ();
    void	reset ();

    ListIterator (List*);
    ListIterator ();
};


inline void  ListIterator::setList (List* l)	{ list = l; link = NULLINK;
						  last = False; }
inline Bool  ListIterator::finished ()		{ return link ? False : True; }
inline void  ListIterator::reset ()		{ link = NULLINK; last = False;}
inline ListIterator::ListIterator (List* l)	{ setList(l); }
inline ListIterator::ListIterator ()		{ setList(NULLIST); }


#endif
