/* @(#)PrxIIMCSntx-classes.h 	 08/08/1994 - 12:28  */

/********************************************************************

  Module:   PrxIIMCSntx-classes.h


  Descr.:   Protot. for classes related to types generated by pepsy.


  Created:  Mon Aug 08, 1994


  Coded by: Attribute Compiler - Luca Deri 1993


********************************************************************/


#ifndef _PrxIIMCSntx_classes_h
#define _PrxIIMCSntx_classes_h

#ifdef __GNU__
#include <std.h>
#else ifdef __cplusplus
#include <stdlib.h>
#endif

#include "msap.h"
#include "AnyType.h"
#include "Integer.h"
#include "ObjId.h"
#include "OctetString.h"
#include "GenericAttr.h"
#include "PrxIIMCSntx-syntax.h"
#include "PrxIIMCSntx-utils.h"


/* Fluffy Isomorphic class */
class SnmpOpType:virtual public AnyType
{
public:
	SnmpOpType():AnyType(){};
};

/* Fluffy Isomorphic class */
class ObjIdent:virtual public ObjId
{
public:
	ObjIdent():ObjId(){};
};

/* Fluffy Isomorphic class */
class TransportDomain:virtual public ObjId
{
public:
	TransportDomain():ObjId(){};
};

/* Fluffy Isomorphic class */
class TransportAddress:virtual public OctetString
{
public:
	TransportAddress():OctetString(){};
};

/* (Statement GMSNameResolve) */
/* Fluffy Isomorphic class */
class AccessControlEnforcement:virtual public Integer
{
public:
	AccessControlEnforcement():Integer(){};
};

/* (Statement GMSNameResolve) */
/* Fluffy Isomorphic class */
class PollPeriod:virtual public Integer
{
public:
	PollPeriod():Integer(){};
};

/* (Statement GMSNameResolve) */
/* Fluffy Isomorphic class */
class ProtoNotImplErrorInfo:virtual public Integer
{
public:
	ProtoNotImplErrorInfo():Integer(){};
};

/* (Statement GMSNameResolve) */
/* Fluffy Isomorphic class */
class RetryLimit:virtual public Integer
{
public:
	RetryLimit():Integer(){};
};

 

/* Definition of class AccessControlInfo */

 extern "C" {
	int AccessControlInfo_print(PS, struct type_PrxIIMCSntx_AccessControlInfo*, int);
	int AccessControlInfo_compare(void*, void*); };

class AccessControlInfo : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   AccessControlInfo(struct type_PrxIIMCSntx_AccessControlInfo* = NULL);
   inline AccessControlInfo() { AccessControlInfo((struct type_PrxIIMCSntx_AccessControlInfo*) NULL); }; 
   ~AccessControlInfo();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE AccessControlInfo::_encode()
{
   return(build_AccessControlInfo((struct type_PrxIIMCSntx_AccessControlInfo*)getval()));
};

inline void* AccessControlInfo::_decode(PE pe)
{
   return((void*)parse_AccessControlInfo(pe));
};

inline char* AccessControlInfo::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)AccessControlInfo_print));
};

inline void AccessControlInfo::_free()
{
   (void)AccessControlInfo_free((struct type_PrxIIMCSntx_AccessControlInfo*)getval());
}

inline int AccessControlInfo::_compare(void* theElem, void* theCmpElem)
{
   return(AccessControlInfo_compare(theElem, theCmpElem));
};

inline int AccessControlInfo::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int AccessControlInfo::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

 

/* Definition of class SnmpSecurity */

 extern "C" {
	int SnmpSecurity_print(PS, struct type_PrxIIMCSntx_SnmpSecurity*, int);
	int SnmpSecurity_compare(void*, void*); };

class SnmpSecurity : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   SnmpSecurity(struct type_PrxIIMCSntx_SnmpSecurity* = NULL);
   inline SnmpSecurity() { SnmpSecurity((struct type_PrxIIMCSntx_SnmpSecurity*) NULL); }; 
   ~SnmpSecurity();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE SnmpSecurity::_encode()
{
   return(build_SnmpSecurity((struct type_PrxIIMCSntx_SnmpSecurity*)getval()));
};

inline void* SnmpSecurity::_decode(PE pe)
{
   return((void*)parse_SnmpSecurity(pe));
};

inline char* SnmpSecurity::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)SnmpSecurity_print));
};

inline void SnmpSecurity::_free()
{
   (void)SnmpSecurity_free((struct type_PrxIIMCSntx_SnmpSecurity*)getval());
}

inline int SnmpSecurity::_compare(void* theElem, void* theCmpElem)
{
   return(SnmpSecurity_compare(theElem, theCmpElem));
};

inline int SnmpSecurity::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int SnmpSecurity::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

 

/* Definition of class SupportedMIBs */

 extern "C" {
	int SupportedMIBs_print(PS, struct type_PrxIIMCSntx_SupportedMIBs*, int);
	int SupportedMIBs_compare(void*, void*); };

class SupportedMIBs : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   SupportedMIBs(struct type_PrxIIMCSntx_SupportedMIBs* = NULL);
   inline SupportedMIBs() { SupportedMIBs((struct type_PrxIIMCSntx_SupportedMIBs*) NULL); }; 
   ~SupportedMIBs();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE SupportedMIBs::_encode()
{
   return(build_SupportedMIBs((struct type_PrxIIMCSntx_SupportedMIBs*)getval()));
};

inline void* SupportedMIBs::_decode(PE pe)
{
   return((void*)parse_SupportedMIBs(pe));
};

inline char* SupportedMIBs::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)SupportedMIBs_print));
};

inline void SupportedMIBs::_free()
{
   (void)SupportedMIBs_free((struct type_PrxIIMCSntx_SupportedMIBs*)getval());
}

inline int SupportedMIBs::_compare(void* theElem, void* theCmpElem)
{
   return(SupportedMIBs_compare(theElem, theCmpElem));
};

inline int SupportedMIBs::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int SupportedMIBs::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

/* (Statement GMSNameResolve) */
/* Fluffy Isomorphic class */
class TimeoutInterval:virtual public Integer
{
public:
	TimeoutInterval():Integer(){};
};

 

/* Definition of class TransportAddresses */

 extern "C" {
	int TransportAddresses_print(PS, struct type_PrxIIMCSntx_TransportAddresses*, int);
	int TransportAddresses_compare(void*, void*); };

class TransportAddresses : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   TransportAddresses(struct type_PrxIIMCSntx_TransportAddresses* = NULL);
   inline TransportAddresses() { TransportAddresses((struct type_PrxIIMCSntx_TransportAddresses*) NULL); }; 
   ~TransportAddresses();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE TransportAddresses::_encode()
{
   return(build_TransportAddresses((struct type_PrxIIMCSntx_TransportAddresses*)getval()));
};

inline void* TransportAddresses::_decode(PE pe)
{
   return((void*)parse_TransportAddresses(pe));
};

inline char* TransportAddresses::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)TransportAddresses_print));
};

inline void TransportAddresses::_free()
{
   (void)TransportAddresses_free((struct type_PrxIIMCSntx_TransportAddresses*)getval());
}

inline int TransportAddresses::_compare(void* theElem, void* theCmpElem)
{
   return(TransportAddresses_compare(theElem, theCmpElem));
};

inline int TransportAddresses::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int TransportAddresses::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

 

/* Definition of class NullRDN */

 extern "C" {
	int NullRDN_print(PS, struct type_PrxIIMCSntx_NullRDN*, int);
	int NullRDN_compare(void*, void*); };

class NullRDN : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   NullRDN(struct type_PrxIIMCSntx_NullRDN* = NULL);
   inline NullRDN() { NullRDN((struct type_PrxIIMCSntx_NullRDN*) NULL); }; 
   ~NullRDN();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE NullRDN::_encode()
{
   return(build_NullRDN((struct type_PrxIIMCSntx_NullRDN*)getval()));
};

inline void* NullRDN::_decode(PE pe)
{
   return((void*)parse_NullRDN(pe));
};

inline char* NullRDN::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)NullRDN_print));
};

inline void NullRDN::_free()
{
   (void)NullRDN_free((struct type_PrxIIMCSntx_NullRDN*)getval());
}

inline int NullRDN::_compare(void* theElem, void* theCmpElem)
{
   return(NullRDN_compare(theElem, theCmpElem));
};

inline int NullRDN::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int NullRDN::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

/* Dangling Isomorphs... */


#endif /* !_PrxIIMCSntx_classes_h_ */

