//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// RealList.h

// By George Pavlou, February 1991


#ifndef _RealList_h_
#define _RealList_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class RealList : public Attr
{
protected:
    inline PE     _encode ()		{ return RealList_encode(
                                          (RealListVal*) getval()); }
    inline void*  _decode (PE pe)	{ return RealList_decode(pe); }
    inline void   _free ()		{  RealList_free(
                                           (RealListVal*) getval()); }
    inline char*  _print ()		{ return attrv2str(getval(),
                                          (PRINT_FNX) RealList_print); }
    inline int    _compare (void* v1, void* v2)
                                        { return RealListVal_cmp(
                                          (RealListVal*) v1,
					  (RealListVal*) v2); }
    inline void*  _getelem (void* v)    { return (void*) RealList_getelem(
					  (RealListVal*) v); }
    inline void** _getnext (void* v)    { return (void**) RealList_getnext(
					  (RealListVal*) v); }
public:
    inline int  addval (double val)	{ RealListVal* elem = new RealListVal;
					  elem->real = val; elem->next = NULL;
					  return add(elem); }
    inline int  rmval (double val)	{ RealListVal elem; elem.real = val;
					  elem.next=NULL; return remove(&elem);}

    inline      RealList ()		{ setval(NULL); }
    inline      RealList (double val)	{ addval(val); }
};


#endif
