//
// Copyright (c) 1994 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

#if !defined(_SnmpImageMO_h_)
#define _SnmpImageMO_h_

#include "Top.h"
#include "SnmpImageMOClassInfo.h"
#include "SnmpImageAccess.h"
#include "AnyType.h"

class SnmpImageMO : public SnmpImageAccess {

	Attr *_attrs[100];
	SnmpImageMOClassInfo * _imageInfop ;

protected :

	int	refreshSubordinate( RDN, AVA*&, int= -1 ) ;
	int	refreshSubordinates( AVA*&, int= -1 ) ;

public :

	int			initialiseClass( void ) ;

	SnmpImageMOClassInfo * 	getClassInfo( void ) ;
	static MOClassInfo* 	getMOClassInfo( void ) ;

        int                     createRR(AVA*&, void* = NULLVD, int = -1);
        int                     deleteRR(AVA*&, void* = NULLVD, Bool = False, int = -1);

    	static
    	MO *cmisCreate(RDN, MO *, MO *, int, CMISParam *,
                  CMISErrors *, CMISErrorInfo *, OID *); // CMIS

    	CMISErrors 	cmisDelete( void );
	int		set( CMISModifyOp, int, int, void*, AVA*&, Bool = False, int = -1 ) ;

    	SnmpImageMO(RDN, MO *, SnmpImageMOClassInfo*, MO * = NULL, Bool* = NULL, int = 0, CMISParam * = NULL,
         	CMISErrors * = NULL, CMISErrorInfo * = NULL, OID * = NULL );
//    	SnmpImageMO(RDN, MO *, MO * = NULL,  int = 0, CMISParam * = NULL,
//         	CMISErrors * = NULL, CMISErrorInfo * = NULL, OID * = NULL );
};


inline SnmpImageMOClassInfo * SnmpImageMO::getClassInfo() { return _imageInfop ; }

inline int SnmpImageMO::initialiseClass( void ) { return OK ; }

#endif /* !_SnmpImageMO_h_ */
