/*
 * Copyright (c) 1990 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* */


/* Saleem N. Bhatti / George Pavlou, January 1993 */

/*****************************************************************************

 These are all the specific MIB syntaxes that should be loaded with
 agent utilities and managers in tables to be passed to
 the initialiseSyntaxes() routine.

 There are three tables, for attribute, event report and all syntaxes

 *****************************************************************************/

#ifndef _Syntaxes_h_
#define _Syntaxes_h_


#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif

#if	defined(MONMET) && !defined(_MONITOR_SNTX_)
#include "MonitorSntx.h"
#endif

#if	defined(IQA) && !defined(_IQASNTX_H_)
#include "IQASntx.h"
#endif

#ifndef _ISODE_SNTX_
#include "IsodeSntx.h"
#endif

#if	defined(OIM) && !defined(_OIM_Syntax_h_)
#include "OIM-Syntax.h"
#endif


VoidFunc nameSyntaxes[] =
{
    gms_name_syntaxes,
    NULL
};


VoidFunc attrSyntaxes[] =
{
    smi_syntaxes,
#ifdef	MONMET
    monitor_attr_syntaxes,
#endif
#ifdef  IQA
    iqa_all_syntaxes,
#endif
    isode_attr_syntaxes,
#ifdef	OIM
    addOimAttributeSyntax,
#endif
    NULL
};


VoidFunc evrepSyntaxes[] =
{
    smi_syntaxes,
#ifdef	OIM
    addOimReportSyntax,
#endif
#ifdef  IQA
    iqa_evrep_syntaxes,
#endif
    NULL
};


VoidFunc allSyntaxes[] =
{
    smi_syntaxes,
#ifdef	MONMET
    monitor_syntaxes,
#endif
#ifdef  IQA
    iqa_attr_syntaxes,
#endif
    isode_syntaxes,
#ifdef	OIM
    addOimAttributeSyntax,
    addOimReportSyntax,
#endif
    NULL
};


#endif /* !_Syntaxes_h_ */
