//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// TProtocolClass.h

// By George Pavlou, February 1991


#ifndef _T_PROTOCOL_CLASS_
#define _T_PROTOCOL_CLASS_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _ISODE_SNTX_
#include "IsodeSntx.h"
#endif



class TProtocolClass : public Attr
{
protected:
    PE	  _encode ();
    void* _decode (PE);
    void  _free ();
    char* _print ();
    int	  _compare (void*, void*);

public:
    void  set (int);
    int	  set (void*);	
    TProtocolClass ();
    TProtocolClass (int);
};


// inline realisation

inline PE  TProtocolClass::_encode ()
{ return TProtocolClass_encode((type_ISODE_TProtocolClass*) getval()); }

inline void*  TProtocolClass::_decode (PE pe)
{ return TProtocolClass_decode(pe); }

inline void  TProtocolClass::_free ()
{ TProtocolClass_free((type_ISODE_TProtocolClass*) getval()); }

inline char*  TProtocolClass::_print ()
{ return attrv2str(getval(), (PRINT_FNX) TProtocolClass_print); }

inline int  TProtocolClass::_compare (void* v1, void*v2)
{ return TProtocolClass_cmp((type_ISODE_TProtocolClass*) v1,
			    (type_ISODE_TProtocolClass*) v2); }

inline void  TProtocolClass::set (int tpclass)
{ type_ISODE_TProtocolClass* val = (type_ISODE_TProtocolClass*) getval();
  val->parm = tpclass; replval(val); }

inline int  TProtocolClass::set (void* val)
{ set(*(int*) val); return OK; }

inline TProtocolClass::TProtocolClass ()
{ type_ISODE_TProtocolClass* tProtClass = new type_ISODE_TProtocolClass;
  tProtClass->parm = int_ISODE_TProtocolClass_undefined; setval(tProtClass); }

inline TProtocolClass::TProtocolClass (int myClass)
{ type_ISODE_TProtocolClass* tProtClass = new type_ISODE_TProtocolClass;
  tProtClass->parm = myClass; setval(tProtClass); }


#endif
