//
// NAME
//   scanner.inc.cc
//
// DESCRIPTION
//   for scanner MOC, via OSIMIS GDMO compiler
//   (based on ISO/IEC 10164-11 Monitor Objects MIB)
//   -- derived from Top --
//
// AUTHOR
//   Jim Reilly
//   Technical Research Centre of Finland
//   icm.group@tel.vtt.fi
//

protected:
	static int		_scannerId;
	inline static int	getNewScannerId() { return(++_scannerId); }
					// monotonically increasing Id

        int		      	set (CMISModifyOp, int, int, void*, AVA*&,
					Bool = False, int = -1);
					// redefine these inherited MO methods

public:
	int			createRR(AVA*&, void* = NULLVD, int = -1);
	int			deleteRR(AVA*&, void* = NULLVD,
						Bool = False, int = -1);

        inline int		wakeUp (char*)  { return OK; }
					// what to do if we get a wakeup

