/*
 * Copyright (c) 1993 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*/

#if !defined(_xmp_h_)
#define _xmp_h_

/************************************************************************/

#include <isode/tailor.h>
#include "msap.h"
#include "midas_xmp.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>

#define NFDS 32         /*should use the proper definition*/

/*************************************************************************/

/*     The following enumeration tags and enumeration constants are defined for use as values of the
 *     corresponding OM attributes:
 *
 *     MP_T_CMIS_Functional Units
 */


#define MP_T_FU_CANCEL_GET                              1
#define MP_T_FU_FILTER                                  2
#define MP_T_FU_MULTIPLE_OBJECT_SELECTION               4
#define MP_T_FU_EXTENDED_SERVICE                        8
#define MP_T_FU_MULTIPLE_REPLY                          16

/*
 *
 *	MP_T_Mode:
 *
 */


#define MP_T_CONFIRMED				        1
#define MP_T_NON_CONFIRMED                              2

/*
 *
 *	MP_T_Priority: 
 *
 */


#define MP_T_HIGH				        1
#define MP_T_LOW                                        2
#define MP_T_MEDIUM                                     3

/*
 *
 *	MP_E_Problem:
 *
 */


#define MP_E_BAD_ADDRESS                         1001
#define MP_E_BAD_RGUMENT                         1002
#define MP_E_BAD_CLASS                           1003
#define MP_E_BAD_CONTEXT                         1004
#define MP_E_BAD_LINKED_REPLY                    1006
#define MP_E_BAD_PROCEDURAL_USE                  1007
#define MP_E_BAD_RESULT                          1008
#define MP_E_BAD_SESSION                         1009
#define MP_E_BAD_SYNTAX                          1010
#define MP_E_BAD_TITLE                           1011
#define MP_E_BAD_VALUE                           1012 
#define MP_E_BAD_WORKSPACE                       1013
#define MP_E_BROKEN_SESSION                      1014
#define MP_E_COMMUNICATIONS_PROBLEM              1015
#define MP_E_EXCLUSIVE_ATTRIBUTE                 1016
#define MP_E_INVALID_CONNECTION_ID               1017
#define MP_E_INVALID_ATTRIBUTE_ID                1018
#define MP_E_MISCELLANEOUS                       1019
#define MP_E_MISSING_ATTRIBUTE                   1020
#define MP_E_NOT_MULTI_VALUED                    1021
#define MP_E_NOT_SUPPORTED                       1022
#define MP_E_NO_SUCH_OPERATION                   1023
#define MP_E_SESSION_TERMINATED                  1024
#define MP_E_SIZE_LIMIT_EXCEEDED                 1025
#define MP_E_TIME_LIMIT_EXCEEDED                 1026
#define MP_E_TOO_MANY_OPERATIONS                 1027
#define MP_E_TOO_MANY_SESSIONS                   1028

/*
 *
 *#define MP_T_Role:
 *
 */


#define MP_T_MANAGING			         1
#define MP_T_MONITORING                          2
#define MP_T_PERFORMING                          4
#define MP_T_REPORTING                           8

/*
 *     The typedef name MP_status is defined as:
 *     typedefOM private object MP_status;
 *     The following constants are defined:
 */


/* #define MP_ACTIVATE                              O 
 * already defined in midas_xmp.h
 */
#define MP_DEACTIVATE                            1
#define MP_QUERY_STATE                           2
#define MP_QUERY_SUPPORIED                       3

/*
 *   MP_ABSENT_OBIECT                                ((OM object)0)
 *   MP_DEFAULT_CONTEXT                              ((OM object)0)
 *   MP_DEFAULT_SESSION                              ((OM object)0)
 *   MP_SUCCESS                                      ((MP_status)0)
 *   MP_NO_WORKSPACE                                 ((MP_status)l)
 *   MP_INVALID_SESSION                              ((MP_status)2)
 *   MP_INSUFFICIENT_RESOURCES                       ((MP_status)3)
 */

/*
 *
 *     The following integer constants are defined:
 *
 */


#define MP_ACTION_CNF					      1
#define MP_ACTION_IND                                         2
#define MP_CANCEL_GET_CNF                                     3
#define MP_CANCEL_GET_IND                                     4
#define MP_CREATE_CNF                                         5
#define MP_CREATE_IND                                         6
#define MP_DELETE_CNF                                         7
#define MP_DELETE_IND					      8
#define MP_EVENT_REPORT_CNF                                   9
#define MP_EVENT_REPORT_IND                                   10
#define MP_GET_CNF                                            11
#define MP_GET_IND                                            12
#define MP_GET_NEXT_IND                                       13
#define MP_SET_CNF                                            14
#define MP_SET_IND                                            15

#define MP_COMPLETED					      1
#define MP_INCOMING                                           2
#define MP_NOTHING                                            3
#define MP_OUTSTANDING                                        4
#define MP_PARTIAL                                            5

#define MP_NO_VALID_FILE_DESCRIPTOR                           -1

/*#define MP_MAX_OUTSTANDING_OPERATIONS                   implementation-defined	*/


/*
 *     The following enumeration tags and enumeration constants are defined for use as values of the
 *     corresponding OM attributes:
 *#define MP_T_CMIS Sync:
 */






#define MP_T_BEST_EFFORT                     O
#define MP_T_ATOMIC                          1

/*
 *
 *#define MP_T_Modify Operator:
 *
 */


#define MP_T_REPLACE                         O
#define MP_T_ADD_VALUES                      1
#define MP_T_REMOVE_VALUES                   2
#define MP_T_SET_TO_DEFAULT                  3

/*
 *
 *#define MP_E_Problem:
 *
 */


#define MP_E_ACCESS_DENIED                      2001
#define MP_E_CLASS_INSTANCE_CONFLICT            2002
#define MP_E_COMPLEXITY_IMITATION               2003
#define MP_E_DUPLICATE_INVOCATION               2004
#define MP_E_DUPLICATE_MANAGED_OBJECT_INSTANCE  2005
#define MP_E_GET_LIST_ERROR                     2006
#define MP_E_INVALID_ARGUMENT_VALUE             2007
#define MP_E_INVALID_ATTRIBUTE_VALUE            2008
#define MP_E_INVALID_FILTER                     2009
#define MP_E_INVALID_OBIECT_INSTANCE            2010
#define MP_E_INVALID_OPERATION                  2011
#define MP_E_INVALID_OPERATOR                   2012
#define MP_E_INVALID_SCOPE                      2013
#define MP_E_MISSING_ATTRIBUTE_VALUE            2014
#define MP_E_MISTYPED_ARGUMENT                  2015
#define MP_E_MISTYPED_OPERATION                 2016
#define MP_E_NO_SUCH_ACTION                     2017
#define MP_E_NO_SUCH_ARGUMENT                   2018
#define MP_E_NO_SUCH_ATTRIBUTE                  2019
#define MP_E_NO_SUCH_EVENT_TYPE                 2020
#define MP_E_NO_SUCH_INVOKE_ID                  2021
#define MP_E_NO_SUCH_OBJECT_CLASS               2022
#define MP_E_NO_SUCH_OBJECT_INSTANCE            2023
#define MP_E_NO_SUCH_REFERENCE_OBJECT           2024
#define MP_E_OPERATION_CANCELLED                2025
#define MP_E_PROCESSING_FAILURE                 2026
#define MP_E_RESOURCE_LIMITATION                2027
#define MP_E_SET_LIST_ERROR                     2028
#define MP_E_SYNCHRONIZATION_NOT_SUPPORTED      2029
#define MP_E_UNRECOGNIZED_OPERATION             2030

/*
 *
 * #define MP_T_Scope:
 *
 */


#define MP_T_BASE_OBJECT                             O
#define MP_T_FIRST_LEVEL_ONLY                        1
#define MP T_WHOLE_SUBTREE                           2

/*
 *     The following enumeration tags and enumeration constants are 
 *     defined for use as values of the corresponding OM attributes
 *     MP_T_Generic- Trap:
 */

#define MP_T_AUTHENTICATION_FAILURE                  1
#define MP_T_COLD_START                              2
#define MP_T_EGP_NEIGHBOR_LOSS                       3
#define MP_T_ENTERPRISE_SPECIFIC                     4
#define MP_T_LINK_DOWN                               5
#define MP_T_LINK_UP                                 6
#define MP_T_WARM_START                              7

/*
 *   MP_E_Problem:
 *
 */


 /* #define MP_E_BAD_VALUE                            3001
  * already defined on line 72 of this file
  */
#define MP_E_GEN_ERR                              3002
#define MP_E_NO_SUCH_NAME                         3003
#define MP_E_READ_ONLY                            3004
#define MP_E_TOO_BIG                              3005


#endif /* !_xmp_h_ */
