/* util.h - various useful utility definitions */

/*
 * $Header: /a/vulcan/xtel/isode/isode-master/h/quipu/RCS/util.h,v 8.0 91/07/17 12:41:31 isode Rel $
 *
 *
 * $Log:	util.h,v $
 * Revision 8.0  91/07/17  12:41:31  isode
 * Release 7.0
 * 
 * 
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#ifndef _DIDUTIL_

#define _DIDUTIL_

#ifndef _H_UTIL			/* PP interwork */

#include <errno.h>
#include <stdio.h>              /* minus the ctype stuff */
#include <ctype.h>
#include <setjmp.h>
#include "isode/manifest.h"
#include "isode/logger.h"

#endif

#ifndef       _GENERAL_
#include "isode/general.h"
#endif

#include "isode/quipu/config.h"
/* declarations that should have been in the system files */

#ifndef FunctionPrototypes
#if defined(__STDC__) || defined(__cplusplus)
#define FunctionPrototypes
#endif
#endif

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef  FunctionPrototypes
int  ps_printf (PS, const char*, ...);
#endif

#ifndef _H_UTIL			/* PP interwork */

#ifdef  FunctionPrototypes
#ifdef	__GNUG__
extern char *strncpy (char*, const char*, int);
extern char *index (const char*, int);
extern char *rindex (const char*, int);
#elif	__cplusplus
extern char *strncpy (char*, const char*, size_t);
#ifndef AIXV3
extern char *index (const char*, char);
extern char *rindex (const char*, char);
#endif
#endif
extern char *strcat (char*, const char*);
extern char *strcpy (char*, const char*);
extern char *strdup (const char*);
/*
 * extern char *multcat ();
 * extern char *multcpy ();
 */
extern char *gets (char*);
extern long lseek (int, long, int);
#else
extern char *strcat ();
extern char *strcpy ();
extern char *strncpy ();
extern char *strdup ();
extern char *multcat ();
extern char *multcpy ();
extern char *index ();
extern char *rindex ();
extern char *gets ();
extern long lseek ();
#endif

/* some common logical values */

#ifndef TRUE
#define TRUE    1
#endif
#ifndef FALSE
#define FALSE   0
#endif
#ifndef YES
#define YES     1
#endif
#ifndef NO
#define NO      0
#endif
#ifndef OK
#define OK      0
#endif
#ifndef DONE
#define DONE    1
#endif
#ifndef NOTOK
#define NOTOK   -1
#endif
#ifndef MAYBE
#define MAYBE   1
#endif

/* stdio extensions */

#ifndef lowtoup
#define lowtoup(chr) (islower(chr)?toupper(chr):chr)
#endif
#ifndef uptolow
#define uptolow(chr) (isupper(chr)?tolower(chr):chr)
#endif
#ifndef MIN
#define MIN(a,b) (( (b) < (a) ) ? (b) : (a) )
#endif
#ifndef MAX
#define MAX(a,b) (( (b) > (a) ) ? (b) : (a) )
#endif
#ifndef	MAXINT
#define MAXINT (~(1 << ((sizeof(int) * 8) - 1)))
#endif

#define isstr(ptr) ((ptr) != 0 && *(ptr) != '\0')
#define isnull(chr) ((chr) == '\0')
#define isnumber(c) ((c) >= '0' && (c) <= '9')

/*
 * provide a timeout facility
 */

extern  jmp_buf _timeobuf;

#define quipu_timeout(val)    (setjmp(_timeobuf) ? 1 : (_timeout(val), 0))

/*
 * some common extensions
 */
#define LINESIZE 1024    /* what we are prepared to consider a line length */
#define FILNSIZE 256    /* max filename length */
#define LOTS    1024    /* a max sort of thing */
#define MAXFILENAMELEN 15	/* size of largest fine name allowed */

# define        MAXFORK 10      /* no. of times to try a fork() */

#ifndef NULLCP
#define NULLCP ((char *)0)
#define NULLVP ((char **) 0)

extern char * malloc ();
extern char * smalloc ();

#define _H_UTIL
#endif
#endif 

#ifdef	__cplusplus
}
#endif

#endif
