/* attr.h - directory service interface definition */

/*
 * $Header: /xtel/isode/isode/h/quipu/RCS/attr.h,v 9.0 1992/06/16 12:23:11 isode Rel $
 *
 *
 * $Log: attr.h,v $
 * Revision 9.0  1992/06/16  12:23:11  isode
 * Release 8.0
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#ifndef QUIPUATTR
#define QUIPUATTR

#include "isode/quipu/oid.h"
#include "isode/manifest.h"


#ifndef FunctionPrototypes
#if defined(__STDC__) || defined(__cplusplus)
#define FunctionPrototypes
#endif
#endif

#ifdef  __cplusplus
extern "C" {
#endif


#ifndef TRUE
#define FALSE 0
#define TRUE 1
#endif

	/* FIRST SECTION DEFINES STRUCTURES FOR ADDRESSING */

typedef oid_table_attr * attrType;
typedef oid_table_attr * AttributeType;

#define NULLAttrT (AttributeType) NULL
#define AttrT_alloc()
#define AttrT_cmp(x,y)	( x == y ? 0 : ( x > y ? -1 : 1 ))
#define AttrT_decode(x) 
#define AttrT_free(x) 
#define AttrT_cpy(x) x
#define grab_oid(x)  (x ? x->oa_ot.ot_oid : NULLOID)

#ifdef FunctionPrototypes
AttributeType AttrT_new(char*);
int AttrT_print (PS, AttributeType, int);
#else
AttributeType AttrT_new ();
int AttrT_print ();
#endif

#define str2AttrT(x) AttrT_new(x)

typedef struct {
	short    av_syntax;             /* Specifies the syntax of the      */
					/* attribute  that follows.         */
#if defined(__STDC__) || defined(__cplusplus)
	void *	 av_struct;
#else
	caddr_t  av_struct;
#endif
} attrVal, * AttributeValue;

#define AV_WRITE_FILE		256
#define AV_FILE			128
#define MAX_AV_SYNTAX 		100

#define NULLAttrV (AttributeValue) NULL
#define AttrV_alloc()   (AttributeValue) smalloc (sizeof (attrVal));

#ifdef FunctionPrototypes
AttributeValue AttrV_cpy (AttributeValue);
int AttrV_cmp (AttributeValue, AttributeValue);
int AttrV_decode (AttributeType, AttributeValue);
int AttrV_print (PS, AttributeValue, int);
int AttrV_free (AttributeValue);
AttributeValue str_at2AttrV (char*, AttributeType);
AttributeValue str2AttrV (char*, short);
short str2syntax (char*);
short add_attribute_syntax (char*, IFP, IFP, IFP, IFP, IFP, IFP, IFP,
                            char*, IFP, char);
short modify_av_printer (AttributeType, char*, IFP);
#else
AttributeValue AttrV_cpy();
int AttrV_cmp ();
int AttrV_decode ();
int AttrV_print ();
int AttrV_free ();
AttributeValue str_at2AttrV();
AttributeValue str2AttrV();
short str2syntax();
short add_attribute_syntax ();
short modify_av_printer ();
#endif

struct file_syntax {
	short	fs_real_syntax;
	char *  fs_name;
	char	fs_mode;
	char	fs_ref;
	AttributeValue fs_attr;
}; 
#define FS_DEFAULT 0x01 	/* default file name */
#define FS_CREATE  0x02		/* created thus remove file */
#define FS_TMP     0x04		/* DSA created tmp file */

#define EDBOUT  1
#define FILEOUT 2   /* for writing to files only */
#define READOUT 3
#define DIROUT  4   /* for dn and rdn print only */
#define	RDNOUT	5
#define	UFNOUT	6   /* user-friendly naming */

#define EDB_LINEWRAP	38	/* Wrap very long lines after 38 characters */

#define ps_print(ps,data) (void)ps_write(ps,(PElementData)data,strlen(data))


#ifdef	FunctionPrototypes
#define	IsodeFunctionPrototypes
typedef PE	(*ENCODE_FNX) (void*);
typedef void*	(*DECODE_FNX) (PE);
typedef void*	(*PARSE_FNX) (char*);
typedef int	(*PRINT_FNX) (PS, void*, int);
typedef void*	(*COPY_FNX) (void*);
typedef int	(*COMPARE_FNX) (void*, void*);
typedef void**	(*GETELEM_FNX) (void*);
typedef void**	(*GETNEXT_FNX) (void*);
typedef void	(*FREE_FNX) (void*);

typedef struct {
	char*		s_sntx;		/* String defining syntax */
	ENCODE_FNX	s_encode;	
	DECODE_FNX	s_decode;
	PARSE_FNX	s_parse;
	PRINT_FNX	s_print;
	COPY_FNX	s_copy;
	COMPARE_FNX	s_compare;
	FREE_FNX	s_free;	
	GETELEM_FNX	s_pe_print;	/* process to handle raw PE (ret char*)
					   used as getelem in OSI mgmt */
	GETNEXT_FNX	s_approx;	/* approx match routine -
					   used as getnext in OSI mgmt */
	char 		s_multiline;	/* if true print each val on new line */
} sntx_table;

sntx_table * get_syntax_table (short);
#else
typedef struct {
	char *	s_sntx;		/* String defining syntax */
	IFP	s_encode;	
	IFP	s_decode;
	IFP	s_parse;
	IFP	s_print;
	IFP	s_copy;
	IFP	s_compare;
	IFP	s_free;	
	IFP	s_pe_print;	/* process to handle raw PE */
	IFP	s_approx;	/* approx match routine -
				   used as getnext in OSI mgmt */
	char 	s_multiline;	/* if true print each value on new line */
} sntx_table;

sntx_table * get_syntax_table ();
#endif

extern char quipu_faststart;
#ifdef FunctionPrototypes
extern char * TidyString(char*);
extern char * TidyString2(char*);
#else
extern char * TidyString();
extern char * TidyString2();
#endif

#define FAST_TIDY(x) if (quipu_faststart) while (isascii(*x) && isspace (*x)) x++; else x = TidyString(x)


#ifdef  __cplusplus
}
#endif

#endif
