// TkKeybordMgr.cc - X keyboard manager realisation


#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include "TkKboardMgr.h"

static int DisplayOnWindow (Tcl_Interp*, char*, const char*);


void TkKeyboardMgr::init ()
{
    _interp = NULL;
    _winName = NULLCP;
    t = 0;
    scheduleWakeUps (10, "10");
    scheduleWakeUps (60, "60");
    startListen (STDIN_FILENO);
}


void TkKeyboardMgr::tkInit (Tcl_Interp* interp, char* winName)
{
    _interp = interp;
    _winName = winName;
}


TkKeyboardMgr::~TkKeyboardMgr ()
{
    stopListen (STDIN_FILENO);
    cancelWakeUps ("10");
    cancelWakeUps ("60");
}


int  TkKeyboardMgr::wakeUp (char* token)
{
    if (strcmp (token, "10") == 0) {
	t += 10;
	sprintf (_buf, "time %d\n", t);
	DisplayOnWindow (_interp, _winName, _buf);
    }
    else
    if (strcmp (token, "60") == 0) {
	sprintf (_buf, "%d minutes\n", (t/60) + 1);
	DisplayOnWindow (_interp, _winName, _buf);
    }

    return OK;
}


int  TkKeyboardMgr::readCommEndpoint (int)
{
    char c;
    int i = 0;

    while (c = getchar ()) {
	_buf[i++] = c;
	if (c == '\n')
	    break;
    }
    _buf[i] = '\0';
	DisplayOnWindow (_interp, _winName, _buf);

    return OK;
}


int DisplayOnWindow ( Tcl_Interp *interp, char *winname, const char *text)
{
    int code;

    code = Tcl_VarEval(interp, winname, " insert end ", "\"", text, "\"",
			(char *) NULL);
    if (code != TCL_OK) {
	puts(interp->result);
	return NOTOK;
    }

    return OK;
}
