// XKeybordMgr.cc - X keyboard manager realisation


#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include "msap.h"
#include "XKboardMgr.h"

#ifndef _XtIntrinsic_h
#undef  Boolean
#define XTFUNCPROTO     /* X manifest for ANSI C,  C++ */
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#undef  Bool            /* X uses also Bool, Boolean, True, False */
#undef  Boolean
#undef  True
#undef  False
#endif
#include <Xm/Xm.h>
#include <Xm/Text.h>


static void xmInsertText (Widget, char*);


XKeyboardMgr::XKeyboardMgr (Widget displayWidget)
{
    _displayWidget = displayWidget;
    t = 0;
    scheduleWakeUps(10, "10");
    scheduleWakeUps(60, "60");
    startListen(STDIN_FILENO);
}


XKeyboardMgr::~XKeyboardMgr ()
{
    stopListen(STDIN_FILENO);
    cancelWakeUps("10");
    cancelWakeUps("60");
}


int  XKeyboardMgr::wakeUp (char* token)
{
    if (strcmp(token, "10") == 0) {
	t += 10;
	sprintf(_buf, "time %d\n", t);
	xmInsertText(_displayWidget, _buf);
    }
    else
    if (strcmp(token, "60") == 0) {
	sprintf(_buf, "%d minutes\n", (t/60) + 1);
	xmInsertText(_displayWidget, _buf);
      }

    return OK;
}


int  XKeyboardMgr::readCommEndpoint (int)
{
    char c;
    int i = 0;

    while (c = getchar()) {
	_buf[i++] = c;
	if (c == '\n')
	    break;
    }
    _buf[i] = '\0';
    xmInsertText(_displayWidget, _buf);

    return OK;
}


static void xmInsertText (Widget displayWidget, char *text)
{
    XmTextPosition position = XmTextGetInsertionPosition(displayWidget);
    XmTextReplace (displayWidget, position, position, text);
}
