//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
/******************************************************************/
/*
	File:	cmis.h

	Notes:
		Cmis general header file

	Author:
		James Cowan (J.Cowan@uk.ac.ucl.cs)
*/
/******************************************************************/
/* defines */
/*
#define	DEBUG_CLIENT		1
#define	CLIENT_TRACE		if (cmis_trace) cmis_trace->form
*/
#define	MAX_TEMP_BUFFER		50

/******************************************************************/
/* typedefs etc */

enum	Result	{Error, Success, Notfound, Continue, Finish};

typedef	struct	Code_result
{
	int	type;
	Result	result;
};

/******************************************************************/
/* Includes */

#ifdef  __GNUG__
#include <std.h>
#elif   __cplusplus
#include <stdlib.h>
#include <strings.h>
#endif

#include <stream.h>
#include "GenString.h"
#include <msap.h>
#include "config.h"
#include "ptrlist.h"

/******************************************************************/

#ifdef	DEBUG_CLIENT

extern	ostream	*cmis_trace;

#endif

/******************************************************************/
/* C function prototypes etc */

void	init_hci(int, char **, GString);
void    cmisbrowser_exit(int level);

#ifdef	DEBUG_CLIENT

void    init_debug();

#endif

void	bell();

/******************************************************************/
/* Forward references */

class	Cmis_client;
class	Cmis_result;
class	Cmis_client_result;

/******************************************************************/
/* End of header file */
/******************************************************************/

