//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
/******************************************************************/
/*

	File:	cmisbrowser.cc

	Notes:
		A generic CMIS object browser

	Author:
		James Cowan (J.Cowan@uk.ac.ucl.cs)
*/
/******************************************************************/
/* Includes */

#include "cmis.h"
#include "Error.h"
#include "Syntaxes.h"

extern char* etcdir;	// from the msap library, initialised
			// in initialiseSyntaxes()
extern "C" {
void  start_malloc_trace (char*);
}
/******************************************************************/

main(int argc, char **argv)

{
GString	hosts_table_name;

//	start_malloc_trace ((char*) 0);

#ifdef	DEBUG_CLIENT
	init_debug();
#endif

#ifdef	DEBUG_MEMORY

	init_mem_trace();

#endif

	if (initialiseSyntaxes(NULLCP, attrSyntaxes) == NOTOK)
		error(NULLCP, "cmisbrowser: cannot initialise syntaxes");

	hosts_table_name = etcdir;
	hosts_table_name += HOST_TABLE;
	init_hci(argc, argv, hosts_table_name);

	cmisbrowser_exit(0);

} /* main */

/******************************************************************/
/* End of Program */
/******************************************************************/


