//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
/***********************************************************/
/* 
	File:	ivadisplay.h

	Notes:	Cmis Interviews attribute display class header file

	Author:
		James Cowan (J.Cowan@uk.ac.ucl.cs)
*/
/***********************************************************/
/* Attribute Display Class */
/***********************************************************/

class   Attr_Display
{
        int		_rows, _cols;
	Boolean		changed(Cmis_Object *);
	GStringPtr	*_names, *_values;

	void		save_attributes(Cmis_Object *);

	void		delete_strings(GStringPtr *array)
	{
		for (int count=0; count<_rows; count++)
			delete array[count];
	}
	void		delete_attributes()
	{
		if (_names)
		{
			delete_strings(_names);
			delete _names;
		}
		if (_values)
		{
			delete_strings(_values);
			delete _values;
		}
	}

	int		calc_max_name_lgth();
	int		calc_max_value_lgth();
	void		write_attributes(StringBrowser *);
	
public:
	Attr_Display()
	{
		_names = (GStringPtr *) 0;
		_values = (GStringPtr *) 0;
		_rows = _cols = 0;
	}
	~Attr_Display()
	{
		delete_attributes();
	}

        Boolean	display_attributes(StringBrowser *, Cmis_result *);
        void	update_attributes(StringBrowser *, Cmis_result *);

        int     get_rows()      {return (_rows);}
        int     get_cols()      {return (_cols);}
};

/***********************************************************/
/* End */
/***********************************************************/


