//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// EventMgr.h - a primitive manager that receives and prints
//	        asynchronous event reports from a remote MIB

// By George Pavlou, December 1991


#ifndef _EVENT_MGR__
#define _EVENT_MGR_

#include <unistd.h>

#ifndef _RMIB_MANAGER_
#include "RMIBManager.h"
#endif


#ifndef _RMIB_AGENT_
#include "RMIBAgent.h"
#endif


class EventMgr : public RMIBManager
{
    RMIBAgent* _agent;

public:
    int  receiveEvent (char*, char*, char*);
    int  stopReceiveEvent (char*, char*, char*);
    int  eventNotification (char*, char*, char*, char*, Attr*, RMIBAgent*);
    int  brokenAssociation (RMIBAgent*);

    EventMgr (RMIBAgent*);
};


inline EventMgr::EventMgr (RMIBAgent* agent)
{ _agent = agent; if (agent) agent->notifyBrokenAssociation(this); }

inline int EventMgr::brokenAssociation (RMIBAgent* agent)
{ _exit(NOTOK); return OK; /* not reached */ }

#endif
