#
# Copyright (c) 1995 University College London
# All rights reserved.
#
# Redistribution and use in source and binary forms are permitted
# provided that the above copyright notice and this paragraph are
# duplicated in all such forms and that any documentation,
# advertising materials, and other materials related to such
# distribution and use acknowledge that the software was developed
# by the Department of Computer Science, University College London.
# The name of the University may not be used to
# endorse or promote products derived from this software without
# specific prior written permission.
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# 

# notify.tcl

# By Thurain Tin, February 1995


#
# evproc1 -
#   An example procedure to process the event reports,
#   which prints the contents to the standard output.
#

proc evproc1 {mgrId appl host class inst type time report} {
    puts "\n************************************************************\n"
    puts "event report: $type from $appl-$host"
    puts "class: $class, instance: $inst"
    puts "event time: $time"
    puts "\n$report"
    puts "\n************************************************************\n"
}

#
# evproc2 -
#   An example procedure to process the event reports,
#   which prints the contents using a message widget.
#

proc evproc2 {mgrId appl host class inst type time report} {
    message .msg$time -width 20c -justify left -relief raised -bd 2 \
	-font -Adobe-Helvetica-Medium-R-Normal--*-180-* \
	-text "$mgrId $appl $host $class $inst $type $time $report"
    button .ok -text OK -command "destroy .msg; destroy .ok"
    pack .msg .ok
}

#
# bkproc -
#   An example procedure to process the notification of broken
#   association from a remote agent. The procedure is little more
#   than being useless here! In practice the application should
#   somehow stop using all the agent objects proxying the remote
#   agent and re-establish the management association(s) later.
#

proc bkproc {mgrId appl host} {
    puts "\n************************************************************\n"
    puts "agent $appl from $host broked the management association!!"
    puts "\n************************************************************\n"
}
