#ifndef	lint
static char *rcsid = "$Header: mindicate.c,v 1.5 94/12/23 08:07:29 mha Exp $";
#endif
/*
 * Copyright (c) 1994 Technical Researc Centre of Finland.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
/* $Id: mindicate.c,v 1.63 1994/10/10 16:25:18 mha Exp mha $*/
/* Routines to realise the M-XXX.indication primitives */

/*
 * By Matti Hallivuori, June 1994
 */
#include "xmsap.h"
#include "mindicate.h"
#include <signal.h>

/* These should be taken from xmp.h:
 * 
 *#define MP_E_NO_WORKSPACE 1    --> MP_NO_WORKSPACE 
 *#define MP_E_INVALID_SESSION 2 --> MP_INVALID_SESSION
 *#define MP_E_INSUFFICIENT_RESOURCES 3 --> MP_INSUFFICIENT_RESOURCES 
*/
#define ROS_IP_LIMIT 8 /* from isode/rosap.h */
#define MP_E_MISTYPED_OPERATION			21
#define MP_E_MISTYPED_ARGUMENT			2
extern xom_head xom_heads[NR_HEADS];
extern int IamAgent;
extern AEI gmyTitle;
MP_waiting_sessions session_list[NR_HEADS];
#define ROOT_INSTANCE_FIX(type) \
  if ((parm->type##_inst.mn_type == MN_DN) && \
      (parm->type##_inst.mn_dn == NULL)) { \
/*  Osimis things it should be  MN_LOCALDN; */ \
    parm->type##_inst.mn_type =  MN_LOCALDN; \
    parm->type##_inst.mn_dn = dn_comp_new_lc(NULLRDN); \
  }
#define BASE_CLASS(type) \
   parm->type##_class.mid_type   = MID_GLOBAL; \
   parm ->type##_class.mid_global = NULLOID;

/* Allocating space for incoming parameters */
#define ALLOCATE_ATTRIBUTES(type,Param) \
  parm->type##_nattrs = number_of_attributes(desc); \
  if (parm->type##_nattrs) { \
    if ((attr = parm->type##_attrs  =(Param *) \
        mi_malloc(parm->type##_nattrs * sizeof(Param))) == NULL) { \
      ret = NOTOK; \
      goto exit; \
    } \
    memset(attr,0,(parm->type##_nattrs * sizeof(Param))); \
  }
/* Allocate pe from life time memory */

/* LINTLIBRARY */

static PE pe_malloc(form,class,tag)
int form, class,tag;
{
  PE pe;
  pe = (PE) mi_malloc (sizeof(PElement));
  if (pe) {
    memset(pe,0,sizeof(PElement));
    pe->pe_form = form;
    pe->pe_class = class;
    pe->pe_id = tag;
  }
  return pe;
}

static PE  xnum2prim (i, id)
int i, id;
{
  int mask, sign, n;
  PElementData dp;
  PE pe;

  if ((pe = pe_malloc (PE_FORM_PRIM,PE_CLASS_UNIV, id)) == NULLPE)
        return NULLPE;

  sign = i >= 0 ? i : i ^ (-1);
  mask = 0x1ff << (((n = sizeof i) - 1) * 8 - 1);
  while (n > 1 && (sign & mask) == 0)
    mask >>= 8, n--;

  if ((pe -> pe_prim = (PElementData) om_malloc ((unsigned int) n)) == NULLPED) {
      return NULLPE;
  }
  for (dp = pe -> pe_prim + (pe -> pe_len = n); n-- > 0; i >>= 8)
    *--dp = i & 0xff;

  return pe;
}


static void unknownAtribute(char *str,OM_descriptor *desc)
{
  if ((str) && (desc)) {
    fprintf(stderr,"Unknown attribute %d in %s\n",desc->type,str);
  } else {
    fprintf(stderr, "bad call to unknownAtribute\n");
  }
}

static int doOmDelete(OM_private_object res)
{
  OM_return_code om_ret_code;
  long int oldMask;

  if (res) {
      oldMask = sigblock(sigMask);
      om_ret_code  = om_delete(res);
      sigsetmask(oldMask);
      if (om_ret_code != OM_SUCCESS) {
          fprintf(stderr,"om_delete: error %d\n",om_ret_code);
          return NOTOK;
      }
  }
  return OK;
}

static OM_descriptor *getArgument(res,delete)
OM_private_object res;
int delete;
{
  OM_descriptor *desc;
  OM_return_code om_ret_code;
  OM_value_position attrs_ret;
  OM_public_object arg;
  long int oldMask;

  if (0 == res) {
    return 0;
  }
  oldMask = sigblock(sigMask);
  om_ret_code = om_get(res,
                      ( OM_NO_EXCLUSIONS ),
                       NULL,
                       OM_FALSE,
                       OM_ALL_VALUES,
                       OM_ALL_VALUES,
                       &arg,
                       &attrs_ret);

  if (om_ret_code != OM_SUCCESS) {
     fprintf(stderr,"om_get failed: %d\n",om_ret_code);
     sigsetmask(oldMask);
     return NULL;
   }
  if (delete) {
    om_ret_code = om_delete(res);
    if (om_ret_code != OM_SUCCESS) {
       fprintf(stderr,"om_delete failed: %d\n",om_ret_code);
       sigsetmask(oldMask);
       return NULL;
     }
  }
  desc = &arg[0];
  sigsetmask(oldMask);
  return desc;
}

/* All XMP errors are received in mp_receive procedure either in status
 * or one of the two status structures. These structures are parsed in this
 * routine. Relevant error information is placed to mi structure in the 
 * place where it should be. The error code is returned with minus sign if
 * the error should lead to disconnection of the session. Agent side may
 * not disconnect their connection, because they normally have only one
 * session which is shared between all managers.
 */

/* NOTE SEE mparm.h CMISErrorInfo for further coding !! */

static char *liberr= "library error (bad";



static int parseStatus(notific,invoke_id,msd,mi, result)
MP_status  notific;
int invoke_id;
MSAPIndication * mi;
OM_descriptor * result;
{
   OM_descriptor *desc, *pdesc=0;
   int problem = 0, fatal=0;
   char str[128];

  
   /* set defaults for all cases - changed below if necessary */
   mi->mi_type = MI_ERROR;
   mi->mi_error.id = replay_invoke(invoke_id);
   if(result != NULL) {
     desc = getArgument(result,1);
     while (desc->type) {
       switch (desc->type) {
       case MP_PROBLEM: {
	 problem = desc->value.enumeration;
	 break;
       }
       case MP_PARAMETER: {
	 pdesc = desc->value.object.object;
	 break;
       }
       case OM_CLASS: {
	 break;
       }
       default: {
	 fprintf(stderr,"error type %d not yet suppordet \n",desc->type);
       }
       }
       desc++;
     }
     switch(problem) {    
     /* Service error */
     case MP_E_ACCESS_DENIED:{
       mi->mi_errtype = m_accessDenied;
       break;
     }
     case MP_E_CLASS_INSTANCE_CONFLICT: {
       mi->mi_errtype = m_classInstanceConflict;
       if (pdesc) {
	 parse_baseManagedObjectClass(pdesc, 
	 &mi->mi_error.info.ei_un.ei_un_classInstanceConflict);
       }
       break;
     }
     case MP_E_COMPLEXITY_LIMITATION: {
       mi->mi_errtype = m_complexityLimitation;
       if (pdesc) {
	 xom2complexityLimitation(pdesc,
	 &mi->mi_error.info.ei_complexityLimitation);
       }
       break;
     }
     case MP_E_DUPLICATE_MANAGED_OBJECT_INSTANCE: {
       mi->mi_errtype =  m_duplicateManagedObjectInstance;
       if (pdesc) {
	 parse_objInst(pdesc,
		       &mi->mi_error.info.ei_noSuchObjectInstance);
       }
       break;
     }
     case MP_E_GET_LIST_ERROR: {
       mi->mi_errtype =  m_getListError;
       mi->mi_getres.id =  (int) invoke_id;
       if (pdesc) {
	 parse_getListError(pdesc, &mi->mi_getres.result);
       }
       break;
     }
     case MP_E_INVALID_ARGUMENT_VALUE: {
       mi->mi_errtype =  m_invalidArgumentValue;
       if (pdesc) {
	 parse_invalidArgumentValue(pdesc,
	 &mi->mi_error.info.ei_invalidArgumentValue);
       }
       break;
     }
     case MP_E_INVALID_ATTRIBUTE_VALUE: {
       mi->mi_errtype =  m_invalidAttributeValue;
       if (pdesc) {
	 parse_attributeObj(
			    &mi->mi_error.info.ei_invalidAttributeValue,pdesc);
       }
       break;
     }
     case MP_E_INVALID_FILTER: {
       mi->mi_errtype = m_invalidFilter;
       if (pdesc) {
	 mi->mi_error.info.ei_invalidFilter = xom2Filter(pdesc);
       }
       break;
     }
     case MP_E_INVALID_OBJECT_INSTANCE: {
       mi->mi_errtype =  m_invalidObjectInstance;
       if (pdesc) {
	 parse_objInst(pdesc,
		       &mi->mi_error.info.ei_noSuchObjectInstance);
       }
       break;
     }
     case MP_E_INVALID_OPERATION: {
       mi->mi_errtype = m_invalidOperation;
       break;
     }
     case MP_E_INVALID_OPERATOR: {
       mi->mi_errtype =  m_invalidOperator;
       break;
     }
     case MP_E_INVALID_SCOPE: {
       mi->mi_errtype = m_invalidScope;
       if (pdesc) {
	 parse_scope(pdesc,&mi->mi_error.info.ei_un.ei_un_invalidScope);
       }
       break;
     }
     case MP_E_MISSING_ATTRIBUTE_VALUE: {
       mi->mi_type = MI_ERROR;
       mi->mi_error.id = replay_invoke(invoke_id);
       mi->mi_errtype =  m_missingAttributeValue;
       if (pdesc) {
	 parse_missingAttributeValue(pdesc,
	 mi->mi_error.info.ei_missingAttributeValue);
       }
       break;
     }      
     case MP_E_MISTYPED_OPERATION: {
       mi->mi_errtype = m_mistypedOperation;
       break;
     }
     case MP_E_NO_SUCH_ACTION: {
       mi->mi_errtype = m_noSuchAction;
       if (pdesc) {
	 parse_noSuchActionId(pdesc,&mi->mi_error.info.ei_noSuchAction,msd);
       }
       break;
     }
     case MP_E_NO_SUCH_ARGUMENT: {
       mi->mi_errtype =  m_noSuchArgument;
       if (pdesc) {
	 parse_noSuchArgument(pdesc,
			      &mi->mi_error.info.ei_noSuchArgument,msd);
       }
       break;
     }
     case MP_E_NO_SUCH_ATTRIBUTE: {
       mi->mi_errtype =  m_noSuchAttribute;
       if (pdesc) {
	 mi->mi_error.info.ei_noSuchAttribute = 
	   xom2attributeId(pdesc);
       }
       break;
     }
     case MP_E_NO_SUCH_EVENT_TYPE: {
       mi->mi_errtype = m_noSuchEventType;
       if (pdesc) {
	 parse_noSuchEventType(pdesc,
			       &mi->mi_error.info.ei_noSuchEventType);
	 break;
       }
     }
     case MP_E_NO_SUCH_INVOKE_ID: {
       mi->mi_errtype =  m_noSuchInvokeId;
       break;
     }
     case MP_E_NO_SUCH_OBJECT_CLASS: {
       mi->mi_errtype = m_noSuchObjectClass;
       if (pdesc) {
	 mi->mi_error.info.ei_noSuchObjectClass = 
	   xom2attributeId(pdesc);
       }
       break;
     }
     case MP_E_NO_SUCH_OBJECT_INSTANCE: {
       mi->mi_errtype = m_noSuchObjectInstance;
       if (pdesc) {
         parse_objInst(pdesc, &mi->mi_error.info.ei_noSuchObjectInstance);
       }
       break;
     }
     case MP_E_NO_SUCH_REFERENCE_OBJECT: {
       mi->mi_errtype = m_noSuchReferenceObject;
       if (pdesc) {
         parse_objInst(pdesc, &mi->mi_error.info.ei_noSuchObjectInstance);
       }
       break;
     }
     case MP_E_OPERATION_CANCELLED: {
       mi->mi_errtype = m_operationCancelled;
       break;
     }
     case MP_E_PROCESSING_FAILURE: {
       mi->mi_errtype = m_processingFailure;
       if (pdesc) {
	 parse_procFailure(pdesc, &mi->mi_error.info.ei_processingFailure);
       }
       break;
     }
     case MP_E_SET_LIST_ERROR: {
       mi->mi_errtype =  m_setListError;
       mi->mi_setres.id = replay_invoke(invoke_id);
       if (pdesc) {
	 parse_setListError(pdesc, &mi->mi_setres.result);
       }
       break;
     }
     case MP_E_SYNCHRONIZATION_NOT_SUPPORTED: {
       mi->mi_errtype =  m_syncNotSupported;
       if (pdesc) {
	 mi->mi_error.info.ei_syncNotSupported = xom2sync(pdesc);
	 break;
       }
     }
     case MP_E_SESSION_TERMINATED: {
       sprintf(str,"Session terminated");
       MI_ERROR_SET(MI_ABORT,MA_USER,MA_ABORTED,NULLEXTERN,problem,&str[0])
	 fatal = TRUE;
       break;
     }
     case MP_E_BAD_CONTEXT:{
       sprintf(str, "%s context)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_ADDRESS:{
       sprintf(str, "%s address)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_ARGUMENT:{
       sprintf(str, "%s argument)",liberr);
       fatal = FALSE; 
       MI_UREJECT_SET(MA_BADARGS,invoke_id,&str[0])
	 break;
     }
     case MP_E_BAD_CLASS:{
       sprintf(str, "%s class)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_ERROR:{
       sprintf(str, "%s error)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_LINKED_REPLY:{
       sprintf(str, "%s linked reply)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_PROCEDURAL_USE:{
       sprintf(str, "%s procedural use)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_RESULT:{
       sprintf(str, "%s result)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_SESSION:{
       sprintf(str, "%s session)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_WORKSPACE:{
       sprintf(str, "%s workspace",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_TITLE:{
       sprintf(str, "%s title)",liberr);
       MI_UREJECT_SET(MA_BADARGS,invoke_id,&str[0])
	 break;
     }
     case MP_E_MISCELLANEOUS:{
       sprintf(str, "miscellaneous library error");
       MI_ERROR_SET(MI_ABORT,MI_UREJECT,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_NOT_SUPPORTED:{
       sprintf(str, "library error (not supported)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_NO_SUCH_OPERATION:{
       sprintf(str, "library error (no such operation)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_TIME_LIMIT_EXCEEDED:{
       sprintf(str, "library error (time limit exeeded)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_TOO_MANY_OPERATIONS:{
       sprintf(str, "library error (too many operations)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_TOO_MANY_SESSIONS:{
       sprintf(str, "library error (too many sessions)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     default: {
       sprintf(str,"errortype %d not supported ", problem);
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
     }
     }
   } else {
     problem = (int) notific;     
     switch(problem) { 
     case MP_INVALID_SESSION: {
       sprintf(str, "Invalid session parameter");
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,MA_ABORTED,NULLEXTERN,problem,&str[0])
	 fatal = TRUE;
       break;
     }
     case MP_NO_WORKSPACE: {
       sprintf(str, "Workspace not open");
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,MA_ABORTED,NULLEXTERN,problem,&str[0])
	 fatal = TRUE;
       break;
     }
     case MP_INSUFFICIENT_RESOURCES: {
       sprintf(str, "Insufficient resources");
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,MA_ABORTED,NULLEXTERN,problem,&str[0])
	 fatal = TRUE;
       break;
     }
     case MP_E_SESSION_TERMINATED: {
       sprintf(str,"Session terminated");
       MI_ERROR_SET(MI_ABORT,MA_USER,MA_ABORTED,NULLEXTERN,problem,&str[0])
	 fatal = TRUE;
       break;
     }
     case MP_E_BAD_CONTEXT:{
       sprintf(str, "%s context)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_ADDRESS:{
       sprintf(str, "%s address)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_ARGUMENT:{
       sprintf(str, "%s argument)",liberr);
       fatal = FALSE;  /* was TRUE */
       MI_UREJECT_SET(MA_BADARGS,invoke_id,&str[0])
	 break;
     }
     case MP_E_BAD_CLASS:{
       sprintf(str, "%s class)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_ERROR:{
       sprintf(str, "%s error)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_LINKED_REPLY:{
       sprintf(str, "%s linked reply)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_PROCEDURAL_USE:{
       sprintf(str, "%s procedural use)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_RESULT:{
       sprintf(str, "%s result)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_SESSION:{
       sprintf(str, "%s session)",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_WORKSPACE:{
       sprintf(str, "%s workspace",liberr);
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_BAD_TITLE:{
       sprintf(str, "%s title)",liberr);
       MI_UREJECT_SET(MA_BADARGS,invoke_id,&str[0])
	 break;
     }
     case MP_E_MISCELLANEOUS:{
       sprintf(str, "miscellaneous library error");
       MI_ERROR_SET(MI_ABORT,MI_UREJECT,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_NOT_SUPPORTED:{
       sprintf(str, "library error (not supported)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_NO_SUCH_OPERATION:{
       sprintf(str, "library error (no such operation)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_TIME_LIMIT_EXCEEDED:{
       sprintf(str, "library error (time limit exeeded)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_TOO_MANY_OPERATIONS:{
       sprintf(str, "library error (too many operations)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     case MP_E_TOO_MANY_SESSIONS:{
       sprintf(str, "library error (too many sessions)");
       fatal = TRUE;
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 break;
     }
     default: {
       sprintf(str,"errortype %d not supported ", problem);
       MI_ERROR_SET(MI_ABORT,MA_LOCAL,NOTOK,NULLEXTERN,problem,&str[0])
	 fatal = FALSE;
     }
     }
   }
 if (fatal) problem = -problem;
 return problem;
 }


/* Wrapper function for messages that are not to be parsed completely. 
 * called mainly from moperation. Setting lifetimegropu to prevent error
 * message. 
 */

int parse_statusCode(notific,mi)
OM_private_object notific;
MSAPIndication * mi;
{
  setNewLifeTimeGroup(mi);
  memset(mi,0,sizeof(MSAPIndication));
  return parseStatus(notific,0,0,mi,NULL);
}


int parse_mode(context,msd,addr)
OM_private_object context;
int msd,addr;
{
  OM_descriptor *desc, *sdesc;
  int mode=0;
  long int oldMask=0;

  desc = sdesc = getArgument(context,0);
  desc++;
  while (desc->type) {
   switch(desc->type) {
   case MP_MODE: {
     mode = (MP_T_CONFIRMED == desc->value.enumeration);
     break;
   }
   case MP_RESPONDER_ADDRESS: {
     if (addr) {
       parse_peObj(desc->value.object.object,0);
     }
     break;
   }
   case MP_PRIORITY:
   case MP_ASYNCHRONOUS:
     break;
   default: fprintf(stderr,"context has atribute %d\n",desc->type);
   }
   desc++;
 }
 doOmDelete(sdesc);
 return mode;
}


int  M_WaitReqAux (msd, secs, mi, pdu)
int msd, secs;
MSAPIndication * mi;
PE *pdu;
{
  MP_status            status=0, status2=0, notific;
  OM_private_object    result;
  OM_sint              rois, flag;
  OM_sint32         invoke_id;     
  OM_descriptor        *resdesc=0;
  int                  fd,conf=0,ret=OK, n,invoke, timeout;
  long int  oldMask, problem=0;
  fd_set                 rfds;
  static MSAPIndication l_mi;

  int i=1;
  int tmp=0;
  OM_object context;
  OM_value_position total_number;
  OM_return_code om_rc;
  OM_workspace workspace;
  OM_boolean test=0;
  OM_object_identifier err = OM_STRING(OMP_O_MP_C_ERROR);
  

  if (pdu) {
   *pdu = 0; 
  }
  if ((xom_heads[msd].mi) && (0 == xom_heads[msd].new_session)) {
    memcpy(mi, xom_heads[msd].mi,sizeof(MSAPIndication));
    xom_heads[msd].mi = 0;
    return OK;
  }
  memset( mi,0, sizeof(MSAPIndication));
  if (xom_heads[msd].session == 0) {
     return NOTOK;
  }


  fd = xom_heads[msd].fd;

next:;

  timeout = (secs == OK) ? -1: 1000*secs; 

  status = mp_wait(session_list, xom_heads[msd].workspace, timeout);
  if (status != MP_SUCCESS) {
     problem = parse_statusCode(status,mi);
     fprintf(stderr,"mp_wait: error %d\n",problem);
     if (problem < 0)  {
        xom_terminate(msd,mi);     
     }
     return NOTOK;
  } else {
    if (session_list[xom_heads[msd].sesCnt].activated) {
        goto receive;
    } else {
      MI_ERROR_MS(MI_ABORT,MA_PROVIDER,NOTOK,NULLEXTERN,"");
      return NOTOK;
    }
  }

receive:
    setNewLifeTimeGroup(mi);
    i=1;
    om_rc = om_get(xom_heads[msd].context, OM_NO_EXCLUSIONS, NULL,
		   OM_TRUE, NULL, NULL, &context, &total_number);
    if (om_rc != OM_SUCCESS) 
       fprintf(stderr,"om_get: error %d\n",om_rc);
    while(context[i].type != MP_MODE) i++;
    tmp = context[i].value.integer;
    oldMask = sigblock(sigMask);
    status = mp_receive(xom_heads[msd].session,&tmp, &rois,
             &flag,&notific, &result,&invoke_id);
    sigsetmask(oldMask);
    context[i].value.integer = tmp;
    om_rc = om_put(xom_heads[msd].context, OM_REPLACE_ALL, context,
		   NULL, NULL, NULL);
    if (om_rc != OM_SUCCESS) 
       fprintf(stderr,"om_put: error %d\n",om_rc);
   

    if ((status) || (notific)) {
       problem = parseStatus(status? status:notific,invoke_id,msd,mi,NULL);
       fprintf(stderr,"mp_receive: error %d\n",problem);
       if (problem < 0) {
        xom_terminate(msd,mi);          
       } 
       return NOTOK; 
    }

    if (notific != MP_SUCCESS) {
       problem = parseStatus(notific,invoke_id,msd,mi);
       fprintf(stderr,"mp_receive: error %d \n",problem);
       return NOTOK; 
    }  

    switch (flag) {
        case MP_INCOMING: {
        resdesc = getArgument(result,1);
       
        conf = parse_mode(xom_heads[msd].context,msd,MP_CREATE_IND==rois);
        switch (rois) {
          case MP_ACTION_IND:{
            mi->mi_type = conf ? MI_ACTIONC: MI_ACTION;
            mi->mi_actioninv.id = (int) invoke_id;
            ret = action_ind(msd, resdesc, &mi->mi_actioninv.args);
            goto exit;
	   }
          case MP_CREATE_IND:{
	    mi->mi_type =  MI_CREATE;
	    mi->mi_createinv.id =  (int) invoke_id;
            ret = create_ind(msd, resdesc, &mi->mi_createinv.args);
            if ((OK==ret) && (1 == xom_heads[msd].new_session)) {
              memcpy(&l_mi,mi,sizeof(MSAPIndication));
              memset( mi,0, sizeof(MSAPIndication));
              xom_heads[msd].mi = &l_mi;
              ret = NOTOK;
	    }
            goto exit;
	  }
          case MP_DELETE_IND: {
	    mi->mi_type = MI_DELETE;
            mi->mi_deleteinv.id =  (int) invoke_id;
	    ret = delete_ind(msd, resdesc, &mi->mi_deleteinv.args);
            goto exit;
	  }
          case MP_CANCEL_GET_IND: {
	    mi->mi_type = MI_CANCEL_GET;
            mi->mi_cancelgetinv.id = (int) invoke_id;
	    ret = cancel_get_ind(msd, resdesc, &mi->mi_cancelgetinv.args);
            goto exit;
	  }
          case MP_EVENT_REPORT_IND: {
            mi->mi_type = conf ? MI_EVENT_REPC: MI_EVENT_REP;
            mi->mi_eventrepinv.id =  (int) invoke_id;
            ret = event_rep_ind(msd, resdesc, &mi->mi_eventrepinv.args);
            goto exit;
	  }
          case MP_GET_IND: {
	    mi->mi_type = MI_GET;
            mi->mi_getinv.id =  (int) invoke_id;
            ret = get_ind(msd, resdesc, &mi->mi_getinv.args);
            goto exit;
	  }
          case MP_GET_NEXT_IND:
            goto exit;
          case MP_SET_IND:{
            mi->mi_type = conf ? MI_SETC: MI_SET;
            mi->mi_setinv.id = (int) invoke_id;
	    ret = set_ind(msd,resdesc, &mi->mi_setinv.args);
            goto exit;
          } 
	}
      }
      case MP_COMPLETED: {
        invoke_id = replay_invoke(invoke_id);
        resdesc = getArgument(result,1);
	
        if (NULL == resdesc) {
          mi->mi_type = MI_EMPTY_RES;
          mi->mi_emptyres.id = (int) invoke_id;
          goto exit;
	}
        switch (rois) {

           case MP_ACTION_CNF: {
	      mi->mi_type = MI_ACTION_RES;
              mi->mi_actionres.id = (int) invoke_id;
	      ret = action_res(msd, resdesc, &mi->mi_actionres.result);
              goto exit;
	   }
           case MP_CREATE_CNF: {
             mi->mi_type = MI_CREATE_RES;
	     mi->mi_createres.id =  (int) invoke_id;
             ret =  create_res(msd, resdesc, &mi->mi_createres.result);
	     goto exit;
	   }
           case MP_DELETE_CNF: {
	    mi->mi_type = MI_DELETE_RES;
            mi->mi_deleteres.id =  (int) invoke_id;
	    ret = delete_res(msd, resdesc, &mi->mi_deleteres.result);
            goto exit;
	   }
           case MP_EVENT_REPORT_CNF: {
	      mi->mi_type = MI_EVENT_REP_RES;
              mi->mi_eventrepres.id =  (int) invoke_id;
	      ret = event_rep_res(msd, resdesc, &mi->mi_eventrepres.result);
              goto exit;
	   }
           case MP_CANCEL_GET_CNF: {
 	     mi->mi_type = MI_CANCEL_GET_RES;
             mi->mi_cancelgetinv.id = (int) invoke_id;
             ret =OK;
             goto exit;
	   }
           case MP_GET_CNF: {
             mi->mi_type = MI_GET_RES;
	     mi->mi_getres.id =  (int) invoke_id;
	     ret = get_res(msd, resdesc, &mi->mi_getres.result);
             goto exit;
	   }
           case MP_SET_CNF:{
	    mi->mi_type = MI_SET_RES;
            mi->mi_setres.id = (int) invoke_id;
	    ret = set_res(msd, resdesc, &mi->mi_setres.result);
            goto exit;
	  }
	}
        break;
      }
      case MP_NOTHING: {
        fprintf(stderr,"M_WaitReq without reason\n");
        return NOTOK;
      }
      case MP_OUTSTANDING: {
/*      No indications or confirmations to receive. Outstanding requests
        to mature */       
        goto next;
      }
      case MP_PARTIAL: {
        invoke_id = replay_invoke(invoke_id);
        resdesc = getArgument(result,1);
	
        mi->mi_type = MI_LINKED_REPLY;
        switch (rois) {
          case MP_ACTION_CNF:
          case MP_DELETE_CNF:
          case MP_CANCEL_GET_CNF:
          case MP_GET_CNF:
          case MP_SET_CNF: {
            mi->mi_linkedreplyinv.id = (int) invoke_id;
            mi->mi_linkedreplyinv.args.lr_linkid = (int) invoke_id;
            ret = parse_linkedReplyArg(msd,resdesc,
                                   &mi->mi_linkedreplyinv.args);
           goto exit;
	 }
         default: fprintf(stderr,"unknown linked reply \n");
      }
    } /* MP_T_PARTIAL */
  } /* end case */
 exit:
   if (resdesc) {
     OM_return_code om_ret_code;
     oldMask = sigblock(sigMask);
     om_ret_code  = om_delete(resdesc);
     sigsetmask(oldMask);
     if (om_ret_code != OM_SUCCESS) {
       fprintf(stderr,"om_delete: error %d\n",om_ret_code);
     }
     return (ret);
   }
}

/* This routine parses XOM scope structure to CMIS scope structure */
static int parse_scope(desc,scope)
OM_descriptor *desc;
CMISScope * scope;
{
  memset(scope,0,sizeof(CMISScope));
  desc++;
  switch (desc->type) {
    case MP_NAMED_NUMBERS: {
      switch (desc->value.enumeration) {
        case MP_T_BASE_OBJECT: {
          scope->sc_type = Sc_BaseObject;
          break;
        }
        case MP_T_FIRST_LEVEL_ONLY: {
          scope->sc_type = Sc_FirstLevel;
          break;
	}
        case MP_T_WHOLE_SUBTREE: {
          scope->sc_type = Sc_WholeSubtree;
          break;
	}
      }
      break;
    } /* named numbers */
    case MP_INDIVIDUAL_LEVELS: {
      scope->sc_type = Sc_IndividualLevel;
      scope->sc_level = desc->value.integer;
      break;
    }
    case MP_BASE_TO_NTH_LEVEL: {
      scope->sc_type = Sc_BaseToNthLevel;
      scope->sc_level = desc->value.integer;
      break;
    }
  } /* outer case */
  return OK;
}

static int parse_missingAttributeValue(desc,parm)
OM_descriptor *desc;
MIDListVal *parm;  /*NOTE was MISMissingAttrValue */
{
  MIDListVal *mit=0, *pmit, *nmit;
  MID attr;
  int ret=OK;
  desc++;

  parm = nmit = (MIDListVal *) mi_malloc(sizeof(MIDListVal));
  while(desc->type) {
    switch (desc->type) {
      case MP_SET_OF_ATTRIBUTE_ID: {
        pmit = mit;
        mit =nmit;
        nmit = (MIDListVal *) mi_malloc(sizeof(MIDListVal));
        mit->midl_mid  = xom2attributeId(desc->value.object.object); /* was(*attr)*/
        if (pmit) {        /* update  next chain */
          pmit->midl_next = mit;
	}
        break;
      }
      default: {
        unknownAtribute("missingAttributevalue",desc);
        return NOTOK;
      }
    }
    desc++;
  }
exit:
  return ret;
}

static MIDentifier xom2actionTypeId(desc)
OM_descriptor * desc;
{
  return xom2attributeId(desc->value.object.object);
}

static int parse_noSuchActionId(desc,parm,msd)
OM_descriptor * desc;
CMISNoSuchArgument * parm;
int msd;
{
  desc++;
  while(desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->nsa_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_ACTION_TYPE: {
        parm->nsa_type = xom2actionTypeId(desc);
        break;
      }
      default: {
        unknownAtribute("noSuchActionId",desc);
        return NOTOK;
      }
    }
    desc++;
  }
  return OK;

}

static int parse_noSuchArgument(desc,parm,msd)
OM_descriptor * desc;
CMISNoSuchArgument * parm;
int msd;
{
  desc++;
  while(desc->type) {
    switch (desc->type) {
      case MP_ACTION_ID: {
        parse_noSuchActionId(desc,parm,msd);
        break;
      }
      case MP_EVENT_ID: {
        parse_noSuchEventId(desc,parm);
        break;
      }
      default: {
        unknownAtribute("noSuchArgument",desc);
        return NOTOK;
      }
    }
    desc++;
  }
  return OK;
}


/* Routines for parsing XOM filter to CMIS filter structures */

static CMISFilterSubstrings *xom2substringObj(desc)
OM_descriptor *desc;
{
  CMISFilterSubstrings *str;
  str = (CMISFilterSubstrings *) mi_malloc(sizeof(CMISFilterSubstrings));
  memset(str,0,sizeof(CMISFilterSubstrings));
  desc++;
  while(desc->type) {
    switch (desc->type) {
      case MP_ATTRIBUTE_ID: {
        str->fi_sub_attrid = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_SUBSTRING: {
         str->fi_sub_string = xom2pe(desc);
         break;
      }
      default: {
        unknownAtribute("substringObj",desc);
        return 0;
      }
    }
    desc++;
  }
  return str;
}

static CMISFilterSubstrings *xom2substringsObj(desc)
OM_descriptor *desc;
{
  CMISFilterSubstrings *str;
  desc++;
  switch (desc->type) {
    case MP_INITIAL_SUBSTRING: {
      str = xom2substringObj(desc->value.object.object);
      str->fi_sub_type = FI_Substring_Initial;
      break;
    }
    case MP_ANY_SUBSTRING: {
      str = xom2substringObj(desc->value.object.object);
      str->fi_sub_type = FI_Substring_Any;
       break;
    }
    case MP_FINAL_SUBSTRING: {
      str = xom2substringObj(desc->value.object.object);
      str->fi_sub_type = FI_Substring_Final;
      break;
    }
    default: {
      unknownAtribute("substringsObj",desc);
      return 0;
    }
  }
  return str;
}

#define add_substring \
  if (desc[1].type) { \
   new = (CMISFilterSubstrings *) mi_malloc(sizeof(CMISFilterSubstrings));\
  if (this) { \
    this->fi_sub_next = new;\
  }  \
  memset(new,0,sizeof(CMISFilterSubstrings));\
  this = new;}


static CMISFilterItem *xom2FilterItem(desc)
OM_descriptor *desc;
{
  CMISFilterItem *item;
  CMISFilterSubstrings *this=NULL, *new;
  CMISParam *par;
  item = (CMISFilterItem *) mi_malloc (sizeof(CMISFilterItem));
  par = &(item->fi_un.fi_un_attr);
  memset(item,0,sizeof(CMISFilterItem));
  desc++;

  while (desc->type) {
    switch (desc->type) {
      case MP_EQUALITY: {
        item->fi_type = FI_Equality;
        parse_attributeObj(par,desc->value.object.object);
        break;
      }
      case MP_SUBSTRINGS: {
        new  = xom2substringsObj(desc->value.object.object);
        if (this) {
          this->fi_sub_next = new;
	} else {
          item->fi_un.fi_un_substrings = new;
	}
        this = new;
        item->fi_type = FI_Substrings ;
        break;
      }
      case MP_GREATER_OR_EQUAL: {
        item->fi_type = FI_GreaterOrEqual;
        parse_attributeObj(par,desc->value.object.object);
        break;
      }
      case MP_LESS_OR_EQUAL: {
        item->fi_type = FI_LessOrEqual;
        parse_attributeObj(par,desc->value.object.object);
        break;
      }
      case MP_PRESENT: {
        item->fi_type = FI_Present;
        par->mp_id = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_SUBSET_OF: {
        item->fi_type = FI_SubsetOf;
        parse_attributeObj(par,desc->value.object.object);
        break;
      }
      case MP_SUPERSET_OF: {
        item->fi_type = FI_SupersetOf;
        parse_attributeObj(par,desc->value.object.object);
        break;
      }
      case MP_NON_NULL_SET_INTERSECTION: {
        item->fi_type = FI_NonNullSetIntersect;
        parse_attributeObj(par,desc->value.object.object);
        break;
      }
      default: {
        unknownAtribute("filterItem",desc);
        break;
      }
    }
    desc++;
  }
  return item;
}

static int makeFilterChain(this,desc)
CMISFilter *this;
OM_descriptor *desc;
{
  CMISFilter * filter = 0;
  desc++;
  if (this->flt_filter) {
    this = this->flt_filter;
    while (desc->type) {
      if (0 == this) {
        fprintf(stderr,"error in filter chain \n");
        break;
      }
      this->flt_next = xom2Filter(desc->value.object.object);
      this = this->flt_next;
      desc++;
    }
  }
}

static CMISFilter *xom2Filter(desc)
OM_descriptor *desc;
{
  CMISFilter *this=0;
  OM_descriptor *tmp;

  desc++;
  if (desc->type) {
    this = (CMISFilter *) mi_malloc (sizeof(CMISFilter));
    memset(this,0,sizeof(CMISFilter));
    switch (desc->type) {
      case MP_ITEM:{
        this->flt_item = xom2FilterItem(desc->value.object.object);
        this->flt_type = Filter_Item;
        break;
      }
      case MP_AND: {
	tmp = &(desc ->value.object.object[1]);
	this->flt_filter = xom2Filter(tmp->value.object.object);
        this->flt_type =  Filter_And;
	makeFilterChain(this,tmp);
        break;
      }
      case MP_OR: {
	tmp = &(desc ->value.object.object[1]);
	this->flt_filter = xom2Filter(tmp->value.object.object);
        this->flt_type = Filter_Or;
	makeFilterChain(this,tmp);
        break;
      }
      case MP_NOT: {
        this->flt_filter = xom2Filter(desc->value.object.object);
        this->flt_type = Filter_Not;
        break;
      }

    } /*case */
  }
  return this;
}


static MIDentifier xom2eventTypeId(desc)
OM_descriptor   *desc;
{
   return xom2attributeId(desc->value.object.object);
}

static int parse_eventReply(desc,parm)
OM_descriptor   *desc;
CMISParam * parm;
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_EVENT_TYPE: {
        parm->mp_id = xom2eventTypeId(desc);
        break;
      }
      case MP_EVENT_REPLY_INFO: {
        parm->mp_val = xom2pe(desc);
        break;
      }
      deafult: {
        unknownAtribute("eventReply",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }       
}

static int parse_actionInfoOrReply(desc,parm)
OM_descriptor   *desc;
CMISParam * parm;
{
  while (desc->type) {
    switch (desc->type) {
      case MP_ACTION_TYPE: {
        parm->mp_id = xom2actionTypeId(desc);
        break;
      }
      case MP_ACTION_INFO_ARG:
      case MP_ACTION_REPLY_INFO: {
        parm->mp_val = xom2pe(desc);
        break;
      }
      case OM_CLASS:{
        break;
      }
       deafult: {
        unknownAtribute("actionReply",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }       
}

static int parse_actionReply(desc,parm)
OM_descriptor   *desc;
CMISParam * parm;
{
  return parse_actionInfoOrReply(desc,parm);
}

static int parse_actionInfo(desc,parm)
OM_descriptor   *desc;
CMISParam * parm;
{
  return parse_actionInfoOrReply(desc,parm);
}

static int  parse_invalidArgumentValue(desc,parm)
OM_descriptor *desc;
CMISParam * parm; /* NOTE was CMISInvalidArgumentValue */
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_ACTION_VALUE: {
        parse_actionInfo(desc->value.object.object, parm);
        break;
      }
      case MP_EVENT_VALUE: {
        parse_eventReply(desc->value.object.object,parm);
        break;
      }
      deafult: {
        unknownAtribute("invalidArgumentValue",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }       
}

static int   parse_errorInfo(desc,parm,msd)
OM_descriptor *desc;
CMISActionError * parm;
int msd;
{
  desc++;
  while (desc->type) {
    switch(desc->type) {
      case MP_ACTION_TYPE: {
        parm->ae_accessDenied = xom2actionTypeId(desc);
        break;
      }
      case MP_ACTION_ARGUMENT: {
        parse_noSuchArgument(desc->value.object.object,
               &parm->ae_noSuchArgument,msd);
        break;
      }
      case MP_ARGUMENT_VALUE: {
         parse_invalidArgumentValue(desc,&parm->ae_invalidArgumentValue);
         break;
      }
      deafult: {
        unknownAtribute("ErrorInfo",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }       
}


static int  parse_actionErrorInfo(desc,parm,msd)
OM_descriptor *desc;
CMISActionError * parm;
int msd;
{
  desc++;
  while (desc->type) {
    switch(desc->type) {
      case MP_ERROR_STATUS: {
        parm->ae_error = errStatVal(desc->value.enumeration);
        break;
      }
      case MP_ERROR_INFO: {
        parse_errorInfo(desc->value.object.object,parm,msd);
        break;
      }
      deafult: {
        unknownAtribute("actionErrorInfo",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }       
}

static int  parse_noSuchEventType(desc,parm)
OM_descriptor *desc;
CMISNoSuchArgument * parm;
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->nsa_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_EVENT_TYPE: {
        parm->nsa_type = xom2eventTypeId(desc);
        break;
      }
      deafult: {
        unknownAtribute("noSuchEventType",desc);
        break;
      }
    }
    desc++;
  }
}


static int  parse_noSuchEventId(desc,parm)
OM_descriptor *desc;
CMISNoSuchArgument * parm;
{ 
  if (desc) {
    return parse_noSuchEventType(desc,parm);
  } else {
    return 0;
  }
}

static CMISModifyOp  modVal(inval)
int inval;
{
int outval=0;
  switch (inval ) {
    case MP_T_REPLACE: {
      outval = m_replace;
      break;
    }
    case MP_T_ADD_VALUES: {
     outval = m_addValue;
     break;
    }
    case MP_T_REMOVE_VALUES: {
      outval = m_removeValue;
      break;
    }
    case MP_T_SET_TO_DEFAULT:{
      outval = m_setToDefault;
      break;
    }
    default: fprintf(stderr,"unkown modify operator %d\n",inval);
  }
  return outval;
}

static int errStatVal(inval)
int inval;
{
  int outval=0;
  switch (inval) {
    case MP_E_ACCESS_DENIED: {
      outval = m_accessDenied;
      break;
    }
    case MP_E_NO_SUCH_ATTRIBUTE: {
      outval = m_noSuchAttribute;
      break;
    }
    case MP_E_INVALID_ATTRIBUTE_VALUE: {
      outval =  m_invalidAttributeValue;
      break;
    }
    case MP_E_INVALID_OPERATION: {
      outval = m_invalidOperation;
      break;
    }
    case MP_E_INVALID_OPERATOR: {
      outval = m_invalidOperator;
      break;
    }
    case MP_E_NO_SUCH_ACTION: {
      outval = m_noSuchAction;
      break;
    }
    default: {
      fprintf(stderr,"Error status %d in errStatVal\n",inval);
    }
  }
  return outval;
}


static int xom2sync(desc)
OM_descriptor *desc;
{
  int effort;
  if (desc->value.enumeration == MP_T_ATOMIC) {
    effort = s_atomic;
  } else {
    effort = s_bestEffort;
  }
  return effort;
}

static int xom2complexityLimitation(desc,parm)
OM_descriptor *desc;
CMISComplexityLimitation * parm;
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case  MP_SYNCHRONIZATION: {
        parm->cl_sync = xom2sync(desc);
        break;
      }
      case MP_SCOPE: {
        parse_scope(desc->value.object.object,&parm->cl_scope);
        break;
      }
      case MP_FILTER: {
        parm->cl_filter = xom2Filter(desc->value.object.object);
        break;
      }
      default: {
        unknownAtribute("complexityLimitation",desc);
        break;
      }
    }
    desc++;
  }
  return OK;
}

static int  parse_specificErr(desc,parm)
OM_descriptor *desc;
CMISParam * parm;
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_ERROR_ID: {
        parm -> mp_id = *xom2mid(desc,MID_GLOBAL);
        break;
      }
      case MP_ERROR_INFO: {
        parm -> mp_val =  xom2attributeVal(desc); 
        break;
      }
      default: {
        unknownAtribute("specificErr",desc);
        break;
      }
    }
    desc++;
  }
  return OK;
}

static int parse_procFailure(desc,parm) 
OM_descriptor *desc;
CMISProcessingFailure *parm;
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->pf_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE:{
        parse_objInst(desc->value.object.object,&parm->pf_inst);
        break;
      }
      case MP_SPECIFIC_ERROR_INFO: {
        parse_specificErr(desc->value.object.object,&parm->pf_error);
        break;
      }
      default: {
        unknownAtribute("procFailure",desc);
        break;
      }
    }
    desc++;
  }
  return OK;
}

static int  parse_attributeError(parm,desc)
CMISSetAttr *parm;
OM_descriptor *desc;
{
   desc++;
   /* defaults */
   parm -> sa_modify = m_noModifyOp;
   parm -> sa_val = NULLPE;
   while (desc->type) {
     switch(desc->type) {
     case MP_ERROR_STATUS: {
        parm->sa_error = errStatVal(desc->value.enumeration);
       break;
     }
     case MP_MODIFY_OPERATOR: {
       parm->sa_modify = 
               modVal(desc->value.enumeration);
       break;   
     }
     case MP_ATTRIBUTE_ID: {
       parm ->sa_id = xom2attributeId(desc->value.object.object);
       break;
     }
     case MP_ATTRIBUTE_VALUE: {
       parm->sa_val = xom2pe(desc);
       break;
      }
      default: {
        unknownAtribute("attributeError",desc);
        break;
      }

    }
    desc++;
  }
  return OK; 
}

static int  parse_setInfoStatus(desc,parm)
OM_descriptor *desc;
CMISSetAttr * parm;
{
  int ret=OK;
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_ATTRIBUTE_ERROR: {
        ret = parse_attributeError(parm,desc->value.object.object);
        break;
      }
      case MP_ATTRIBUTE: {
        ret = parse_attributeObj(&parm->sa_ava,desc->value.object.object);
        break;
      }
      default: {
        fprintf(stderr,"unkown attribute %d in setInfoStatus\n",
                desc->type);
      }
    }
    desc++;
  }
  return ret;
}

static int parse_attributeIdError(parm,desc)
CMISGetAttr * parm;
OM_descriptor *desc;
{
  int ret=OK;
  desc++;
  while (desc->type) {
    switch (desc->type) {
    case MP_ERROR_STATUS: {
      parm ->ga_error =  errStatVal(desc->value.enumeration);
      break;
    }
    case MP_ATTRIBUTE_ID: {
      parm ->ga_id = xom2attributeId(desc->value.object.object);
      break;
    }
    case MP_ATTRIBUTE_VALUE: {
      parm->ga_val = xom2pe(desc);
      break;
    }
    default: {
      unknownAtribute("attributeIdError",desc);
      break;
    }
  }
  desc++;
  }
}

static int  parse_getInfoStatus(desc,parm)
OM_descriptor *desc;
CMISGetAttr * parm;
{
  int ret=OK;
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_ATTRIBUTE_ID_ERROR: {
        ret = parse_attributeIdError(parm,desc->value.object.object);
        break;
      }
      case MP_ATTRIBUTE: {
        ret = parse_attributeObj(&parm->ga_ava,desc->value.object.object);
        break;
      }
      default: {
        unknownAtribute("getInfoStatus",desc);
        break;
      }
    }
    desc++;
  }
  return ret;

}

static int parse_setListError(desc,parm)
OM_descriptor *desc;
CMISSetRes *parm;
{
  OM_descriptor *tmp;
  CMISSetAttr *attr;
  int ret=OK;
  desc++;
  ALLOCATE_ATTRIBUTES(sr,CMISSetAttr)

  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->sr_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE:{
        parse_objInst(desc->value.object.object,&parm->sr_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->sr_time = xom2str(desc);
        break;
      }
      case MP_SET_INFO_LIST: {
	tmp =  &(desc ->value.object.object[1]);
	while(tmp->type !=0) {
	  parse_setInfoStatus(tmp->value.object.object,parm->sr_attrs);
	  tmp++;
	}
        break;
      }
      default: {
        unknownAtribute("setListError",desc);
        break;
      }
    }
    desc++;
  }
 exit:
  return ret;
}

static int parse_getListError(desc,parm)
OM_descriptor *desc;
CMISGetRes *parm;
{
  OM_descriptor *tmp;
  CMISGetAttr *attr;
  int ret=OK;
  ALLOCATE_ATTRIBUTES(gr,CMISGetAttr)

  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->gr_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE:{
        parse_objInst(desc->value.object.object,&parm->gr_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->gr_time = xom2str(desc);
        break;
      }
      case MP_GET_INFO_LIST: {
	tmp = &(desc->value.object.object[1]);
	while(tmp->type !=0) {
	  parse_getInfoStatus(tmp->value.object.object,parm->gr_attrs);
	  tmp++;
	}
        break;
      }
      default: {
        unknownAtribute("getListError",desc);
        break;
      }
    }
    desc++;
  }
 exit:
  return ret;
}
static int parse_deleteError(desc,parm)
OM_descriptor *desc;
CMISDeleteError *parm;
{
  int ret=OK;
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->de_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE:{
        parse_objInst(desc->value.object.object,&parm->de_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->de_time = xom2str(desc);
        break;
      }
      case MP_DELETE_ERROR_INFO: {
        parm->de_error =  errStatVal(desc->value.enumeration);
        break;
      }
      default: {
        unknownAtribute("deleteError",desc);
        break;
      }
    }
    desc++;
  }
 exit:
  return ret;
}

static int parse_actionError(desc, parm, msd)
OM_descriptor *desc;
CMISActionError *parm;
int msd;
{
  int ret=OK;
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->ae_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE:{
        parse_objInst(desc->value.object.object,&parm->ae_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->ae_time = xom2str(desc);
        break;
      }
      case MP_ACTION_ERROR_INFO: {
        parse_actionErrorInfo(desc->value.object.object,parm,msd); 
        break;
      }
      default: {
        unknownAtribute("actionError",desc);
        break;
      }
    }
    desc++;
  }
 exit:
  return ret;
}

/* Responses leading to multiple reply messages are encapsulated in
 * linked reply envelopes. This routine gets rid of the envelope.
 */
static int  parse_linkedReplyArg (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISLinkedReplyArg * parm;
{
  int status;
  OM_private_object res_l;

/* CMIS_Linked_Reply_Argument contains handle to real object. Unraveling
   envelope level. Subobjects excluded to keep them private!  */
   res_l = desc[1].value.object.object;
   switch (desc[1].type) {
     case MP_GET_RESULT: {
       status = get_res(msd, res_l, &parm -> lr_getres);
       parm -> lr_type = LR_GET_RES;
       return status;
     }
     case MP_GET_LIST_ERROR: {
       parm -> lr_type = LR_GET_LISTERR;
       parse_getListError(res_l,&parm->lr_getres);
       return NOTOK;
     }
     case MP_SET_RESULT:{
       parm -> lr_type = LR_SET_RES;
       status = set_res(msd,res_l, &parm -> lr_setres);
       return status;
     }
     case MP_SET_LIST_ERROR: {
       parm -> lr_type = LR_SET_LISTERR; 
       status = parse_setListError(res_l,&parm->lr_setres);
       return status;
     }
     case MP_ACTION_RESULT: {
       parm -> lr_type = LR_ACTION_RES;
       status = action_res(msd,res_l,&parm ->lr_actionres);
       return status;
     }
     case MP_PROCESSING_FAILURE: {
       parm -> lr_type = LR_PROC_FAILURE; 
       status = parse_procFailure(res_l,&parm->lr_procfailure);
       return status;
     }
     case MP_DELETE_RESULT: {
       parm -> lr_type = LR_DELETE_RES; 
       status = delete_res(msd,res_l, &parm -> lr_deleteres);
       return status;

     }
     case MP_ACTION_ERROR: {
       parm -> lr_type = LR_ACTION_ERR;
       status = parse_actionError(res_l, &parm -> lr_actionerr,msd);
       return NOTOK;
     }
     case MP_DELETE_ERROR: {
       parm -> lr_type = LR_DELETE_ERR;
       status = parse_deleteError(res_l,&parm -> lr_deleteerr);
       return NOTOK;
      }
     default: {
       printf("Linked replay for %d not supported \n",desc[1].type);
       return NOTOK;
     }
   }
}

static int parse_baseManagedObjectClass(desc,parm)
OM_descriptor *desc;
CMISClassInstanceConflict *parm;
{
  desc++;
  while (desc->type) {
    switch(desc->type) {
      case MP_BASE_MANAGED_OBJECT_CLASS: {
        parm->cic_class =  xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_BASE_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->cic_inst);
        break;
      }
      default:{
        unknownAtribute("baseManagedObject",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }
  return OK;
}

/* local version to prevent memory leak NOTE: xmsap.c contains
 * respective freeing routine.
 */
static DN  dn_comp_new_lc (rdn)
RDN rdn;
{
DN ptr;
        ptr = (DN) mi_malloc(sizeof(dncomp));
        dn_comp_fill (ptr,rdn);
        ptr->dn_parent = NULLDN;
        return (ptr);
}


static int get_ind (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISGetArg * parm;
{
  MID  attr;
  int i,nattr,ret = OK;
  ALLOCATE_ATTRIBUTES(ga,MIDentifier)
  nattr = parm->ga_nattrs;
  if (0 ==  parm->ga_nattrs) {
    parm->ga_nattrs = GET_ALLATTRS;
  }
  desc++;
  while (desc->type) {
    switch(desc->type) {
      case MP_BASE_MANAGED_OBJECT_CLASS: {
        if (strcmp(desc->value.object.object[1].value.string.elements,
           (char *)gmyTitle->aei_ap_title->pe_un1.un_pe_prim) != 0) {
          parm->ga_class =  xom2attributeId(desc->value.object.object);
	} else {
          BASE_CLASS(ga)
	}
        break;
      }
      case MP_BASE_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->ga_inst);
        break;
      }
      case MP_ACCESS_CONTROL: {
        fprintf(stderr,"acces control not yet supported \n");
        parm->ga_access = NULL;
        break;
      }
      case  MP_SYNCHRONIZATION: {
        parm->ga_sync = xom2sync(desc);
        break;
      }
      case MP_SCOPE: {
        parse_scope(desc->value.object.object,&parm->ga_scope);
        break;
      }
      case MP_FILTER: {
        parm->ga_filter = xom2Filter(desc->value.object.object);
        break;
      }
      case MP_ATTRIBUTE_ID_LIST: {
        OM_descriptor *sdesc;
        sdesc = &desc->value.object.object[1];
        if (!sdesc->type) {
        parm->ga_nattrs = nattr = GET_NOATTRS; /* empty list - no attributes */
	}
        for (i=0;i<nattr;i++) {
          attr[0] = xom2attributeId(sdesc->value.object.object);
          attr++;
          sdesc++;
	}
        break;
      }
      default:{
        unknownAtribute("get_ind",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }
 exit:
  ROOT_INSTANCE_FIX(ga)
  return ret;
}

static int  set_ind (msd, desc,parm)
int msd;
OM_descriptor *desc;
CMISSetArg * parm;
{
  CMISSetAttr *attr;
  int i,ret = OK;
  ALLOCATE_ATTRIBUTES(sa,CMISSetAttr)

  desc++;
  while (desc->type) {
    switch(desc->type) {
      case MP_BASE_MANAGED_OBJECT_CLASS: {
        if (strcmp(desc->value.object.object[1].value.string.elements,
           (char *) gmyTitle->aei_ap_title->pe_un1.un_pe_prim) != 0) {
          parm->sa_class = xom2attributeId(desc->value.object.object);
	} else {
          BASE_CLASS(sa)
	}
        break;
      }
      case MP_BASE_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->sa_inst);
        break;
      }
      case MP_ACCESS_CONTROL: {
        fprintf(stderr,"acces control not yet supported \n");
        parm->sa_access = NULL;
        break;
      }
      case  MP_SYNCHRONIZATION: {
        parm->sa_sync = xom2sync(desc);
        break;
      }
      case MP_SCOPE: {
        parse_scope(desc->value.object.object,&parm->sa_scope);
        break;
      }
      case MP_FILTER: {
        parm->sa_filter = xom2Filter(desc->value.object.object);
        break;
      }
      case  MP_MODIFICATION_LIST: {
          OM_descriptor *sdesc, *bdesc;
	  sdesc = &(desc->value.object.object[1]);
	  while(sdesc->type) {
	    /* defaults */
	    attr -> sa_modify = m_replace;
	    attr -> sa_val = NULLPE;
	    attr -> sa_error = m_noError;
	    bdesc = &(sdesc->value.object.object[1]);
	    while (bdesc->type) {
            switch(bdesc->type) {
	      case MP_ATTRIBUTE_ID: {
                attr ->sa_id = xom2attributeId(bdesc->value.object.object);
                break;
	      }
              case MP_ATTRIBUTE_VALUE: {
                attr->sa_val = xom2pe(bdesc);
                break;
	      }
	      case MP_MODIFY_OPERATOR: {
               attr->sa_modify = 
               modVal(bdesc->value.enumeration);
               break;   
	     }
	      }
	    bdesc++;
	  }
	    sdesc++;
	    attr++;
	  }
          break;
 	}
      default:{
        unknownAtribute("set_ind",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }
 exit:
  ROOT_INSTANCE_FIX(sa)
  return ret;
  }


static int  action_ind (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISActionArg *parm;
{
  int ret=OK;
  desc++;
  while (desc->type) {
    switch(desc->type) {
      case MP_BASE_MANAGED_OBJECT_CLASS: {
        if (strcmp(desc->value.object.object[1].value.string.elements,
           (char *)gmyTitle->aei_ap_title->pe_un1.un_pe_prim) != 0) {
          parm->aa_class =  xom2attributeId(desc->value.object.object);
	} else {
          BASE_CLASS(aa)
	}
        break;
      }
      case MP_BASE_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->aa_inst);
        break;
      }
      case MP_ACCESS_CONTROL: {
        fprintf(stderr,"acces control not yet supported \n");
        parm->aa_access = NULL;
        break;
      }
      case  MP_SYNCHRONIZATION: {
        parm->aa_sync = xom2sync(desc);
        break;
      }
      case MP_SCOPE: {
        parse_scope(desc->value.object.object,&parm->aa_scope);
        break;
      }
      case MP_FILTER: {
        parm->aa_filter = xom2Filter(desc->value.object.object);
        break;
      }
      case MP_ACTION_INFO: {
        parse_actionInfo(desc->value.object.object,&parm->aa_info);
        break;
      }
      default:{
        unknownAtribute("action_ind",desc);
        ret = NOTOK;
        break;  /* out of the switch */
      }
    }
    desc++;
  }
 exit:
  ROOT_INSTANCE_FIX(aa)
  return ret;
}




  
static int  create_ind (msd,desc, parm)
int msd;
OM_descriptor *desc;
CMISCreateArg      *parm;
{
  static OID efd=0;
  static int nrEfd=0;
  int i,ret=OK;
  CMISParam *attr;
  OM_descriptor *sdesc;

/* Got anything ? */
 if (0 == desc ) {
   ret=NOTOK;
   goto exit;
 }
  ALLOCATE_ATTRIBUTES(ca,CMISParam)

  if (!efd) {
    efd = name2oid("eventForwardingDiscriminator");
  }
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->ca_class = xom2attributeId(desc->value.object.object);
        if ((IamAgent) && (oid_equal(parm->ca_class.mid_global, efd)) &&
             (nrEfd < 3)) {
           /* "new session is born" for oldstyle evsink -  depriciated code */
          nrEfd++;
          xom_heads[0].new_session = 1;
	}
        break;
      }
      case MP_CREATE_OBJECT_INSTANCE: {
        OM_descriptor *subdesc;                
        subdesc = &desc->value.object.object[1];
        parse_objInst(subdesc->value.object.object,&parm->ca_inst);
        if (subdesc->type == MP_SUPERIOR_OBJECT_INSTANCE) {
          parm->ca_inst_type = CA_SUPERIOR_INST;
	} else {
          parm->ca_inst_type = CA_OBJECT_INST;
	}
        break;
      }
      case MP_ACCESS_CONTROL: {
        fprintf(stderr,"acces control not yet supprted \n");
        break;
      }
      case MP_REFERENCE_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->ca_reference_inst);
        break;
      }
      case MP_ATTRIBUTE_LIST: {
	 sdesc = &(desc->value.object.object[1]);
	 while(sdesc->type) {
	   ret = parse_attributeObj(attr,sdesc->value.object.object);
	   attr++;
	   sdesc++;
	 }
        break;
      }
      default: {
        unknownAtribute("create_ind",desc);
        break;
      }
    }     
    desc++;
  }
 exit:
  return ret;
}


static int  delete_ind (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISDeleteArg * parm;
{
  int i,ret = OK;

  desc++;
  while (desc->type) {
    switch(desc->type) {
      case MP_BASE_MANAGED_OBJECT_CLASS: {
        if (strcmp(desc->value.object.object[1].value.string.elements,
           (char *) gmyTitle->aei_ap_title->pe_un1.un_pe_prim) != 0) {
          parm->da_class = xom2attributeId(desc->value.object.object);
	} else {
          BASE_CLASS(da)
	}
        break;
      }
      case MP_BASE_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->da_inst);
        break;
      }
      case MP_ACCESS_CONTROL: {
        fprintf(stderr,"acces control not yet supported \n");
        parm->da_access = NULL;
        break;
      }
      case  MP_SYNCHRONIZATION: {
        parm->da_sync = xom2sync(desc);
        break;
      }
      case MP_SCOPE: {
        parse_scope(desc->value.object.object,&parm->da_scope);
        break;
      }
      case MP_FILTER: {
        parm->da_filter = xom2Filter(desc->value.object.object);
        break;
      }
      default:{
        unknownAtribute("delete_ind",desc);
        break;  /* out of the switch */
      }
    }
    desc++;
  }
 exit:
  ROOT_INSTANCE_FIX(da)
  return ret;
  }

static int  event_rep_ind (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISEventReportArg    *parm;
{
  int i,ret;

/* Got anything ? */
 if (0 == desc ) {
   ret = NOTOK;
   goto exit;
 }

  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->ea_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE:{
        parse_objInst(desc->value.object.object,&parm->ea_inst);
        break;
      }
      case MP_EVENT_TIME: {
        parm->ea_time = xom2str(desc);
        break;
      }
      case MP_EVENT_TYPE: {
        parm->ea_type = xom2eventTypeId(desc);
        break;
      }
      case MP_EVENT_INFO: {
        parm->ea_info = xom2pe(desc);
        break;
      }
      default: {
        unknownAtribute("event_rep_ind",desc);
        break;
      }
    }     
    desc++;
  }
 exit:
  return ret;
}



static int  cancel_get_ind (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISCancelGetArg    *parm;
{
  int ret;

/* Got anything ? */
 if (0 == desc ) {
   ret = NOTOK;
   goto exit;
 }
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_GET_INVOKE_ID: {
        parm->cga_getinvoke = prim2num(xom2pe(desc));
        break;
      }
      default: {
        unknownAtribute("cancel_get_ind",desc);
        break;
      }
    }     
    desc++;
  }
 exit:
  return ret;
}




static int  event_rep_res (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISEventReportRes    *parm;
{
  int ret;

/* Got anything ? */
 if (0 == desc ) {
   ret = NOTOK;
   goto exit;
 }

  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->er_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE:{
        parse_objInst(desc->value.object.object,&parm->er_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->er_time = xom2str(desc);
        break;
      }
      case MP_EVENT_REPLY: {
        parse_eventReply(desc->value.object.object,&parm->er_reply);
        break;
      }
      default: {
        unknownAtribute("event_rep_res_ind",desc);
        break;
      }
    }     
    desc++;
  }
 exit:
  return ret;
}

static int berLen(str)
unsigned char * str;
{
  static int len, blen;
  len = (int) str[0];
  if ((len >= 0) && (len < 128)) {
    return len;
  } else {
    len = len & 0x7f;
    if (len == 0) {
/*    indefinite form */
      blen = 0;
      str++;
      while( (str[0]) && (str[1])) {
        str++;
        blen++;
      }
    } else {
      if (len>2) {
        fprintf(stderr,"berlen: coding error, len: %d bytes \n",len);
        return 1;
      }
      while (len-- > 0) {
           str++;
           blen = (blen << 8) | (int) str[0];
	 }
    }
  }
  if (blen > MAXMALLOC) {
    fprintf(stderr,"berlen: possible coding error, len: %d\n",blen);
  }
  return blen;
}
static PE xom2pe(desc)
OM_descriptor *desc;
/*  make presentation element from ber encoded xom_string. The elements
 *  part contains the same data as PE 
 */
{
PE pe, pe0,pe1;
OM_descriptor desc0;
int class, form, tag, len, slen, val, bitcnt=0;
unsigned char *c, *str;

  pe0 = pe1 = NULL;
  str = c = desc->value.string.elements;
  len = slen = desc->value.string.length;
  tag = desc->syntax & OM_S_SYNTAX;

/* defaults for PE */

  switch (tag) {
    case OM_S_BIT_STRING: {
      tag = PE_PRIM_BITS;
      class = PE_CLASS_UNIV;
      form = PE_FORM_PRIM;
      bitcnt = len;
      len = len/8 +1;
      break;
    }
    case OM_S_BOOLEAN: {
      pe = desc->value.boolean ? bool2prim(1) : bool2prim(0);
      goto  allocated;
    }
    case OM_S_ENUMERATION: {
      val = desc->value.enumeration;
      pe = xnum2prim(val,PE_PRIM_ENUM);
      goto  allocated;
    }
    case OM_S_INTEGER: {
      val = desc->value.integer;
      pe = xnum2prim(val,PE_PRIM_INT);
      goto  allocated;
    }
    case OM_S_ENCODING_STRING: {
      class = (int) ((str[0] >> 6) &0x3);
      form  = (str[0] >> 5) & 0x1;  
      tag = str[0] & 0x1f;   /* NOTE tags > 30 don go right */
      if (tag == 0x1f) {
         fprintf(stderr," tags > 30 not yet supported \n");
      }
      val = (int) str[1];
      str++;str++;
      len = len-2;
      if ((val > 127) || (val < 0)) {
        val = val & 0x7f;
        len = len -val; 
        str = &str[val];
      }
      slen =berLen(&c[1]);
      desc0 = *desc;
      if (form != PE_FORM_PRIM) {
        desc0.value.string.elements = str;
        desc0.value.string.length = slen;
        pe1 = (slen > 1) ? xom2pe(&desc0) : NULLPE;
      }
      break;
    }
    default: { /* object identifier, various strings */
      class = PE_CLASS_UNIV;
      form = PE_FORM_PRIM;
      break;
    }
  } /* switch */

  pe = pe_malloc(form,class,tag);
  if (!pe) {
    return NULLPE;
  }
  if (pe->pe_form == PE_FORM_PRIM) { 
    pe->pe_un1.un_pe_prim = (unsigned char *) mi_malloc(slen);
    memcpy(pe->pe_un1.un_pe_prim, str, slen);
    pe->pe_un2.un_pe_nbits = bitcnt;
  } 
  pe->pe_len = slen; 

allocated:
  /*  Update next chain */
  if (len > slen ) {
    desc0 = *desc;
    desc0.value.string.elements = &str[slen];
    desc0.value.string.length = len -slen;
    pe0 = xom2pe(&desc0);
  }

  pe->pe_next = pe0;
  if (pe->pe_form) {
    pe->pe_un1.un_pe_cons = pe1;
  }
  return pe;
}

static OID xom2oid(desc)
OM_descriptor *desc;
{
  static OID oid;
  static int len;
  static unsigned char *str;
  static unsigned int elem, tmpElems[100];
  unsigned int nrElems=2;
  if ((desc->syntax) != OM_S_OBJECT_IDENTIFIER_STRING) {
    fprintf(stderr,"Encoding error in attribute id \n");
    return NULLOID;
  }
  str = desc->value.string.elements;
  len = desc->value.string.length-1; /* first char special */
  /* buil oid to buffer - first 2 elements a special case because they
   * are encode in one byte */
  
  tmpElems[0] = (( int) str[0]) / 40;
  tmpElems[1] = (( int) str[0]) % 40;
  while(len>0) {
    str++;
    len--;  
    if ((elem = (unsigned int) str[0]) >= 128) {
    /* the element is coded with several characters by using 7 bits per char */
      elem = 0;
      while (*str & 0x80) {
        elem = elem | ((unsigned int) (*str++ & 0x7f));
        elem <<= 7;
        len--;
      }
      elem = elem | ((unsigned int) (*str & 0x7f));
    }
    tmpElems[nrElems++] = elem;
  }
  /* create OID */
  oid = (OID) mi_malloc(sizeof(OIDentifier));
  oid->oid_nelem = nrElems;
  oid->oid_elements = (unsigned int *) mi_malloc(nrElems*sizeof(int));
  memcpy(&oid->oid_elements[0],&tmpElems[0],nrElems*sizeof(int));
  return oid;
}

static MID xom2mid(attr,type)
OM_descriptor *attr;   /* list of attribute list descriptors  */
int type;
{
  MID mid;
  OID oid;
  if ((oid = xom2oid(attr)) == NULLOID) {
     return NULLMID;
  }
  mid = (MID) mi_malloc(sizeof(MIDentifier));
  mid->mid_un.mid_un_global = oid;
  mid->mid_type= type;
  return mid;
}

static RDN  xomDSRDN2dn_rdn(desc)
OM_descriptor *desc;
{
  RDN rdn, rdnx;
  OM_descriptor   *rdnDesc;
  AttributeValue av;
  rdn = NULLRDN;
  rdnDesc = desc;
  av = (AttributeValue) mi_malloc(sizeof(attrVal));
  rdnDesc++;
  while (rdnDesc->type != NULL) {
    OM_descriptor   *ava;
    PE pe;
    attrType at;
    OID oid;
    ava = rdnDesc->value.object.object;
    oid = xom2oid(&ava[1]);
    at =  oid2attr(oid); /*oid2oidInd(oid);  */
    if (!at) {
      printf("***** Warning: 0 pointer 'at' in xomDSRDN2dn_rdn()\n");
      break;
    }
    pe = xom2pe(&ava[2]);
    av->av_syntax = at->oa_syntax; 
    av->av_struct = get_syntax_table(at->oa_syntax)->s_decode(pe); /* LEAKS */
    rdnx = rdn_comp_new(at,av); /* NOTE LEAKS !! */
    free(av->av_struct);
    rdn = rdn_merge(rdn,rdnx);
    rdnDesc++;
  }
 return rdn;
}

static DN xomDSDN2mn_dn(desc)
OM_descriptor *desc;
{
  DN dn, dnx;
  OM_descriptor   *dsdnDesc;
  dn = NULLDN;
  dsdnDesc = desc;
  dsdnDesc++;
  while (dsdnDesc->type != NULL) {
    RDN rdn;
    rdn = xomDSRDN2dn_rdn(dsdnDesc->value.object.object);
    dnx = dn_comp_new_lc(rdn);
    if (dn == NULLDN) {
      dn = dnx;
    } else {
      dn_append(dn,dnx);
    }
    dsdnDesc++;
  }
 return dn;
}

static int  parse_objInst(instDesc,mn)
OM_descriptor *instDesc;
MN mn;
{
  DN dn=NULL;
  instDesc++;

  while (instDesc->type) {
    switch (instDesc->type) {
      case MP_DISTINGUISHED_NAME: {
        mn->mn_dn = xomDSDN2mn_dn(instDesc->value.object.object); 
        mn->mn_type = MN_DN;
        break;
      }
      case MP_LOCAL_DN: {
        mn->mn_dn = xomDSDN2mn_dn(instDesc->value.object.object); 
        mn->mn_type = MN_LOCALDN;
        break;
      }
      case MP_NON_SPECIFIC_FORM: {
        mn -> mn_nonspec = xom2str(instDesc);
        mn -> mn_type = MN_NONSPEC; 
        break;
      }
      default: {
        unknownAtribute("objInst",instDesc);
        mn -> mn_nonspec = strdup("");
        mn -> mn_type = MN_NONSPEC; 
        return NOTOK;
      }
    }
    instDesc++;
  }
  return OK;
}

static MIDentifier xom2attributeId(attrDesc)
OM_descriptor   *attrDesc;
{
  PE  pe;
  int p10;
  MID mid;
  MIDentifier mide;
     memset(&mide,0,sizeof(MIDentifier));     
     attrDesc++;
     switch (attrDesc->type) {
       case  MP_GLOBAL_FORM: {
          mid = xom2mid(attrDesc,MID_GLOBAL);
          break;
      } 
       case MP_LOCAL_FORM: {
         if ((pe = xom2pe(attrDesc)) == NULLPE) {
            mid= NULLMID;
            break;
         }

         if ((p10 = prim2num (pe)) == NOTOK
               && pe -> pe_errno != PE_ERR_NONE) {
             advise (NULLCP, "localForm %s%s", PEPY_ERR_BAD_INTEGER,
                      pe_error (pe -> pe_errno));
             mid = NULLMID;
             break;
         }
         mid = (MID) mi_malloc(sizeof(MIDentifier));
         mid->mid_un.mid_un_local = p10;
         mid->mid_type= MID_LOCAL;
         break;
        }
      default: {
         fprintf(stderr,"Attribute/Event name not in local/global format \n");
         mid = NULLMID;
         break;
       }
    }
  if (mid) {
    return *mid;
  } else {
    return mide;
  }
}

static PE xom2attributeVal(desc)
OM_descriptor *desc;
{
  if (OM_S_NULL == desc->syntax) {
    return NULLPE;
  }
  return xom2pe(desc);
}


static int parse_attributeObj(cmis,desc)
CMISParam *cmis;
OM_descriptor *desc;
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_ATTRIBUTE_ID: {
        cmis->mp_id = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_ATTRIBUTE_VALUE: {
        cmis->mp_val = xom2attributeVal(desc); 
        break;
      }
      default: {
        fprintf(stderr,"no good attribute %d\n",desc->type);
        return NOTOK;
      }
   }
   desc++;
  }
  return OK;
}

static int number_of_attributes(desc)
OM_descriptor *desc;
{
  OM_descriptor *cntDesc, *sdesc;
  int nrattrs=0;
  
  cntDesc = desc;
  while (cntDesc->type) {
    switch (cntDesc->type) {
      case MP_ATTRIBUTE_LIST: {
        sdesc =  &cntDesc->value.object.object[1];
	while(sdesc->type == MP_ATTRIBUTE) {
	  nrattrs++;
	  sdesc++;
	}
	break;
      }
      case MP_ATTRIBUTE_ID_LIST: {
        sdesc =  &cntDesc->value.object.object[1];
        if (sdesc->type == MP_ATTRIBUTE_ID) {
          while (sdesc->type) {
            if (sdesc->type == MP_ATTRIBUTE_ID) {
              nrattrs++;
	    }
            sdesc++;
          }
        } else {
          nrattrs++;
        }
        break;
      }
      case MP_MODIFICATION_LIST: {
        sdesc =  &cntDesc->value.object.object[1];
	while(sdesc->type == MP_MODIFICATION) {
	  nrattrs++;
	  sdesc++;
	}
	break;
      }
      case MP_GET_INFO_LIST:
      case MP_SET_OF_ATTRIBUTE_ID:
      case MP_SET_INFO_LIST: {
        nrattrs++;
        break;
      }
    }
    cntDesc++;
  }
  return nrattrs;
}

static char * xom2str(desc)
OM_descriptor *desc;
{
  char * c;
  int len;
  len = desc->value.string.length;
  c = (char *) mi_malloc(len +1);
  memcpy(c,desc->value.string.elements,len);
  c[len] = 0;
  return c;
}

static char * xom2bytes(desc,len)
OM_descriptor *desc;
int *len;
/* This routine is outside of the lifetime memory management */
{
  char * c;
  len[0] = desc->value.string.length;
  c = (char *) malloc(len[0] +1);
  memcpy(c,desc->value.string.elements,len[0]);
  return c;
}

static int parse_peObj(desc,msd)
OM_descriptor *desc;
int msd;
{
  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_N_ADDRESSES: {
        xom_heads[msd].n_addr = xom2bytes(desc,&xom_heads[msd].ln);
        break;
      }
      case MP_P_SELECTOR: {
        xom_heads[msd].p_select = strdup(xom2str(desc));
        break;
      }
      case MP_S_SELECTOR: {
        xom_heads[msd].s_select = strdup(xom2str(desc));
        break;
      }
      case MP_T_SELECTOR: {
        xom_heads[msd].t_select = strdup(xom2str(desc));
        break;
      }
      default: fprintf(stderr,"non OSI address\n");
    }
    desc++;
  }
}   

static int  get_res (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISGetRes * parm;
{
  int i, l, ret=OK, tmp2;
  OM_descriptor *tmp;
  CMISGetAttr *attr;
  
/* Got anything  */
  if (0 == desc) {
     goto empty;
   }
  ALLOCATE_ATTRIBUTES(gr,CMISGetAttr)


  while(desc->type) {
    switch(desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->gr_class =  xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->gr_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->gr_time = xom2str(desc);
        break;
      }
       case MP_ATTRIBUTE_LIST: {
	 l=1;
	 tmp = desc->value.object.object;
	 while(tmp[l].type!=0) {
	   ret = parse_attributeObj(&attr->ga_ava,tmp[l].value.object.object);
	   attr->ga_error =  (ret == OK) ? m_noError: m_noSuchAttribute;
	   attr++;
	   l++;
	 }
        break;
      }
      case OM_CLASS:{
        break;
      }
      default: {
        fprintf(stderr,"unknown attribute %d in get arg\n",desc->type);
        ret=NOTOK;
        break;
      }
    }
    desc++;
  }
 exit:
 empty:
  return ret;
}

static int  set_res (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISSetRes * parm;
{
  int i,ret=OK;
  CMISSetAttr *attr;
  OM_descriptor *sdesc;

/* Got anything ? */
 if (0 == desc) {
   goto empty;
 }
  ALLOCATE_ATTRIBUTES(sr,CMISSetAttr)

  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->sr_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->sr_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->sr_time = xom2str(desc);
        break;
      }
      case MP_ATTRIBUTE_LIST: {
	sdesc = &(desc->value.object.object[1]);
	while(sdesc->type) {
	  ret = parse_attributeObj(&attr->sa_ava,sdesc->value.object.object);
	  attr++;
	  sdesc++;
	}
        break;
      }
      default: {
        fprintf(stderr,"Unknown attribute %d in CMIS Set_res argument. \n",desc->type);
        ret=NOTOK;
        break;
      }
    }     
    desc++;
  }
 exit:
 empty:
  return ret;

}

static int  action_res (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISActionRes * parm;
{
  int ret=OK;
/* Got anything  */
  if (0 == desc) {
     goto empty;
   }
  desc++;
  while(desc->type) {
    switch(desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->ar_class =  xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->ar_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->ar_time = xom2str(desc);
        break;
      }
      case MP_ACTION_REPLY: {
        parse_actionReply(desc->value.object.object,&parm->ar_reply);
        break;
      }
      default: {
        fprintf(stderr,"unknown attribute %d in action_res\n",desc->type);
        ret=NOTOK;
        break;
      }
    }
    desc++;
  }
 exit:
 empty:
  return ret;
}






static int  create_res (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISCreateRes * parm;
{
  int i,ret=OK;
  CMISParam *attr;
  OM_descriptor *sdesc;

/* Got anything ? */
 if (0 == desc) {
   goto empty;
 }
  ALLOCATE_ATTRIBUTES(cr,CMISParam)

  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->cr_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->cr_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->cr_time = xom2str(desc);
        break;
      }
       case MP_ATTRIBUTE_LIST: {
	sdesc = &(desc->value.object.object[1]);
	while(sdesc->type) {
	  ret = parse_attributeObj(attr,sdesc->value.object.object);
	  attr++;
	  sdesc++;
	}
        break;
      } 

      default: {
        fprintf(stderr,"Unknown attribute %d in CMIS Create_res argument. \n",desc->type);
        ret=NOTOK;
        break;
      }
    }     
    desc++;
  }
 exit:
 empty:
  return ret;

}

static int  delete_res (msd, desc, parm)
int msd;
OM_descriptor *desc;
CMISDeleteRes * parm;
{
  int i,ret=OK;

/* Got anything ? */
 if (0 == desc) {
   goto empty;
 }

  desc++;
  while (desc->type) {
    switch (desc->type) {
      case MP_MANAGED_OBJECT_CLASS: {
        parm->dr_class = xom2attributeId(desc->value.object.object);
        break;
      }
      case MP_MANAGED_OBJECT_INSTANCE: {
        parse_objInst(desc->value.object.object,&parm->dr_inst);
        break;
      }
      case MP_CURRENT_TIME: {
        parm->dr_time = xom2str(desc);
        break;
      }
      default: {
        fprintf(stderr,"Unknown attribute %d in CMIS delete_res argument. \n",
                desc->type);
        ret = NOTOK;
        break;
      }
    }     
    desc++;
  }
 exit:
 empty:
  return ret;

}

static void  check_actual_class (obj_class)
MID  obj_class;
{
    if (obj_class->mid_type != MID_GLOBAL ||
		!oid_equal(obj_class->mid_global, ACTUALCLASS_ASN_OID))
	return;
    oid_free(obj_class->mid_global);
    obj_class->mid_global = NULLOID;
}
