#if !defined(_mindicate_)
#define _mindicate_
/*
 * Copyright (c) 1994 Technical Researc Centre of Finland.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id:  $
 *
 * By Matti Hallivuori, December 1994
 */

/* ----------- NOTE naming practices --------------------------- 
 * parse_ returns status, first parameter is OM_descriptor *, next pointer
 * to result etc. xom2 returns value, parameter is OM_descriptor *
 */
static PE pe_malloc(int,int,int);
static PE xnum2prim(int,int);
static MIDentifier xom2actionTypeId(OM_descriptor *);
static MIDentifier xom2attributeId(OM_public_object);
static PE xom2attributeVal(OM_public_object);
static MIDentifier xom2eventTypeId(OM_descriptor *);
static OM_descriptor *getArgument(OM_private_object ,int);
static PE xom2pe(OM_descriptor *);
static OID xom2oid(OM_public_object);
static MID xom2mid(OM_public_object,int);
static RDN xomDSRDN2dn_rdn(OM_descriptor *);
static DN xomDSDN2mn_dn(OM_descriptor *);
static int xom2complexityLimitation(OM_descriptor *,CMISComplexityLimitation *);
static char * xom2bytes(OM_descriptor *, int *);
static CMISFilter *xom2Filter(OM_descriptor *);
static CMISFilterItem *xom2FilterItem(OM_descriptor *);
static CMISFilterSubstrings *xom2substringObj(OM_descriptor *);
static CMISFilterSubstrings *xom2substringsObj(OM_descriptor *);
static int xom2sync(OM_descriptor *);
static char * xom2str(OM_descriptor *);

static int parse_baseManagedObjectClass(OM_descriptor *,CMISClassInstanceConflict *);
static int parse_deleteError(OM_descriptor *,CMISDeleteError *);
static int parse_getInfoStatus(OM_descriptor *,CMISGetAttr *);
static int parse_getListError(OM_descriptor *,CMISGetRes *);
static int parse_objInst(OM_descriptor *,MN);
static int parse_procFailure(OM_descriptor *,CMISProcessingFailure *);
static int parse_scope(OM_descriptor *,CMISScope * );
static int parse_setInfoStatus(OM_descriptor *, CMISSetAttr *);
static int parse_setListError(OM_descriptor *,CMISSetRes *);
static int parse_specificErr(OM_descriptor *,CMISParam *);
static int parse_actionError(OM_descriptor*,CMISActionError*,int);
static int parse_actionErrorInfo(OM_descriptor *,CMISActionError *,int);
static int parse_actionInfo(OM_descriptor *,CMISParam *);
static int parse_actionInfoOrReply(OM_descriptor *,CMISParam*);
static int parse_actionReply(OM_descriptor *,CMISParam *);
static int parse_attributeObj(CMISParam *,OM_descriptor *);
static int parse_attributeError(CMISSetAttr *,OM_descriptor *);
static int parse_attributeIdError(CMISGetAttr *,OM_descriptor *);
static int parse_errorInfo(OM_descriptor *,CMISActionError *,int);
static int parse_eventReply(OM_descriptor *,CMISParam*);
static int parse_invalidArgumentValue(OM_descriptor*,CMISInvalidArgumentValue*);
static int parse_missingAttributeValue(OM_descriptor *,MIDListVal *);
static int parse_noSuchActionId(OM_descriptor *, CMISNoSuchArgument *,int );
static int parse_noSuchArgument(OM_descriptor *,CMISNoSuchArgument *,int);
static int parse_noSuchEventId(OM_descriptor *,CMISNoSuchArgument *);
static int parse_noSuchEventType(OM_descriptor *,CMISNoSuchArgument *);
static int parse_peObj(OM_descriptor *,int);
int parse_status(MP_status,int,int,MSAPIndication *, OM_descriptor *);
int parse_statusCode(OM_private_object,MSAPIndication *);
static OM_descriptor *result2attribute_list_desc(OM_private_object,int);
static OM_descriptor *list2ava_desc(OM_descriptor *);
static int errStatVal(int);
static int makeFilterChain(CMISFilter *,OM_descriptor *);
static CMISModifyOp  modVal(int);
static int number_of_attributes(OM_descriptor *);
static int parse_attributeList(CMISGetAttr *,OM_private_object,int);
static int parse_linkedReplyArg(int,OM_private_object,  CMISLinkedReplyArg *);

/* --------- calls for upper level pdu's ------------------- */
static int action_ind (int, OM_descriptor *, CMISActionArg *);
static int  action_res (int, OM_descriptor *,CMISActionRes *);
static int cancel_get_ind (int, OM_descriptor *, CMISCancelGetArg *);
static int create_ind (int, OM_descriptor *, CMISCreateArg *);
static int create_res (int, OM_descriptor *, CMISCreateRes *);
static int delete_ind (int, OM_descriptor *, CMISDeleteArg *);
static int delete_res (int, OM_descriptor *, CMISDeleteRes *);
static int event_rep_ind (int, OM_descriptor *, CMISEventReportArg *);
static int event_rep_res (int, OM_descriptor *, CMISEventReportRes *);
static int get_ind (int, OM_descriptor *, CMISGetArg *);
static int get_res (int, OM_descriptor * ,CMISGetRes *);
static int set_ind (int, OM_descriptor *, CMISSetArg *);
static int set_res (int, OM_descriptor *, CMISSetRes *);

#endif






