/*
 * Copyright (c) 1994 Technical Researc Centre of Finland.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id:$
 *
 * By Matti Hallivuori, December 1994
 */

/* Routines to release a management association */


/* definitions for XOM */
#include <xom.h>
#include <xmp.h>
#include <xmp_cmis.h>
#include <signal.h>
OM_IMPORT(MP_CMIS_PACKAGE)
OM_IMPORT(MP_C_COMMUNICATIONS_ERROR)
OM_IMPORT(MP_C_CMIS_SERVICE_ERROR)
#include <stdio.h>
#include "msap.h"
#include "xmsap.h"
extern int getNewNumber();
extern int releaseNumber(int);
extern int IamAgent;
extern int sesCnt;
extern int NrOfSessions;
extern int mngrNr;
extern xom_head xom_heads[NR_HEADS];
#if defined(sun)
extern  MP_waiting_sessions session_list[NR_HEADS];
#endif


/* LINTLIBRARY */

int xom_terminate(msd,mi)
int msd;
MSAPIndication* mi;
{
  OM_private_object session;
  MP_status status;
  int i, limit;


  memset(mi,0,sizeof(MSAPIndication));
  if (xom_heads[msd].workspace == 0) {
     return OK;
   }

  if (xom_heads[msd].ds_rdn) {
    om_delete(xom_heads[msd].ds_rdn);
  }
  session = xom_heads[msd].session;
  xom_heads[msd].session = 0;
  xom_heads[msd].fd = 0;

  if ((session != 0) && !IamAgent) {
    status = mp_unbind(session);
    if (status != MP_SUCCESS) {
      fprintf(stderr,"mterminate problem %d in unbind\n",parse_statusCode(status,mi));
      return NOTOK;
    }
#if defined(sun)
    NrOfSessions--;
    releaseNumber(mngrNr);
    for (i=xom_heads[msd].sesCnt;i<=sesCnt;i++) {
      session_list[i] = session_list[i+1];
    }
#endif
    sesCnt--;
    limit = xom_heads[msd].sesCnt;
    for (i=0;i<NR_HEADS;i++) {
      if(xom_heads[i].sesCnt >limit) {
        xom_heads[i].sesCnt--;
      }
    }
    xom_heads[msd].sesCnt = 0;
    if (0 == sesCnt) {
      if (IamAgent) {
        status = mp_unbind(session);
      }
      mp_shutdown(xom_heads[msd].workspace);
      xom_heads[msd].workspace = 0;
    }
  }
  return OK;
}

/* Orderly termination of any management association requires that all
 * transactions are completed. If this is not the case we lie that the
 * other end refuses to disconnect the association.
 */
int  M_TerminateReq (msd, reason, info, mi)
int msd, reason;
PE info;
MSAPIndication* mi;
{
  int fd;
  fd_set    rfds;
  long int oldMask;
  struct TSAPdisconnect td;

  if (IamAgent) /*950713*/
    return OK;

  setNewLifeTimeGroup(mi);
  fd = xom_heads[msd].fd;
  FD_ZERO (&rfds);
  FD_SET (fd , &rfds);

/*  NOTE SIGNALS MUST BE BLOCKED FOR THE WHOLE DURATION */
  oldMask = sigblock(sigMask);
  if (setRfds (fd+1, rfds, 0, &td)) {
    mi->mi_type = MI_ABORT;
    mi->mi_abort.ma_source = MA_USER;
    mi->mi_abort.ma_reason = MA_NOTREL;
    mi->mi_abort.ma_notrel = NULLPE;
    (void) strncpy(mi->mi_abort.ma_data, "Peer refused to release", MA_SIZE);
    sigsetmask(oldMask);
    return NOTOK;
  }
  sigsetmask(oldMask);
  return  xom_terminate(msd,mi);
}


int  M_TerminateResp (msd, status, reason, info, mi)
int msd, status, reason;
PE info;
MSAPIndication* mi;
{
   fprintf(stderr,"*** >M_TerminateResp called <*** \n");
    return OK;
}


/* M_AbortReq - abort an association unilaterally
 */

int  M_AbortReq (msd, info, mi)
int msd;
External*  info;
MSAPIndication* mi;
{
  long int oldMask;
  int ret;
  setNewLifeTimeGroup(mi);
/*  NOTE SIGNALS MUST BE BLOCKED FOR THE WHOLE DURATION */
  oldMask = sigblock(sigMask);
  ret = xom_terminate(msd,mi);
  sigsetmask(oldMask);
  return ret;
}






