/*
 * Copyright (c) 1994 Technical Researc Centre of Finland.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */


/* tsaplisten.c - "network" listening */
/*
 * By Matti Hallivuori, December 1994
 */

#ifndef	lint
static char *rcsid = "$Header: tsaplisten.c,v 1.2 94/12/19 10:10:48 mha Exp $";
#endif


/* LINTLIBRARY */
#include "xmsap.h"
#include <errno.h>
#include <signal.h>
extern int  xmplose (struct TSAPdisconnect *,int,char *);
extern int NrOfSessions;
extern int sesCnt;
extern int gfununits;
extern char* gcontext;
extern struct PSAPaddr * gmyAddr;
extern AEI gmyTitle;
OM_IMPORT(MP_CMIS_PKG)
#define MP_E_NO_WORKSPACE 1 
#define MP_E_INVALID_SESSION 2
extern xom_head xom_heads[NR_HEADS];
extern  MP_waiting_sessions session_list[NR_HEADS];

OM_private_object       session;
MP_status               status;
static OM_workspace  workspace;
extern long int oldSigMask;
extern OM_workspace gWorkspace;

int	TNetListenXMP(addr, aei, td)
struct  PSAPaddr *addr;
AEI  aei;
struct TSAPdisconnect *td;

{
  OM_uint32 tmp;
  int status2=0;
  MP_feature *feature_list;
  OM_descriptor *new_session;
  static  MSAPIndication l_mi;
  char  *service;
  int fun, problem,try=0;
  service = aei2serv_stub(aei);
  if (!gcontext) {
    gWorkspace = mp_initialize();
    gcontext = strdup(service);
    gfununits = fun = MP_T_FU_CANCEL_GET 
        | MP_T_FU_FILTER 
        | MP_T_FU_MULTIPLE_OBJECT_SELECTION
        | MP_T_FU_MULTIPLE_REPLY;
    gmyAddr= (struct PSAPaddr *) malloc(sizeof(struct PSAPaddr)); 
    memcpy(gmyAddr,addr,sizeof(struct PSAPaddr));
    gmyTitle = (AEI) malloc(sizeof(AEInfo));
    memcpy(gmyTitle, aei, sizeof(AEInfo));
    if (aei->aei_ap_title) {
      gmyTitle->aei_ap_title = pe_cpy(aei->aei_ap_title);
    } else {
      gmyTitle->aei_ap_title = 0;
    }
  }
new_try:
  try++;

  feature_list = create_feature_list(&MP_CMIS_PKG,NULL);
  status = mp_negotiate(feature_list,gWorkspace);

  if (status != MP_SUCCESS) {
    problem = parse_statusCode(status,&l_mi);
    if ((abs(problem) == MP_E_NO_WORKSPACE ) && (try <2)) {
    gWorkspace = mp_initialize();
    goto new_try;
    }
    fprintf(stderr, "mp_negotiate error %d \n",problem);
    om_free(new_session);
    return NOTOK;
  } else {
    if (feature_list[0].response != OM_TRUE) {
      printf("mp_negotiate: didn't get the CMIS package\n");
      om_free(new_session);
      return NOTOK;
    }
  }
  new_session = create_session_obj(fun,service,aei,addr,NULLAEI,NULLPA);
  status = mp_bind(new_session ,gWorkspace,&session);
  status2 = mp_get_last_error(gWorkspace, &tmp);

  session_list[0].bound_session = session; 
  fprintf(stderr, "opening session, status %d\n",status);
  om_free(new_session);
  if (status != MP_SUCCESS) {
     xmplose (td, DR_CONGEST, "unble to bind to net");
     problem = parse_statusCode(status,&l_mi);
     fprintf(stderr, "mp_bind error %d \n",problem);
    return NOTOK;
  }
  xom_heads[0].fd = xom_filedesc(session);
  xom_heads[0].session = session;
  xom_heads[0].workspace= gWorkspace;
  xom_heads[0].context = create_private_context(0,0);
  xom_heads[0].context1 = create_private_context(0,1);
 return OK;
}
int anyMessages(rfds,msd)
/* returns 1 if there is message, 0 otherwise */
fd_set *rfds;
int msd;
{
  int problem,i;
  MP_status status;
  OM_uint32 timeout;
  static  MSAPIndication l_mi;
  timeout = 1;
  status = mp_wait(session_list, xom_heads[msd].workspace,timeout);
  if (status != MP_SUCCESS) {
    problem = parse_statusCode(status,&l_mi);
/*  if session terminated open it and try again */
    if ((MP_E_SESSION_TERMINATED == abs(problem)) || 
        (MP_E_INVALID_SESSION == abs(problem))) {
      fprintf(stderr,"TNet err %d \n",problem);
      TNetListenXMP(gmyAddr,gmyTitle,0);
    } else {
      fprintf(stderr,"mp_receive: error %d \n",problem);
      return 0;
    }
  }
  
/* Only one active session on agent side !! */
  if (session_list[0].activated) {
    FD_ZERO (rfds);
    FD_SET (xom_heads[0].fd, rfds);
    return 1;
  }
  return 0;
}

/*  */
int setRfds (nfds, cfds, secs, td)
int	nfds;
fd_set *cfds;
int	secs;
struct TSAPdisconnect *td;
{
    fd_set rfds;
    int     n, fails=0;

    sigsetmask(oldSigMask);
    for (;;) {
        rfds = *cfds;
	switch (n = xselect ( nfds+1, &rfds, NULLFD, NULLFD, secs)) {
	    case OK:{
                fails =0;
	        if (secs == NOTOK) /* just a timeout */
		    goto next;
                sigblock(sigMask);
                *cfds = rfds;
		return OK;
	    }
            case NOTOK: {
                if (secs != NOTOK) {
                  return;
		}
                if(fails++ <10) {
                   goto next;
		 }
                sigblock(sigMask);
                *cfds = rfds;
                return NOTOK;
	    }
	    default: {
                sigblock(sigMask);
                *cfds = rfds;
		return n;
	    }
	 }
next: ;
      }
}

int get_msd(session)
OM_private_object session;
{
  int msd;
  for (msd=0;msd< NR_HEADS;msd++) {
    if (xom_heads[msd].session == session) {
      return msd;
    }
  }
  return NOTOK;
}
#if defined(sun)
int TNetAccept_xmp (nfds, rfds, secs, td)

int	nfds;
fd_set *rfds;
int	secs;
struct TSAPdisconnect *td;
{

retry:        /* always take first care of q3 */
  if (anyMessages(rfds,0)) {
    return 1;
  }

/* some other communication ?? */
  setRfds(nfds, rfds, secs, td);
  if (!FD_ISSET(xom_heads[0].fd, rfds)) {
    return 0;
  }
  goto retry;
}

#else
int TNetAccept_xmp (nfds, rfds, secs, td)
int	nfds;
fd_set *rfds;
int	secs;
struct TSAPdisconnect *td;
{
  return setRfds(nfds, rfds, secs, td);
}
#endif

/* shut down xom/xmp connection */
/* Agent may have only one session and workspace.
 * Other sessions are in that case simulated for the needs of event
 * reports.
 */
int	TNetCloseXMP (msd, td)
int msd;
struct TSAPdisconnect *td;
{
  MSAPIndication  l_mi;
  if (OK == xom_terminate(msd,&l_mi)) {
    return OK;
  } else {
    xmplose (td, DR_UNKNOWN , "unbind failed");
    return NOTOK;
  }
}


















