#if !defined(_xmpgen_)
#define _xmpgen_
/*****************************************************************************

Copyright (C) 94/11/29 VTT

Module:      libmsap.a
File:        xmpgen.h
Type:        headerfile for c
Version:     1.1
Originator:  Matti Hallivuori
Description: all definable constants for libmsap

*****************************************************************************/

#ifndef	lint
static char *xmpgen_h = "@(#)xmpgen.h v1.1 94/12/0518:24:10";
#endif

/* NR_HEADS-1 is the maximum number of simultaneous sessions. For agent
   applications minimum is 2, for managers this should be the number of
   open sessions, recomended value >5
 */
#define NR_HEADS 10

/*  NR_EVENTS is the number of managers that may receive notifications from
    the agent.
 */
#define NR_EVENTS 100

/* MAXMALLOC is the size of the largest acceptable xom attribute. This value
   is checked in berlen calcuation. Recomended value >= 512 (bytes).
 */
#define MAXMALLOC 512  

/* CONNECTION_INITIALIZE_TIMEOUT is libmsap.a timeout for first get operation
   (made to see if there is agent). This timeout should not be longer than
   the timeout defined for OSI stack. The value should be as low as possible,
   but big enough to make connection possible even under load condition.
   Recomended value >30 (s) 
 */
#define CONNECTION_INITIALIZE_TIMEOUT 120

/*  MAXINVOKEMAP defines the size of invoke identifier mapping table. This 
    should be biger than the maximum number of active indications (see OSI
    stack definitions). Recomded value 128.
 */
#define MAXINVOKEMAP 128

/* _lifeSize gives the static allocation reserved for handling outgoing
   message. The memory is parcelled out with calls to om_malloc and freed
   at the end of operation as one group. The size must be somewhat greater
   than the maximum incoming message. Recomended value >= 4100 (bytes).
 */
#define _lifeSize 15000

/*  NROFLFRS gives the maximum number of incoming messages received, but not
    yet answered. The value should be at least as high as the one given in ISO
    stack definitions. Recomended value > 16.
 */
#define NROFLFRS 16 /* NOTE */

/* _lifeSize2 gives the static allocation reserved for handling incoming
   message. There may at any time be at most NROFLFRS unhandled messages.
   The size should normally be same as _lifeSize, but the value depend
   on the demands of the particular agent.
 */
#define _lifeSize2 15000

/* MAX_OID_CHAR gives the number of characters (including .) that an oid
   string presentation may have. This value is used to reserved a static 
   conversion buffer. Recomended value 256.
 */
#define MAX_OID_CHAR 256

/* MAX_OID_NUMBER gives the number of characters that can be in the 
   character representation between two successive points (eg. 1.2.345.5
   has max length 3 between two successive points). Recomended value 10.
 */
#define MAX_OID_NUMBER 10

#endif
