#if !defined(_xmsap_)
#define _xmsap_
/*
 * Copyright (c) 1994 Technical Researc Centre of Finland.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * By Matti Hallivuori, DEcember 1994
 */


#ifndef	lint
static char *rcsid_h = "$Header: xmsap.h,v 1.3 94/12/19 09:04:46 mha Exp $";
#endif


#ifdef integer
#undef integer
#endif
#include <stdio.h>
#include "xmpgen.h"
#include "msap.h"
#include <xom.h>
#include <xmp.h>
#include <xmp_cmis.h>

#define xom_filedesc(session) last_fd_in_use() /*950202*/

#if !defined(sun)
/* Needed for HP compiler/linker */
#ifndef FD_CLR
#define FD_CLR(n, p)  (p)->fds_bits[(n)/NFDBITS] &= ~(1<<((n)%NFDBITS))
#define FD_SET(n, p)  (p)->fds_bits[(n)/NFDBITS] |= (1<<((n)%NFDBITS))
#define FD_ISSET(n, p) ((p)->fds_bits[(n)/NFDBITS] & (1<<((n)%NFDBITS)))
#define FD_ZERO(p)     memset((char *)(p), (char) 0, sizeof(*(p)))
#endif
#ifndef _INCLUDE_XOPEN_SOURCE
#define _INCLUDE_XOPEN_SOURCE
#define _INCLUDE_POSIX_SOURCE
/*typedef char * caddr_t;*/
#define caddr_t char *
typedef unsigned char        u_char;
typedef unsigned short       u_short;
typedef unsigned long        u_long;
typedef unsigned int         u_int;
typedef unsigned int         space_t;
typedef long fd_mask;
# define MAXFUPLIM       2048
# define NFDBITS (sizeof(fd_mask) * 8)     /* 8 bits per byte */
# ifndef FD_SETSIZE
#    define FD_SETSIZE MAXFUPLIM
# endif
# ifndef howmany
#    define howmany(x,y)  (((x)+((y)-1))/(y))
# endif
 typedef struct fd_set {
       fd_mask fds_bits[howmany(FD_SETSIZE, NFDBITS)];
     } fd_set;
#endif  /* _INCLUDE_XOPEN_SOURCE */
#endif

#define DSCSIZE sizeof(OM_descriptor)
#define AGENTSIDE 1   
#define DELETE_STATUS 1
#define sigMask  (0x7fffffff & !sigmask(SIGTRAP))

#define LOCAL_ERROR(chr) 	mi->mi_type = MI_ABORT; \
	mi->mi_abort.ma_source = MA_LOCAL; \
	mi->mi_abort.ma_reason = 0; \
	mi->mi_abort.ma_info   = NULLEXTERN;\
	(void) strncpy(mi->mi_abort.ma_data, chr, MA_SIZE);\
        return NOTOK

#define MI_ERROR_MS(type,source,reason,info,str) \
        mi->mi_type = type;\
        mi->mi_abort.ma_source = source;\
        mi->mi_abort.ma_reason = reason;\
        mi->mi_abort.ma_info   = info;\
        if (status){ \
          strcpy(mi->mi_abort.ma_data,str); \
	}
#define MI_ERROR_SET(type,source,reason,info,problem,str) \
        mi->mi_type = type;\
        mi->mi_abort.ma_source = source;\
        mi->mi_abort.ma_reason = reason;\
        mi->mi_abort.ma_info   = info;\
        fprintf(stderr, "Error nr %d (%s)\n",problem,str);\
        if (str){ \
          strcpy(mi->mi_abort.ma_data,str); \
	}
#define MI_PREJECT_SET(reason,invoke,str) \
    mi->mi_type = MI_PREJECT; \
    mi->mi_preject.mpr_reason = reason;\
    mi->mi_preject.mpr_id = replay_invoke(invoke); \
    fprintf(stderr, "Error nr %d (%s)\n",problem,str);\
    if (str){ \
       strcpy(mi->mi_preject.mpr_data,str); \
	}
#define MI_UREJECT_SET(reason,invoke,str) \
    mi->mi_type = MI_UREJECT; \
    mi->mi_ureject.mur_reason = reason;\
    mi->mi_ureject.mur_id = replay_invoke(invoke); \
    fprintf(stderr, "Error nr %d (%s)\n",problem,str);\
    if (str){ \
       strcpy(mi->mi_ureject.mur_data,str); \
	}
#define check_descriptor(obj) \
   if ((obj == NULL) || (obj->type == NULL)) { \
      desc = NULL; \
      return desc;   }

OM_descriptor  * pa2xomAddress(struct PSAPaddr *,AEI);
void print_xmp_error(char*,MP_status,int);

typedef struct xom_ses {
     OM_private_object  session;
     OM_workspace       workspace;
     PE                 calledTitle;
     OM_object          ds_rdn;
     OM_private_object  context;
     OM_private_object  context1;
     int                fd;
     int                sesCnt;
     int                ln;
     char*              n_addr;         /* called address */
     char*              p_select;
     char*              s_select;
     char*              t_select;
     MSAPIndication*    mi;
     int                new_session;
   }xom_head;

typedef struct  xom_ev {
     char              *name;
     OM_private_object paddr;
 } xom_ev;

typedef struct invoke_map {
   int com;
   int osimis;
 } invoke_map;

/* Recoded isode/related functions */
char *aei2serv_stub(AEI);
char *aei2pre_stub(AEI);
struct PSAPaddr *aei2addr_stub (AEI);

/* Mappin functions */
int record_invoke_id(int,int);
int replay_invoke(int);
struct PSAPaddr * title2agentPa(PE);
static int titleInTable(PE);

/* life time memory management */
int om_free(OM_descriptor *);

/* common xmp handling functions */
void assign_ber(OM_descriptor *,PE);
void assign_byte_string(OM_descriptor *,char *,int);
void assign_oid(OM_descriptor *, OID);
void assign_pe(OM_descriptor *,PE);
void assign_octet_string(OM_descriptor *, char *);  /* xom strings */
OM_descriptor * create_context_obj(int,int,int,int,struct PSAPaddr *,
                        AEI,int);
/* xmp functions related to session creation */
OM_descriptor * create_ds_rdn_obj(int,OM_object *);
OM_descriptor * create_ds_rdn_obj2(int,OM_object *,int);
MP_feature  *create_feature_list(OM_object_identifier*,OM_object_identifier*); 
OM_descriptor * create_session_obj(int, char*, AEI, struct PSAPaddr *,
                                   AEI, struct PSAPaddr * );
OM_descriptor * managerAddress(int);
OM_private_object create_private_context(int, int);
int pub2priv(int,OM_descriptor *, OM_private_object *);

/* miscellaneous general purpose functions */
int string_defined(char *);
char *alphahexatostr(char *, int *);
char *berOID2str(PE);
OID paddr2title(const char *,const char *,int);
#endif





