/*
 * Copyright (c) 1994 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
** mtime - lightweight GeneralizedTime
*/

/*
** Saleem N. Bhatti
** May 1994
*/

#if !defined(_mtime_h_)
#define _mtime_h_

#if !defined(_a_)
#if defined(__STDC__) || defined(__cplusplus)
#define _a_(_args_) _args_
#else
#define _a_(_args_) ()
#endif
#endif

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct MTime_s { /* GeneralizedTime */

    int year;
    int month;
    int day;
    int hours;
    int minutes;
    int seconds;
    int microseconds;
    int zone; /* seconds offset from GMT */

} MTime;

int mTime2str _a_((const MTime *mt, char *str));
int str2mTime _a_((const char *str, MTime *mt));

char *mtime _a_(()); /* uses mTime2str() - do not free() return */

#if defined(__cplusplus)
}
#endif

#endif /* !_mtime_h_ */
