#ifndef _IQAAccessControlInfo_h_
#define _IQAAccessControlInfo_h_

#ifdef __GNU__
#include <std.h>
#else ifdef __cplusplus
#include <stdlib.h>
#endif

#include "msap.h"
#include "GenericAttr.h"
#include "PrxIIMCSntx-syntax.h"
#include "PrxIIMCSntx-utils.h"

 extern "C" {
	int AccessControlInfo_print(PS, struct type_PrxIIMCSntx_AccessControlInfo*, int);
	int AccessControlInfo_compare(void*, void*); };

class AccessControlInfo : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   AccessControlInfo(struct type_PrxIIMCSntx_AccessControlInfo* = NULL);
/*   inline AccessControlInfo() { AccessControlInfo((struct type_PrxIIMCSntx_AccessControlInfo*) NULL); }; KMTM*/
   ~AccessControlInfo();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE AccessControlInfo::_encode()
{
   return(build_AccessControlInfo((struct type_PrxIIMCSntx_AccessControlInfo*)getval()));
};

inline void* AccessControlInfo::_decode(PE pe)
{
   return((void*)parse_AccessControlInfo(pe));
};

inline char* AccessControlInfo::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)AccessControlInfo_print));
};

inline void AccessControlInfo::_free()
{
   AccessControlInfo_free((struct type_PrxIIMCSntx_AccessControlInfo *)getval());
}

inline int AccessControlInfo::_compare(void* theElem, void* theCmpElem)
{
   return(AccessControlInfo_compare(theElem, theCmpElem));
};

inline int AccessControlInfo::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int AccessControlInfo::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

#endif
