#ifndef _IQANullRDN_h_
#define _IQANullRDN_h_

#ifdef __GNU__
#include <std.h>
#else ifdef __cplusplus
#include <stdlib.h>
#endif

#include "msap.h"
#include "GenericAttr.h"
#include "PrxIIMCSntx-syntax.h"
#include "PrxIIMCSntx-utils.h"

/* Definition of class NullRDN */

 extern "C" {
	int NullRDN_print(PS, struct type_PrxIIMCSntx_NullRDN*, int);
	int NullRDN_compare(void*, void*); };

class NullRDN : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   NullRDN(struct type_PrxIIMCSntx_NullRDN* = NULL);
   ~NullRDN();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE NullRDN::_encode()
{
   return(build_NullRDN((struct type_PrxIIMCSntx_NullRDN*)getval()));
};

inline void* NullRDN::_decode(PE pe)
{
   return((void*)parse_NullRDN(pe));
};

inline char* NullRDN::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)NullRDN_print));
};

inline void NullRDN::_free()
{
   (void)NullRDN_free((struct type_PrxIIMCSntx_NullRDN*)getval());
}

inline int NullRDN::_compare(void* theElem, void* theCmpElem)
{
   return(NullRDN_compare(theElem, theCmpElem));
};

inline int NullRDN::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int NullRDN::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};


#endif
