-- Internet Alarm handling syntaxes
-- K.M.T.McCarthy
-- 07-Jun-94
PrxAlarmSntx { ccitt(0) data(9) pss(2342) ucl(19200300) iimc(114) iimcSyntaxes(1) 4 }

DEFINITIONS ::=

PREFIXES build parse print

BEGIN

	IMPORTS 
		RelativeDistinguishedName,
		DistinguishedName
			FROM IF {
			        joint-iso-ccitt(2)
				ds(5)
				modules(1)
				informationFramework(1)
                        }
--		SnmpIpAddress,
--		SnmpCounter,
--		SnmpGauge,
--		SnmpTimeTicks
--			FROM PrxSV1Sntx {
--				ccitt(0)
--				data(9)
--				pss(2342)
--				ucl(19200300)
--				iimc(114)
--				iimcSyntaxes(1)
--				1
--			}
		TransportDomain,
		TransportAddress,
		AccessControlInfo
			FROM PrxIIMCSntx {
				ccitt(0)
				data(9)
				pss(2342)
				ucl(19200300)
				iimc(114)
				iimcSyntaxes(1)
				2
			} ;

	
	-- IIMCIMIBTRANS
			
	InternetAlarmInfo ::= SEQUENCE {

		probableCause 		     ProbableCause,
		attributeIdList		[1]  AttributeIdentifierList OPTIONAL,
		objectInstanceList  	[2]  ObjectInstanceList OPTIONAL,
		unknownVarBindList	     UnknownVarBindList OPTIONAL,
               	internetTrapInfo    	[5]  InternetTrapInfo   OPTIONAL,
		perceivedSeverity   	[6]  PerceivedSeverity  OPTIONAL,
                notificationId      	[7]  NotificationIdentifier OPTIONAL,
                correlatedNot       	[8]  CorrelatedNotifications OPTIONAL,
                transportDomain     	[9]  TransportDomain    OPTIONAL,
                transportAddress    	[10] TransportAddress   OPTIONAL,
                accessControlInfo   	[11] AccessControlInfo  OPTIONAL,
                additionalInformation 	[12] AdditionalInformation OPTIONAL
        }


        InternetTrapInfo ::= SET OF SEQUENCE {
			objectInstance ObjectInstance OPTIONAL,
                        COMPONENTS OF Attribute
	}

	ObjectInstanceList ::= SET OF ObjectInstance
	

	UnknownVarBindList ::= CHOICE {
		v1	[3] RFC1157-SNMPVarBindList
--                v2	[4] SNMPv2-PDUVarBindList
        }


	
	-- X.711
	Attribute ::= SEQUENCE {
		attributeId	AttributeId,
		attributeValue	ANY DEFINED BY attributeId
	}
	
	AttributeId ::= CHOICE {
		globalForm	[0]	IMPLICIT OBJECT IDENTIFIER,
		localForm	[1]	IMPLICIT INTEGER
	}
	
	ObjectInstance ::= CHOICE {
		distinguishedName	[2] DistinguishedName,
		nonSpecificForm		[3] OCTET STRING,
		localDistinguishedName	[4] IMPLICIT RelativeDistinguishedName -- RDNSequence
	}
	
	-- 10165-2 | X.721
	ProbableCause ::= CHOICE { 
		globalValue	OBJECT IDENTIFIER,
		localValue	INTEGER -- for completeness !
	}

	AttributeIdentifierList ::= SET OF AttributeId
	
	AdditionalInformation ::= SET OF ManagementExtension
	
	ManagementExtension ::= SEQUENCE {
		identifier	OBJECT IDENTIFIER,
		significance	[1] BOOLEAN DEFAULT FALSE,
		information	[2] ANY DEFINED BY identifier
	}

	PerceivedSeverity ::= ENUMERATED{ indeterminate(0),
				critical(1), major(2),
				minor(3), warning(4),
				cleared(5)
	}

	NotificationIdentifier ::= INTEGER
	
	CorrelatedNotifications ::= SET OF SEQUENCE {
		correlatedNotifications SET OF NotificationIdentifier,
		sourceObjectInst	ObjectInstance OPTIONAL
	}


	-- RFC1157
	RFC1157-SNMPVarBindList ::= SEQUENCE OF RFC1157-SNMPVarBind

	RFC1157-SNMPVarBind ::= SEQUENCE {
		name	OBJECT IDENTIFIER, -- RFC1155 "ObjectName"
		value   ObjectSyntax
        }


	ObjectSyntax ::= ANY 

--	RFC1155
--        ObjectSyntax ::= CHOICE {
--		simple		 SimpleSyntax,
--                application-wide ApplicationSyntax
--        }
--
--        SimpleSyntax ::= CHOICE {
--                number INTEGER,
--                string OCTET STRING,
--                object OBJECT IDENTIFIER,
--                empty  NULL
--	}
--
--        ApplicationSyntax ::= CHOICE {
--                address NetworkAddress,
--		  address SnmpIpAddress,
--                counter SnmpCounter,
--                gauge   SnmpGauge,
--                ticks   SnmpTimeTicks
--                arbitrary Opaque
--	}

END
