/* @(#)PrxIIMCSntx-utils.c 	 08/08/1994 - 12:28  */

/********************************************************************

  Module:   PrxIIMCSntx-utils.c


  Descr.:   Def. of utils functs for the types generated by pepsy.


  Created:  Mon Aug 08, 1994


  Coded by: Attribute Compiler - Luca Deri 1993


********************************************************************/


#ifndef _PrxIIMCSntx_utils_c
#define _PrxIIMCSntx_utils_c

#include <stdio.h>
#include <stdlib.h>
#include "msap.h"
#include "PrxIIMCSntx-utils.h"

/* Used in the XXX_print function with pe2mem */
static char *tempStr;
static int tempLen;

/********************************************************************

  Name:             SnmpOpType_print


  Description:      This function prints the input SnmpOpType structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct SnmpOpType*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int SnmpOpType_print(PS ps, struct type_PrxIIMCSntx_SnmpOpType *elem, int quoted)
#else
int SnmpOpType_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_SnmpOpType *elem;
int quoted;
#endif
{
   sntx_table* table;
   int s = str2syntax("ASN");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_print(ps, elem, quoted));
}

/* GeneralType::Generate_free - className: SnmpOpType typeName: type_PrxIIMCSntx_SnmpOpType */
extern int SnmpOpType_free();

/********************************************************************

  Name:             SnmpOpType_compare


  Description:      This function compares the two input
                    *SnmpOpType pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int SnmpOpType_compare(void *elem_a, void *elem_b)
#else
int SnmpOpType_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   sntx_table* table;
   int s = str2syntax("ASN");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_compare(elem_a, elem_b));
}


/********************************************************************

  Name:             ObjIdent_print


  Description:      This function prints the input ObjIdent structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct ObjIdent*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int ObjIdent_print(PS ps, struct type_PrxIIMCSntx_ObjIdent *elem, int quoted)
#else
int ObjIdent_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_ObjIdent *elem;
int quoted;
#endif
{
   sntx_table* table;
   int s = str2syntax("oid");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_print(ps, elem, quoted));
}

/* GeneralType::Generate_free - className: ObjIdent typeName: type_PrxIIMCSntx_ObjIdent */
extern int ObjIdent_free();

/********************************************************************

  Name:             ObjIdent_compare


  Description:      This function compares the two input
                    *ObjIdent pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int ObjIdent_compare(void *elem_a, void *elem_b)
#else
int ObjIdent_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   sntx_table* table;
   int s = str2syntax("oid");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_compare(elem_a, elem_b));
}


/********************************************************************

  Name:             TransportDomain_print


  Description:      This function prints the input TransportDomain structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct TransportDomain*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int TransportDomain_print(PS ps, struct type_PrxIIMCSntx_TransportDomain *elem, int quoted)
#else
int TransportDomain_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_TransportDomain *elem;
int quoted;
#endif
{
   sntx_table* table;
   int s = str2syntax("oid");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_print(ps, elem, quoted));
}

/* GeneralType::Generate_free - className: TransportDomain typeName: type_PrxIIMCSntx_TransportDomain */
extern int TransportDomain_free();

/********************************************************************

  Name:             TransportDomain_compare


  Description:      This function compares the two input
                    *TransportDomain pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int TransportDomain_compare(void *elem_a, void *elem_b)
#else
int TransportDomain_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   sntx_table* table;
   int s = str2syntax("oid");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_compare(elem_a, elem_b));
}


/********************************************************************

  Name:             TransportAddress_print


  Description:      This function prints the input TransportAddress structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct TransportAddress*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int TransportAddress_print(PS ps, struct type_PrxIIMCSntx_TransportAddress *elem, int quoted)
#else
int TransportAddress_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_TransportAddress *elem;
int quoted;
#endif
{
   sntx_table* table;
   int s = str2syntax("octetstring");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_print(ps, elem, quoted));
}

/* GeneralType::Generate_free - className: TransportAddress typeName: type_PrxIIMCSntx_TransportAddress */
extern int TransportAddress_free();

/********************************************************************

  Name:             TransportAddress_compare


  Description:      This function compares the two input
                    *TransportAddress pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int TransportAddress_compare(void *elem_a, void *elem_b)
#else
int TransportAddress_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   sntx_table* table;
   int s = str2syntax("octetstring");

   if(s == 0)
	return(NOTOK);
   if((table = get_syntax_table(s)) == (sntx_table *) 0)
	return(NOTOK);

   return(table->s_compare(elem_a, elem_b));
}


/********************************************************************

  Name:             AccessControlEnforcement_print


  Description:      This function prints the input AccessControlEnforcement structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct AccessControlEnforcement*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int AccessControlEnforcement_print(PS ps, struct type_PrxIIMCSntx_AccessControlEnforcement *elem, int quoted)
#else
int AccessControlEnforcement_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_AccessControlEnforcement *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

/* ENUM CODE BEGIN */
   switch(elem->parm) {
      case int_PrxIIMCSntx_AccessControlEnforcement_agent:
        ps_printf(ps, "{ parm: agent }");
        break;
      case int_PrxIIMCSntx_AccessControlEnforcement_proxy:
        ps_printf(ps, "{ parm: proxy }");
        break;
      case int_PrxIIMCSntx_AccessControlEnforcement_both:
        ps_printf(ps, "{ parm: both }");
        break;
      default:
        ps_printf(ps, "{ parm: wrong value (%d) }", elem->parm);
      };
/* ENUM CODE END */
   ps_printf(ps, " ");

   return(OK);
};

/* GeneralType::Generate_free - className: AccessControlEnforcement typeName: type_PrxIIMCSntx_AccessControlEnforcement */
extern int AccessControlEnforcement_free();

/********************************************************************

  Name:             AccessControlEnforcement_compare


  Description:      This function compares the two input
                    *AccessControlEnforcement pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int AccessControlEnforcement_compare(void *elem_a, void *elem_b)
#else
int AccessControlEnforcement_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_AccessControlEnforcement *elem_1 =
          (struct type_PrxIIMCSntx_AccessControlEnforcement*)elem_a;
   struct type_PrxIIMCSntx_AccessControlEnforcement *elem_2 =
          (struct type_PrxIIMCSntx_AccessControlEnforcement*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(elem_1->parm
       == elem_2->parm) /* Equal */
     cmpRes = A_EQUAL_B;
   else if(elem_1->parm
            <= elem_2->parm) /* Not equal */
     cmpRes = A_LESS_EQUAL_B;
   else
     cmpRes = A_GREATER_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;

   return(theResult);
};


/********************************************************************

  Name:             PollPeriod_print


  Description:      This function prints the input PollPeriod structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct PollPeriod*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int PollPeriod_print(PS ps, struct type_PrxIIMCSntx_PollPeriod *elem, int quoted)
#else
int PollPeriod_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_PollPeriod *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   ps_printf(ps, "{ parm: %d }", elem->parm);
   ps_printf(ps, " ");

   return(OK);
};

/* GeneralType::Generate_free - className: PollPeriod typeName: type_PrxIIMCSntx_PollPeriod */
extern int PollPeriod_free();

/********************************************************************

  Name:             PollPeriod_compare


  Description:      This function compares the two input
                    *PollPeriod pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int PollPeriod_compare(void *elem_a, void *elem_b)
#else
int PollPeriod_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_PollPeriod *elem_1 =
          (struct type_PrxIIMCSntx_PollPeriod*)elem_a;
   struct type_PrxIIMCSntx_PollPeriod *elem_2 =
          (struct type_PrxIIMCSntx_PollPeriod*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(elem_1->parm
       == elem_2->parm) /* Equal */
     cmpRes = A_EQUAL_B;
   else if(elem_1->parm
            <= elem_2->parm) /* Not equal */
     cmpRes = A_LESS_EQUAL_B;
   else
     cmpRes = A_GREATER_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;

   return(theResult);
};


/********************************************************************

  Name:             ProtoNotImplErrorInfo_print


  Description:      This function prints the input ProtoNotImplErrorInfo structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct ProtoNotImplErrorInfo*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int ProtoNotImplErrorInfo_print(PS ps, struct type_PrxIIMCSntx_ProtoNotImplErrorInfo *elem, int quoted)
#else
int ProtoNotImplErrorInfo_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_ProtoNotImplErrorInfo *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

/* ENUM CODE BEGIN */
   switch(elem->parm) {
      case int_PrxIIMCSntx_ProtoNotImplErrorInfo_transportProtocol:
        ps_printf(ps, "{ parm: transportProtocol }");
        break;
      case int_PrxIIMCSntx_ProtoNotImplErrorInfo_authenticationProtocol:
        ps_printf(ps, "{ parm: authenticationProtocol }");
        break;
      case int_PrxIIMCSntx_ProtoNotImplErrorInfo_privacyProtocol:
        ps_printf(ps, "{ parm: privacyProtocol }");
        break;
      default:
        ps_printf(ps, "{ parm: wrong value (%d) }", elem->parm);
      };
/* ENUM CODE END */
   ps_printf(ps, " ");

   return(OK);
};

/* GeneralType::Generate_free - className: ProtoNotImplErrorInfo typeName: type_PrxIIMCSntx_ProtoNotImplErrorInfo */
extern int ProtoNotImplErrorInfo_free();

/********************************************************************

  Name:             ProtoNotImplErrorInfo_compare


  Description:      This function compares the two input
                    *ProtoNotImplErrorInfo pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int ProtoNotImplErrorInfo_compare(void *elem_a, void *elem_b)
#else
int ProtoNotImplErrorInfo_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_ProtoNotImplErrorInfo *elem_1 =
          (struct type_PrxIIMCSntx_ProtoNotImplErrorInfo*)elem_a;
   struct type_PrxIIMCSntx_ProtoNotImplErrorInfo *elem_2 =
          (struct type_PrxIIMCSntx_ProtoNotImplErrorInfo*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(elem_1->parm
       == elem_2->parm) /* Equal */
     cmpRes = A_EQUAL_B;
   else if(elem_1->parm
            <= elem_2->parm) /* Not equal */
     cmpRes = A_LESS_EQUAL_B;
   else
     cmpRes = A_GREATER_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;

   return(theResult);
};


/********************************************************************

  Name:             RetryLimit_print


  Description:      This function prints the input RetryLimit structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct RetryLimit*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int RetryLimit_print(PS ps, struct type_PrxIIMCSntx_RetryLimit *elem, int quoted)
#else
int RetryLimit_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_RetryLimit *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   ps_printf(ps, "{ parm: %d }", elem->parm);
   ps_printf(ps, " ");

   return(OK);
};

/* GeneralType::Generate_free - className: RetryLimit typeName: type_PrxIIMCSntx_RetryLimit */
extern int RetryLimit_free();

/********************************************************************

  Name:             RetryLimit_compare


  Description:      This function compares the two input
                    *RetryLimit pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int RetryLimit_compare(void *elem_a, void *elem_b)
#else
int RetryLimit_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_RetryLimit *elem_1 =
          (struct type_PrxIIMCSntx_RetryLimit*)elem_a;
   struct type_PrxIIMCSntx_RetryLimit *elem_2 =
          (struct type_PrxIIMCSntx_RetryLimit*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(elem_1->parm
       == elem_2->parm) /* Equal */
     cmpRes = A_EQUAL_B;
   else if(elem_1->parm
            <= elem_2->parm) /* Not equal */
     cmpRes = A_LESS_EQUAL_B;
   else
     cmpRes = A_GREATER_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;

   return(theResult);
};


/********************************************************************

  Name:             AccessControlInfo_print


  Description:      This function prints the input AccessControlInfo structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct AccessControlInfo*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int AccessControlInfo_print(PS ps, struct type_PrxIIMCSntx_AccessControlInfo *elem, int quoted)
#else
int AccessControlInfo_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_AccessControlInfo *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   ps_printf(ps, " { ");
/* ENUM CODE BEGIN */
   switch(elem->offset) {
      case type_PrxIIMCSntx_AccessControlInfo_communityString:
        ps_printf(ps, "{ offset: communityString }");
        break;
      case type_PrxIIMCSntx_AccessControlInfo_partyInfo:
        ps_printf(ps, "{ offset: partyInfo }");
        break;
      default:
        ps_printf(ps, "{ offset: wrong value (%d) }", elem->offset);
      };
/* ENUM CODE END */
   ps_printf(ps, " ");
/* VARIABLE PRINT CODE FOR UNION */
 /*  details are: prefix = (null), fieldName = un, theFieldName = un. */
/* Aaeeeiiii!! doctored union name... */
   switch(elem->offset)
     {
       case type_PrxIIMCSntx_AccessControlInfo_communityString:
       if(elem->un.communityString != NULL);
          ps_printf(ps, "{ communityString: %s }", printFilter(elem->un.communityString));
       break;

       case type_PrxIIMCSntx_AccessControlInfo_partyInfo:
 /*STRUCTFIELD PRINT POINTER CODE */
 /*  details are: prefix = un., fieldName = partyInfo, theFieldName = un.partyInfo-> */
           if(elem->un.partyInfo != NULL)
           {
           ps_printf(ps, "{ partyInfo: ");
           ps_printf(ps, "{ srcParty: %s }", oid2ode_aux(elem->un.partyInfo->srcParty, quoted));
           ps_printf(ps, " ");
           ps_printf(ps, "{ dstParty: %s }", oid2ode_aux(elem->un.partyInfo->dstParty, quoted));
           ps_printf(ps, " ");
           ps_printf(ps, "{ context: %s }", oid2ode_aux(elem->un.partyInfo->context, quoted));
           ps_printf(ps, " ");
           ps_printf(ps, " }");
           }
           else
             ps_printf(ps, "elem->un.partyInfo: EMPTY\n");
       break;

     } /* End switch */
/* ENDED UNION CODE GEN */ 
   ps_printf(ps, " ");
   ps_printf(ps, " }");

   return(OK);
};

/* GeneralType::Generate_free - className: AccessControlInfo typeName: type_PrxIIMCSntx_AccessControlInfo */
extern int AccessControlInfo_free();

/********************************************************************

  Name:             AccessControlInfo_compare


  Description:      This function compares the two input
                    *AccessControlInfo pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int AccessControlInfo_compare(void *elem_a, void *elem_b)
#else
int AccessControlInfo_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_AccessControlInfo *elem_1 =
          (struct type_PrxIIMCSntx_AccessControlInfo*)elem_a;
   struct type_PrxIIMCSntx_AccessControlInfo *elem_2 =
          (struct type_PrxIIMCSntx_AccessControlInfo*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(elem_1->offset == elem_2->offset) /* Equal */
     cmpRes = A_EQUAL_B;
   else
     return(A_NOT_EQUAL_B); /* Surely the structures can't be compared */

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;

/* VARIABLE COMPARE CODE FOR UNION */
/* Aaeeeiiii!! doctored union name... */
   switch(elem_1->offset)
      {
       case type_PrxIIMCSntx_AccessControlInfo_communityString:
       if(!((elem_1->un.communityString == NULL)
           && (elem_2->un.communityString == NULL)))
      {
            if((elem_1->un.communityString != NULL)
               && (elem_2->un.communityString != NULL))
             {
       if(qb_cmp(*elem_1->un.communityString,
                 *elem_2->un.communityString) == 0) /* Equal */
         cmpRes = A_EQUAL_B;
       else
         cmpRes = A_NOT_EQUAL_B;

         if(theResult != A_EQUAL_B)
           {
             if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
               return(A_NOT_EQUAL_B);
           }
         else
           theResult = cmpRes;
             }
            else
              return(A_NOT_EQUAL_B);
         }
       break;

       case type_PrxIIMCSntx_AccessControlInfo_partyInfo:
 /*STRUCTFIELD COMPARE POINTER CODE */
 /*  details are: prefix = un., fieldName = partyInfo, theFieldName = un.partyInfo-> */
           if((elem_1->un.partyInfo != NULL) && (elem_2->un.partyInfo != NULL))
           {
           if(oid_cmp(elem_1->un.partyInfo->srcParty,
                       elem_2->un.partyInfo->srcParty) == 0) /* Equal */
             cmpRes = A_EQUAL_B;
           else
             cmpRes = A_NOT_EQUAL_B;

             if(theResult != A_EQUAL_B)
               {
                 if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
                   return(A_NOT_EQUAL_B);
               }
             else
               theResult = cmpRes;

           if(oid_cmp(elem_1->un.partyInfo->dstParty,
                       elem_2->un.partyInfo->dstParty) == 0) /* Equal */
             cmpRes = A_EQUAL_B;
           else
             cmpRes = A_NOT_EQUAL_B;

             if(theResult != A_EQUAL_B)
               {
                 if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
                   return(A_NOT_EQUAL_B);
               }
             else
               theResult = cmpRes;

           if(oid_cmp(elem_1->un.partyInfo->context,
                       elem_2->un.partyInfo->context) == 0) /* Equal */
             cmpRes = A_EQUAL_B;
           else
             cmpRes = A_NOT_EQUAL_B;

             if(theResult != A_EQUAL_B)
               {
                 if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
                   return(A_NOT_EQUAL_B);
               }
             else
               theResult = cmpRes;

           } else if((elem_1->un.partyInfo != NULL)
                    || (elem_2->un.partyInfo != NULL))
                     return(A_NOT_EQUAL_B); /* Not equal */

       break;

     } /* End switch */

   return(theResult);
};


/********************************************************************

  Name:             SnmpSecurity_print


  Description:      This function prints the input SnmpSecurity structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct SnmpSecurity*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int SnmpSecurity_print(PS ps, struct type_PrxIIMCSntx_SnmpSecurity *elem, int quoted)
#else
int SnmpSecurity_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_SnmpSecurity *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   ps_printf(ps, " { ");
 /*STRUCTFIELD PRINT POINTER CODE */
 /*  details are: prefix = (null), fieldName = member_PrxIIMCSntx_0, theFieldName = member_PrxIIMCSntx_0-> */
   if(elem->member_PrxIIMCSntx_0 != NULL)
   {
   ps_printf(ps, "{ member_PrxIIMCSntx_0: ");
   ps_printf(ps, " { ");
   tempStr = NULL;
   if(elem->member_PrxIIMCSntx_0->snmpOperation != NULL);
      if(pe2mem(elem->member_PrxIIMCSntx_0->snmpOperation, &tempStr, &tempLen) != OK)
      return(NOTOK);
   ps_printf(ps, "{ snmpOperation: %s } ", tempStr);
   free(tempStr);
   ps_printf(ps, " ");
/* Elephant Droppings */
   ps_printf(ps, "{ snmpSecurityInfo: ");
   if(elem->member_PrxIIMCSntx_0->snmpSecurityInfo != NULL);
      if(AccessControlInfo_print(ps, elem->member_PrxIIMCSntx_0->snmpSecurityInfo, quoted) != OK)
      return(NOTOK);
   ps_printf(ps, " }");
   ps_printf(ps, " ");
   ps_printf(ps, " }");
   ps_printf(ps, " }");
   }
   else
     ps_printf(ps, "elem->member_PrxIIMCSntx_0: EMPTY\n");
   ps_printf(ps, " ");
/* Elephant Droppings */
   ps_printf(ps, "{ next: ");
   if(elem->next != NULL);
      if(SnmpSecurity_print(ps, elem->next, quoted) != OK)
      return(NOTOK);
   ps_printf(ps, " }");
   ps_printf(ps, " ");
   ps_printf(ps, " }");

   return(OK);
};

/* GeneralType::Generate_free - className: SnmpSecurity typeName: type_PrxIIMCSntx_SnmpSecurity */
extern int SnmpSecurity_free();

/********************************************************************

  Name:             SnmpSecurity_compare


  Description:      This function compares the two input
                    *SnmpSecurity pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int SnmpSecurity_compare(void *elem_a, void *elem_b)
#else
int SnmpSecurity_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_SnmpSecurity *elem_1 =
          (struct type_PrxIIMCSntx_SnmpSecurity*)elem_a;
   struct type_PrxIIMCSntx_SnmpSecurity *elem_2 =
          (struct type_PrxIIMCSntx_SnmpSecurity*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

 /*STRUCTFIELD COMPARE POINTER CODE */
 /*  details are: prefix = (null), fieldName = member_PrxIIMCSntx_0, theFieldName = member_PrxIIMCSntx_0-> */
   if((elem_1->member_PrxIIMCSntx_0 != NULL) && (elem_2->member_PrxIIMCSntx_0 != NULL))
   {
   if(!((elem_1->member_PrxIIMCSntx_0->snmpOperation == NULL)
       && (elem_2->member_PrxIIMCSntx_0->snmpOperation == NULL)))
      {
        if((elem_1->member_PrxIIMCSntx_0->snmpOperation != NULL)
           && (elem_2->member_PrxIIMCSntx_0->snmpOperation != NULL))
         {
   if(pe_cmp(elem_1->member_PrxIIMCSntx_0->snmpOperation,
              elem_2->member_PrxIIMCSntx_0->snmpOperation) == 0) /* Equal */
     cmpRes = A_EQUAL_B;
   else
     cmpRes = A_NOT_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   if(!((elem_1->member_PrxIIMCSntx_0->snmpSecurityInfo == NULL)
       && (elem_2->member_PrxIIMCSntx_0->snmpSecurityInfo == NULL)))
      {
        if((elem_1->member_PrxIIMCSntx_0->snmpSecurityInfo != NULL)
           && (elem_2->member_PrxIIMCSntx_0->snmpSecurityInfo != NULL))
         {
   cmpRes = AccessControlInfo_compare(elem_1->member_PrxIIMCSntx_0->snmpSecurityInfo,
             elem_2->member_PrxIIMCSntx_0->snmpSecurityInfo);

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   } else if((elem_1->member_PrxIIMCSntx_0 != NULL)
            || (elem_2->member_PrxIIMCSntx_0 != NULL))
             return(A_NOT_EQUAL_B); /* Not equal */


   if(!((elem_1->next == NULL)
       && (elem_2->next == NULL)))
      {
        if((elem_1->next != NULL)
           && (elem_2->next != NULL))
         {
   cmpRes = SnmpSecurity_compare(elem_1->next,
             elem_2->next);

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   return(theResult);
};


/********************************************************************

  Name:             SupportedMIBs_print


  Description:      This function prints the input SupportedMIBs structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct SupportedMIBs*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int SupportedMIBs_print(PS ps, struct type_PrxIIMCSntx_SupportedMIBs *elem, int quoted)
#else
int SupportedMIBs_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_SupportedMIBs *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   ps_printf(ps, " { ");
   if(elem->ObjIdent != NULL);
      ps_printf(ps, "{ ObjIdent: %s }", oid2ode_aux(elem->ObjIdent, quoted));
   ps_printf(ps, " ");
/* Elephant Droppings */
   ps_printf(ps, "{ next: ");
   if(elem->next != NULL);
      if(SupportedMIBs_print(ps, elem->next, quoted) != OK)
      return(NOTOK);
   ps_printf(ps, " }");
   ps_printf(ps, " ");
   ps_printf(ps, " }");

   return(OK);
};

/* GeneralType::Generate_free - className: SupportedMIBs typeName: type_PrxIIMCSntx_SupportedMIBs */
extern int SupportedMIBs_free();

/********************************************************************

  Name:             SupportedMIBs_compare


  Description:      This function compares the two input
                    *SupportedMIBs pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int SupportedMIBs_compare(void *elem_a, void *elem_b)
#else
int SupportedMIBs_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_SupportedMIBs *elem_1 =
          (struct type_PrxIIMCSntx_SupportedMIBs*)elem_a;
   struct type_PrxIIMCSntx_SupportedMIBs *elem_2 =
          (struct type_PrxIIMCSntx_SupportedMIBs*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(!((elem_1->ObjIdent == NULL)
       && (elem_2->ObjIdent == NULL)))
      {
        if((elem_1->ObjIdent != NULL)
           && (elem_2->ObjIdent != NULL))
         {
   if(oid_cmp(elem_1->ObjIdent,
               elem_2->ObjIdent) == 0) /* Equal */
     cmpRes = A_EQUAL_B;
   else
     cmpRes = A_NOT_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   if(!((elem_1->next == NULL)
       && (elem_2->next == NULL)))
      {
        if((elem_1->next != NULL)
           && (elem_2->next != NULL))
         {
   cmpRes = SupportedMIBs_compare(elem_1->next,
             elem_2->next);

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   return(theResult);
};


/********************************************************************

  Name:             TimeoutInterval_print


  Description:      This function prints the input TimeoutInterval structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct TimeoutInterval*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int TimeoutInterval_print(PS ps, struct type_PrxIIMCSntx_TimeoutInterval *elem, int quoted)
#else
int TimeoutInterval_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_TimeoutInterval *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   ps_printf(ps, "{ parm: %d }", elem->parm);
   ps_printf(ps, " ");

   return(OK);
};

/* GeneralType::Generate_free - className: TimeoutInterval typeName: type_PrxIIMCSntx_TimeoutInterval */
extern int TimeoutInterval_free();

/********************************************************************

  Name:             TimeoutInterval_compare


  Description:      This function compares the two input
                    *TimeoutInterval pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int TimeoutInterval_compare(void *elem_a, void *elem_b)
#else
int TimeoutInterval_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_TimeoutInterval *elem_1 =
          (struct type_PrxIIMCSntx_TimeoutInterval*)elem_a;
   struct type_PrxIIMCSntx_TimeoutInterval *elem_2 =
          (struct type_PrxIIMCSntx_TimeoutInterval*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(elem_1->parm
       == elem_2->parm) /* Equal */
     cmpRes = A_EQUAL_B;
   else if(elem_1->parm
            <= elem_2->parm) /* Not equal */
     cmpRes = A_LESS_EQUAL_B;
   else
     cmpRes = A_GREATER_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;

   return(theResult);
};


/********************************************************************

  Name:             TransportAddresses_print


  Description:      This function prints the input TransportAddresses structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct TransportAddresses*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int TransportAddresses_print(PS ps, struct type_PrxIIMCSntx_TransportAddresses *elem, int quoted)
#else
int TransportAddresses_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_TransportAddresses *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   ps_printf(ps, " { ");
 /*STRUCTFIELD PRINT POINTER CODE */
 /*  details are: prefix = (null), fieldName = member_PrxIIMCSntx_1, theFieldName = member_PrxIIMCSntx_1-> */
   if(elem->member_PrxIIMCSntx_1 != NULL)
   {
   ps_printf(ps, "{ member_PrxIIMCSntx_1: ");
   ps_printf(ps, " { ");
   if(elem->member_PrxIIMCSntx_1->domain != NULL);
      ps_printf(ps, "{ domain: %s }", oid2ode_aux(elem->member_PrxIIMCSntx_1->domain, quoted));
   ps_printf(ps, " ");
   if(elem->member_PrxIIMCSntx_1->address != NULL);
      ps_printf(ps, "{ address: %s }", printFilter(elem->member_PrxIIMCSntx_1->address));
   ps_printf(ps, " ");
   ps_printf(ps, " }");
   ps_printf(ps, " }");
   }
   else
     ps_printf(ps, "elem->member_PrxIIMCSntx_1: EMPTY\n");
   ps_printf(ps, " ");
/* Elephant Droppings */
   ps_printf(ps, "{ next: ");
   if(elem->next != NULL);
      if(TransportAddresses_print(ps, elem->next, quoted) != OK)
      return(NOTOK);
   ps_printf(ps, " }");
   ps_printf(ps, " ");
   ps_printf(ps, " }");

   return(OK);
};

/* GeneralType::Generate_free - className: TransportAddresses typeName: type_PrxIIMCSntx_TransportAddresses */
extern int TransportAddresses_free();

/********************************************************************

  Name:             TransportAddresses_compare


  Description:      This function compares the two input
                    *TransportAddresses pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int TransportAddresses_compare(void *elem_a, void *elem_b)
#else
int TransportAddresses_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_TransportAddresses *elem_1 =
          (struct type_PrxIIMCSntx_TransportAddresses*)elem_a;
   struct type_PrxIIMCSntx_TransportAddresses *elem_2 =
          (struct type_PrxIIMCSntx_TransportAddresses*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

 /*STRUCTFIELD COMPARE POINTER CODE */
 /*  details are: prefix = (null), fieldName = member_PrxIIMCSntx_1, theFieldName = member_PrxIIMCSntx_1-> */
   if((elem_1->member_PrxIIMCSntx_1 != NULL) && (elem_2->member_PrxIIMCSntx_1 != NULL))
   {
   if(!((elem_1->member_PrxIIMCSntx_1->domain == NULL)
       && (elem_2->member_PrxIIMCSntx_1->domain == NULL)))
      {
        if((elem_1->member_PrxIIMCSntx_1->domain != NULL)
           && (elem_2->member_PrxIIMCSntx_1->domain != NULL))
         {
   if(oid_cmp(elem_1->member_PrxIIMCSntx_1->domain,
               elem_2->member_PrxIIMCSntx_1->domain) == 0) /* Equal */
     cmpRes = A_EQUAL_B;
   else
     cmpRes = A_NOT_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   if(!((elem_1->member_PrxIIMCSntx_1->address == NULL)
       && (elem_2->member_PrxIIMCSntx_1->address == NULL)))
      {
        if((elem_1->member_PrxIIMCSntx_1->address != NULL)
           && (elem_2->member_PrxIIMCSntx_1->address != NULL))
         {
   if(qb_cmp(*elem_1->member_PrxIIMCSntx_1->address,
             *elem_2->member_PrxIIMCSntx_1->address) == 0) /* Equal */
     cmpRes = A_EQUAL_B;
   else
     cmpRes = A_NOT_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   } else if((elem_1->member_PrxIIMCSntx_1 != NULL)
            || (elem_2->member_PrxIIMCSntx_1 != NULL))
             return(A_NOT_EQUAL_B); /* Not equal */


   if(!((elem_1->next == NULL)
       && (elem_2->next == NULL)))
      {
        if((elem_1->next != NULL)
           && (elem_2->next != NULL))
         {
   cmpRes = TransportAddresses_compare(elem_1->next,
             elem_2->next);

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;
         }
        else
          return(A_NOT_EQUAL_B);
     }

   return(theResult);
};


/********************************************************************

  Name:             NullRDN_print


  Description:      This function prints the input NullRDN structure.


  Input params.:    PS
                    The presentation stream where the function prints.

                    struct NullRDN*
                    The structure to be printed.

                    int
                    Flag: 1 = quoted print, 0 = not quoted print.


  Output params.:   int
                    NOTOK if some error is occurred, OK otherwise.


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(_cplusplus)
int NullRDN_print(PS ps, struct type_PrxIIMCSntx_NullRDN *elem, int quoted)
#else
int NullRDN_print(ps, elem, quoted)
PS ps;
struct type_PrxIIMCSntx_NullRDN *elem;
int quoted;
#endif
{
   if(elem == NULL)
     {
       ps_print(ps, " NULL");
       return(OK); /* Nothing to print */
     }

   switch(elem->parm) {
     case False:
       ps_printf(ps, "{ parm: False }");
       break;
     case True:
       ps_printf(ps, "{ parm: True }");
       break;
     default:
       ps_printf(ps, "{ parm: ??? }");
   }
   ps_printf(ps, " ");

   return(OK);
};

/* GeneralType::Generate_free - className: NullRDN typeName: type_PrxIIMCSntx_NullRDN */
extern int NullRDN_free();

/********************************************************************

  Name:             NullRDN_compare


  Description:      This function compares the two input
                    *NullRDN pointers.


  Input params.:    void*
                    The structure to be compared.

                    void*
                    The structure to compare.


  Output params.:   int
                    A_EQUAL_B:         1st struct == 2nd struct
                    A_LESS_EQUAL_B:    1st struct <= 2nd struct
                    A_GREATER_EQUAL_B: 1st struct >= 2nd struct
                    A_NOT_EQUAL_B:     1st struct != 2nd struct


  Modific. history:


  Created on:       Mon Aug 08, 1994


  Coded by:         Attribute Compiler - Luca Deri 1993


********************************************************************/
#if defined(__STDC__) || defined(__cplusplus)
int NullRDN_compare(void *elem_a, void *elem_b)
#else
int NullRDN_compare(elem_a, elem_b)
void *elem_a;
void *elem_b;
#endif
{
   struct type_PrxIIMCSntx_NullRDN *elem_1 =
          (struct type_PrxIIMCSntx_NullRDN*)elem_a;
   struct type_PrxIIMCSntx_NullRDN *elem_2 =
          (struct type_PrxIIMCSntx_NullRDN*)elem_b;
   int theResult = A_EQUAL_B, cmpRes;

  if((elem_1 == NULL) && (elem_2 == NULL))
     return(A_EQUAL_B);
  else if((elem_1 == NULL) || (elem_2 == NULL))
     return(A_NOT_EQUAL_B);

   if(elem_1->parm
       == elem_2->parm) /* Equal */
     cmpRes = A_EQUAL_B;
   else if(elem_1->parm
            <= elem_2->parm) /* Not equal */
     cmpRes = A_LESS_EQUAL_B;
   else
     cmpRes = A_GREATER_EQUAL_B;

     if(theResult != A_EQUAL_B)
       {
         if((theResult != cmpRes) && (cmpRes != A_EQUAL_B))
           return(A_NOT_EQUAL_B);
       }
     else
       theResult = cmpRes;

   return(theResult);
};


#endif /* !_PrxIIMCSntx_utils_c_ */

