/* @(#)PrxIIMCSntx-utils.h 	 08/08/1994 - 12:28  */

/********************************************************************

  Module:   PrxIIMCSntx-utils.h


  Descr.:   Prot. of utils functs for the types generated by pepsy.


  Created:  Mon Aug 08, 1994


  Coded by: Attribute Compiler - Luca Deri 1993


********************************************************************/


#ifndef _PrxIIMCSntx_utils_h
#define _PrxIIMCSntx_utils_h

#include <string.h>
#include "PrxIIMCSntx-types.h"
#include "Boolean.h"
#include "Library.h"
#include "mparm.h"

#define PRESENT(bits,name) ((bits & name) == name)
#define SET_PRESENT(bits,name) (bits |= name)
#define SET_ABSENT(bits,name)  (bits &= ~name)
#define SET_ALL_ABSENT(bits)   (bits &= 0x0)
#define A_EQUAL_B                    0
#define A_GREATER_EQUAL_B            1
#define A_LESS_EQUAL_B               2
#define A_SUBSET_OF_B                3
#define A_SUPERSET_OF_B              4
#define A_NON_NULL_INTERSECTION_B    5
#define A_NOT_EQUAL_B                6

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int SnmpOpType_print(PS, struct type_PrxIIMCSntx_SnmpOpType*, int);
	int SnmpOpType_compare(void*, void*);
	int  SnmpOpType_free(struct type_PrxIIMCSntx_SnmpOpType *);
	void* SnmpOpType_add(void*, void*);
	void* SnmpOpType_remove(void*, void*);

		}
#else
	int SnmpOpType_print();
	int SnmpOpType_compare();
	int SnmpOpType_free();
	void* SnmpOpType_add();
	void* SnmpOpType_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int ObjIdent_print(PS, struct type_PrxIIMCSntx_ObjIdent*, int);
	int ObjIdent_compare(void*, void*);
	int  ObjIdent_free(struct type_PrxIIMCSntx_ObjIdent *);
	void* ObjIdent_add(void*, void*);
	void* ObjIdent_remove(void*, void*);

		}
#else
	int ObjIdent_print();
	int ObjIdent_compare();
	int ObjIdent_free();
	void* ObjIdent_add();
	void* ObjIdent_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int TransportDomain_print(PS, struct type_PrxIIMCSntx_TransportDomain*, int);
	int TransportDomain_compare(void*, void*);
	int  TransportDomain_free(struct type_PrxIIMCSntx_TransportDomain *);
	void* TransportDomain_add(void*, void*);
	void* TransportDomain_remove(void*, void*);

		}
#else
	int TransportDomain_print();
	int TransportDomain_compare();
	int TransportDomain_free();
	void* TransportDomain_add();
	void* TransportDomain_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int TransportAddress_print(PS, struct type_PrxIIMCSntx_TransportAddress*, int);
	int TransportAddress_compare(void*, void*);
	int  TransportAddress_free(struct type_PrxIIMCSntx_TransportAddress *);
	void* TransportAddress_add(void*, void*);
	void* TransportAddress_remove(void*, void*);

		}
#else
	int TransportAddress_print();
	int TransportAddress_compare();
	int TransportAddress_free();
	void* TransportAddress_add();
	void* TransportAddress_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int AccessControlEnforcement_print(PS, struct type_PrxIIMCSntx_AccessControlEnforcement*, int);
	int AccessControlEnforcement_compare(void*, void*);
	int  AccessControlEnforcement_free(struct type_PrxIIMCSntx_AccessControlEnforcement *);
	void* AccessControlEnforcement_add(void*, void*);
	void* AccessControlEnforcement_remove(void*, void*);

		}
#else
	int AccessControlEnforcement_print();
	int AccessControlEnforcement_compare();
	int AccessControlEnforcement_free();
	void* AccessControlEnforcement_add();
	void* AccessControlEnforcement_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int PollPeriod_print(PS, struct type_PrxIIMCSntx_PollPeriod*, int);
	int PollPeriod_compare(void*, void*);
	int  PollPeriod_free(struct type_PrxIIMCSntx_PollPeriod *);
	void* PollPeriod_add(void*, void*);
	void* PollPeriod_remove(void*, void*);

		}
#else
	int PollPeriod_print();
	int PollPeriod_compare();
	int PollPeriod_free();
	void* PollPeriod_add();
	void* PollPeriod_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int ProtoNotImplErrorInfo_print(PS, struct type_PrxIIMCSntx_ProtoNotImplErrorInfo*, int);
	int ProtoNotImplErrorInfo_compare(void*, void*);
	int  ProtoNotImplErrorInfo_free(struct type_PrxIIMCSntx_ProtoNotImplErrorInfo *);
	void* ProtoNotImplErrorInfo_add(void*, void*);
	void* ProtoNotImplErrorInfo_remove(void*, void*);

		}
#else
	int ProtoNotImplErrorInfo_print();
	int ProtoNotImplErrorInfo_compare();
	int ProtoNotImplErrorInfo_free();
	void* ProtoNotImplErrorInfo_add();
	void* ProtoNotImplErrorInfo_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int RetryLimit_print(PS, struct type_PrxIIMCSntx_RetryLimit*, int);
	int RetryLimit_compare(void*, void*);
	int  RetryLimit_free(struct type_PrxIIMCSntx_RetryLimit *);
	void* RetryLimit_add(void*, void*);
	void* RetryLimit_remove(void*, void*);

		}
#else
	int RetryLimit_print();
	int RetryLimit_compare();
	int RetryLimit_free();
	void* RetryLimit_add();
	void* RetryLimit_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int AccessControlInfo_print(PS, struct type_PrxIIMCSntx_AccessControlInfo*, int);
	int AccessControlInfo_compare(void*, void*);
	int  AccessControlInfo_free(struct type_PrxIIMCSntx_AccessControlInfo *);
	void* AccessControlInfo_add(void*, void*);
	void* AccessControlInfo_remove(void*, void*);

		}
#else
	int AccessControlInfo_print();
	int AccessControlInfo_compare();
	int AccessControlInfo_free();
	void* AccessControlInfo_add();
	void* AccessControlInfo_remove();
#endif

extern qb_cmp();
extern oid_cmp();
#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int SnmpSecurity_print(PS, struct type_PrxIIMCSntx_SnmpSecurity*, int);
	int SnmpSecurity_compare(void*, void*);
	int  SnmpSecurity_free(struct type_PrxIIMCSntx_SnmpSecurity *);
	void* SnmpSecurity_add(void*, void*);
	void* SnmpSecurity_remove(void*, void*);

		}
#else
	int SnmpSecurity_print();
	int SnmpSecurity_compare();
	int SnmpSecurity_free();
	void* SnmpSecurity_add();
	void* SnmpSecurity_remove();
#endif

extern pe_cmp();
#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int SupportedMIBs_print(PS, struct type_PrxIIMCSntx_SupportedMIBs*, int);
	int SupportedMIBs_compare(void*, void*);
	int  SupportedMIBs_free(struct type_PrxIIMCSntx_SupportedMIBs *);
	void* SupportedMIBs_add(void*, void*);
	void* SupportedMIBs_remove(void*, void*);

		}
#else
	int SupportedMIBs_print();
	int SupportedMIBs_compare();
	int SupportedMIBs_free();
	void* SupportedMIBs_add();
	void* SupportedMIBs_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int TimeoutInterval_print(PS, struct type_PrxIIMCSntx_TimeoutInterval*, int);
	int TimeoutInterval_compare(void*, void*);
	int  TimeoutInterval_free(struct type_PrxIIMCSntx_TimeoutInterval *);
	void* TimeoutInterval_add(void*, void*);
	void* TimeoutInterval_remove(void*, void*);

		}
#else
	int TimeoutInterval_print();
	int TimeoutInterval_compare();
	int TimeoutInterval_free();
	void* TimeoutInterval_add();
	void* TimeoutInterval_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int TransportAddresses_print(PS, struct type_PrxIIMCSntx_TransportAddresses*, int);
	int TransportAddresses_compare(void*, void*);
	int  TransportAddresses_free(struct type_PrxIIMCSntx_TransportAddresses *);
	void* TransportAddresses_add(void*, void*);
	void* TransportAddresses_remove(void*, void*);

		}
#else
	int TransportAddresses_print();
	int TransportAddresses_compare();
	int TransportAddresses_free();
	void* TransportAddresses_add();
	void* TransportAddresses_remove();
#endif

#if defined(__STDC__) || defined(__cplusplus)
 extern "C" {
	int NullRDN_print(PS, struct type_PrxIIMCSntx_NullRDN*, int);
	int NullRDN_compare(void*, void*);
	int  NullRDN_free(struct type_PrxIIMCSntx_NullRDN *);
	void* NullRDN_add(void*, void*);
	void* NullRDN_remove(void*, void*);

		}
#else
	int NullRDN_print();
	int NullRDN_compare();
	int NullRDN_free();
	void* NullRDN_add();
	void* NullRDN_remove();
#endif


#endif /* !_PrxIIMCSntx_utils_h_ */

