//
// Copyright (c) 1994 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

#ifndef _SNMPIMAGEACCESS_H_
#define _SNMPIMAGEACCESS_H_

extern "C" {
#include <sys/time.h>
#if !defined(SOLARIS)
	int gettimeofday( struct timeval*, struct timezone* ) ;
#endif
} ;

#include "SnmpRMIBAgent.h"
#include "cmipsnmpProxyAgent.h"


class	SnmpImageAccess : public Top {

	cmipsnmpProxyAgent * _cmipsnmpProxyAgentp ;
	SnmpRMIBAgent 	   * _snmpRMIBagentp ;
	timeval		     _lastCachedTimeVal ;
	int		     _staleS ;

protected:

	void	setCmipsnmpProxyAgent( cmipsnmpProxyAgent* ) ;
	void	setSnmpRMIBAgent( SnmpRMIBAgent* ) ;

	CMISErrors refreshImageSubordinate(  SnmpImageMOClassInfo *, RDN, AVA*& ) ;
	CMISErrors refreshImageSubordinates( SnmpImageMOClassInfo *, AVA*& ) ;

	void 	initialise( void ) ;

	SnmpImageAccess( RDN, MO*) ;

public:
	
	cmipsnmpProxyAgent * getCmipsnmpProxyAgent( void ) ;
	SnmpRMIBAgent      * getSnmpRMIBAgent( void ) ;

	SnmpImageMO * getClassFirst( SnmpImageMOClassInfo* ) ; // Multi-MIB version
	SnmpImageMO * getClassNext(  SnmpImageMOClassInfo* ) ; // Multi-MIB version

	Bool	isRemoteAgentLocked( int&, CMISErrors& ) ; // Old GMS API
	Bool	isRemoteAgentLocked( int&, AVA*& ) ;	   // New GMS API

	~SnmpImageAccess() ;
} ;

inline	cmipsnmpProxyAgent * SnmpImageAccess::getCmipsnmpProxyAgent( void ) { return _cmipsnmpProxyAgentp ; }
inline	SnmpRMIBAgent      * SnmpImageAccess::getSnmpRMIBAgent( void ) 	    { return _snmpRMIBagentp ; }

inline	void    SnmpImageAccess::setCmipsnmpProxyAgent( cmipsnmpProxyAgent* cmipsnmpProxyAgentp ) 
							   { _cmipsnmpProxyAgentp = cmipsnmpProxyAgentp ; }
inline	void    SnmpImageAccess::setSnmpRMIBAgent( SnmpRMIBAgent* snmpRMIBagentp ) 
							   { _snmpRMIBagentp = snmpRMIBagentp ; }

inline	void 	SnmpImageAccess::initialise( void ) { _cmipsnmpProxyAgentp = (cmipsnmpProxyAgent*)0 ;
					 	      _snmpRMIBagentp      = (SnmpRMIBAgent*)0 ;
     						      _lastCachedTimeVal.tv_sec = _lastCachedTimeVal.tv_usec = 0 ;
 						      _staleS = 2 ; }

inline	SnmpImageAccess::SnmpImageAccess( RDN rdn, MO* mo ) : Top( rdn, mo ) { initialise() ; }
#endif
