#ifndef _IQA_h_
#define _IQA_h_

#ifdef __GNU__
#include <std.h>
#else ifdef __cplusplus
#include <stdlib.h>
#endif

#include "msap.h"
#include "GenericAttr.h"
#include "PrxIIMCSntx-syntax.h"
#include "PrxIIMCSntx-utils.h"

 extern "C" {
	int SnmpSecurity_print(PS, struct type_PrxIIMCSntx_SnmpSecurity*, int);
	int SnmpSecurity_compare(void*, void*); };

class SnmpSecurity : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   SnmpSecurity(struct type_PrxIIMCSntx_SnmpSecurity* = NULL);
   ~SnmpSecurity();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE SnmpSecurity::_encode()
{
   return(build_SnmpSecurity((struct type_PrxIIMCSntx_SnmpSecurity*)getval()));
};

inline void* SnmpSecurity::_decode(PE pe)
{
   return((void*)parse_SnmpSecurity(pe));
};

inline char* SnmpSecurity::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)SnmpSecurity_print));
};

inline void SnmpSecurity::_free()
{
   (void)SnmpSecurity_free((struct type_PrxIIMCSntx_SnmpSecurity*)getval());
}

inline int SnmpSecurity::_compare(void* theElem, void* theCmpElem)
{
   return(SnmpSecurity_compare(theElem, theCmpElem));
};

inline int SnmpSecurity::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int SnmpSecurity::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

#endif
