//
// Copyright (c) 1994 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// remoteSystem.h 
// By Jose Neuman de Souza, September 1993
//
// Updates from Nov-93 K.M.T.McCarthy.
//		23-11-93	"getSnmpRMIBAgent() and getCmipsnmpProxyAgent() added 
//				 with inheritance from the class SnmpImageAccess."
//		29-11-93	"refreshSubordinate() class member added."
//		07-11-93	"refreshSubordinates() class member added."
//

#ifndef _REMOTESYSTEM_H_
#define _REMOTESYSTEM_H_

#ifndef _TOP_
#include "Top.h"
#endif

#include "SnmpRMIBAgent.h"
#include "SnmpImageAccess.h"

class remoteSystem : public SnmpImageAccess
{
#define REMOTESYSTEM_LEVEL	1		/* Top 0 */

    	static MOClassInfo	_remoteSystem;
    	static const int
    	REMOTESYSTEMID,
	REMOTESYSTEMTITLE,
	REMOTESYSOPERSTATE,
	REMOTESYSUSAGESTATE ;
#define REMOTESYSTEMNATTRS	4

    	Attr	*_attrs[REMOTESYSTEMNATTRS];

protected:
	int	refreshSubordinate( RDN, AVA*&, int= -1 );
	int	refreshSubordinates( AVA*&, int= -1 ) ;

public:
    	static int		initialiseClass ();

    	static MOClassInfo*	getClassInfo ();
//    	static MO*  cmisCreate(RDN, MO *, MO *, int, CMISParam *,
//                        CMISErrors *, CMISErrorInfo *, OID *); // CMIS

//    	remoteSystem(RDN, MO *, MO * = NULL, int = 0, CMISParam * = NULL,
//			CMISErrors * = NULL, CMISErrorInfo * = NULL, OID * = NULL);

    	remoteSystem( AVA*&, RDN, MO*, cmipsnmpProxyAgent*, Bool& ) ;
};

inline MOClassInfo*  	   remoteSystem::getClassInfo ( void ) { return &_remoteSystem ; }

#endif
