//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// TimeManagerRelay.cc

// By George Pavlou, February 1994


#include <stdlib.h>
#include "msap.h"
#include "Error.h"
#include "Top.h"	/* for the notification function (relayEventReport) */
#include "TimeManagerRelay.h"


int  TimeManagerRelay::eventNotification (char* objClass, char* objInst,
	char* eventType, char* eventTime, Attr* report, RMIBAgent* rmibAgent)
{
    if (strcasecmp(eventType, "attributeValueChange") != 0)
	return NOTOK;

    // relay the time first
    CMISEventReportArg* evRep = rmibAgent->getCMISEventReportArg();
    Top::relayEventReport(evRep->ea_class.mid_global, &evRep->ea_inst,
		evRep->ea_time, evRep->ea_type.mid_global, evRep->ea_info);

    // check now wake-ups in this application
    TimeManager::eventNotification (objClass, objInst, eventType, eventTime,
					report, rmibAgent);
    return OK;
}

