//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// DbmCat.cc - Shows contents of ndbm files.
// I assume that the records and keys all consist of printable charcters, and
// all records have their fields delimited a colon. Spaces in fields are not
// ignored.

// Saleem N. Bhatti
// June 1992

#if !defined(_DbmCat_cc_)
#define _DbmCat_cc_

#if defined(__GNUG__)
#include <std.h>
#elif defined(__cplusplus)
#include <stdlib.h>
#ifdef AIXV3
#include <stdio.h>
#endif
#endif
#include <strings.h>

#include "dbm-lock.h"

main(int argc, char **argv)
{
    if (argc != 2) {
        printf("usage : dbmcat <dbm-file-name>\n");
        exit(0);
    }

    register
    DbmFile *db;

    if ((db = dbmOpen(argv[1])) == NULL) {
        printf("Couldn't open %s\n", argv[1]);
        perror("");
        exit(0);
    }

    register
    datum *key, *entry;

    for(key = dbmGetKey(db, DBM_GetFirstKey); key != NULL;
    key = dbmGetKey(db)) {

        if ((entry = dbmFetch(db, key)) == NULL) continue;

        char data[DBM_MaxRecordSize + 1];
        register
        char *dp;

        bcopy(key->dptr, data, key->dsize);
        data[key->dsize] = NULL;
        printf("[key = %s]\n", data);

        bcopy(entry->dptr, data, entry->dsize);
        data[entry->dsize] = NULL;

        for(dp = data; *dp != (char) NULL; ++dp) {
            if (*dp == ':') { printf("\n"); continue; }
            printf("%c", *dp);
        }

        printf("\n--- Press RETURN ---\n");
        while(getchar() != '\n') ;
    }
}

#endif /* !_DbmCat_cc_ */
