/*
 * Copyright (c) 1994 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
** MSAP Credential syntaxes for authentication dialogue
*/

/*
** Saleem N. Bhatti
** March 1994
*/

#if !defined(_CredSntx_h_)
#define _CredSntx_h_

#if !defined(_a_)
#if defined(__STDC__) || defined(__cplusplus)
#define _a_(_args_) _args_
#else
#define _a_(_args_) ()
#endif
#endif

#if defined(__cplusplus)
extern "C" {
#endif

#include "Cred-types.h"

PE MsapCredentials_encode _a_((struct type_Cred_MsapCredentials *));
struct type_Cred_MsapCredentials *MsapCredentials_decode _a_((PE));
void MsapCredentials_free _a_((struct type_Cred_MsapCredentials *));

PE SessionKey_encode _a_((struct type_Cred_SessionKey *));
struct type_Cred_SessionKey *SessionKey_decode _a_((PE));
void SessionKey_free _a_((struct type_Cred_SessionKey *));

PE SessionToken_encode _a_((struct type_Cred_SessionToken *));
struct type_Cred_SessionToken *SessionToken_decode _a_((PE));
void SessionToken_free _a_((struct type_Cred_SessionToken *));

PE SessionCredentials_encode _a_((struct type_Cred_SessionCredentials *));
struct type_Cred_SessionCredentials *SessionCredentials_decode _a_((PE));
void SessionCredentials_free _a_((struct type_Cred_SessionCredentials *));

#if defined(__cplusplus)
}
#endif

#endif /* !_CredSntx_h_ */
