
/* MD5.H - header file for MD5C.C
 */

/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
rights reserved.

License to copy and use this software is granted provided that it
is identified as the "RSA Data Security, Inc. MD5 Message-Digest
Algorithm" in all material mentioning or referencing this software
or this function.

License is also granted to make and use derivative works provided
that such works are identified as "derived from the RSA Data
Security, Inc. MD5 Message-Digest Algorithm" in all material
mentioning or referencing the derived work.

RSA Data Security, Inc. makes no representations concerning either
the merchantability of this software or the suitability of this
software for any particular purpose. It is provided "as is"
without express or implied warranty of any kind.
These notices must be retained in any copies of any part of this
documentation and/or software.
 */

/* Modified a tad from the original RFC 1321 stuff by Saleem */
/* 25 February 1994 */

#if !defined(_md5_h_)
#define _md5_h_

#if !defined(_a_)
#if defined(__STDC__) || defined(__cplusplus)
#define _a_(_args_) _args_
#else
#define _a_(_args_) ()
#endif
#endif

#include "global.h"

#if defined(__cplusplus)
extern "C" {
#endif

/* MD5 context */
typedef struct MD5Context_s {
  UINT4 state[4];                                   /* state (ABCD) */
  UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                         /* input buffer */
} MD5Context;

void md5Init _a_((MD5Context *));
void md5Update _a_((MD5Context *, const unsigned char *, const unsigned int));
void md5Final _a_((unsigned char [16], MD5Context *));

#if defined(__cplusplus)
}
#endif

#endif /* !_md5_h_ */
