/*
 * Copyright (c) 1994 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
** Managing invokeId values
*/

/*
** Saleem N. Bhatti
** April 1994
*/

#if !defined(_minvoke_h_)
#define _minvoke_h_

#if !defined(_a_)
#if defined(__STDC__) || defined(__cplusplus)
#define _a_(_args_) _args_
#else
#define _a_(_args_) ()
#endif
#endif

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum InvokeSearch_e {
    InvokeSearch_id,
    InvokeSearch_invokeId,
} InvokeSearch;

typedef enum InvokeSearchType_e {
    InvokeSearchType_search,
    InvokeSearchType_first,
    InvokeSearchType_next
} InvokeSearchType;

/* User interface */
void initialiseInvoke _a_(());
void addInvoke _a_((const int fd, const int id, const int invokeId));
void removeInvoke _a_((const int fd, const int v, const InvokeSearch s));
int checkInvoke _a_((const int fd, const int v, const InvokeSearch s,
                     const InvokeSearchType t));
    /* non-zero if true */
void clearInvoke _a_((const int fd));

/*
** And just in case you want to make your own invokeId manager ...
*/
typedef struct Invoke_s {

    int id;
    int invokeId;

    struct Invoke_s *prev;
    struct Invoke_s *next;

} Invoke;

/* List element management */
Invoke *Invoke_make _a_((const int id, const int invokeId, Invoke *iList));
void Invoke_free _a_((Invoke *i));
Invoke *Invoke_search _a_((Invoke *iList, const int v, const InvokeSearch s,
                           const InvokeSearchType t));

void initialiseInvokeListSpace _a_(());
Invoke *getInvokeList _a_((const int fd));
void setInvokeList _a_((const int fd, Invoke *iList)); /* uses clearInvoke() */
void clearInvokeList _a_((const int fd));

#if defined(__cplusplus)
}
#endif

#endif
