#ifndef lint
static char *rcsid = "$Header: /xtel/isode/isode/dsap/common/RCS/dn_cmp.c,v 9.0 1992/06/16 12:12:39 isode Rel $";
#endif

/*
 * $Header: /xtel/isode/isode/dsap/common/RCS/dn_cmp.c,v 9.0 1992/06/16 12:12:39 isode Rel $
 *
 *
 * $Log: dn_cmp.c,v $
 * Revision 9.0  1992/06/16  12:12:39  isode
 * Release 8.0
 *
 */

/*
 *                                NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#include "util.h"
#include "name.h"

dn_cmp (a,b)
register DN  a,b;
{
int res;

	for (; (a != NULLDN) && (b != NULLDN) ; a = a->dn_parent, b = b->dn_parent)
		if ( (res = rdn_cmp (a->dn_rdn,b->dn_rdn)) != OK) {
			return res;
		}

	if (( a == NULLDN) && (b == NULLDN)) {
		return OK;
	} else {
		return ( a == NULLDN ? 1 : -1 );
	}

}

dn_cmp_prefix (a,b)
register DN  a,b;
{
	for (; a != NULLDN && b != NULLDN ; a = a->dn_parent, b = b->dn_parent)
		if ( dn_comp_cmp (a,b) == NOTOK) {
			return NOTOK;
		}

	if ( a == NULLDN) {
		return OK;
	} else {
		return NOTOK;
	}

}

dn_order_cmp (a,b)
register DN  a,b;
{
        int     i;

        for ( ; (a != NULLDN) && (b != NULLDN); a = a->dn_parent,
            b = b->dn_parent ) {
                if ( (i = rdn_cmp( a->dn_rdn, b->dn_rdn )) != 0 ) {
                        return( i );
                }
        }

        if ( ( a == NULLDN) && (b == NULLDN) ) {
                return( 0 );
        } else if ( b ) {       /* b longer, so a is less */
                return( -1 );
        } else {                /* a must be longer */
                return( 1 );
        }
        /* NOTREACHED */
}


/*
 * the following is exactly the same as above but it returns 2
 * when any single-value RDNs are not equal -
 * it serves to order compare OSI mgmt distinguished names
 */

dn_mgmt_order_cmp (a,b)
register DN  a,b;
{
        int     i;

        for ( ; (a != NULLDN) && (b != NULLDN); a = a->dn_parent,
            b = b->dn_parent ) {
                if ( (i = rdn_cmp( a->dn_rdn, b->dn_rdn )) != 0 ) {
                        return( 2 );
                }
        }

        if ( ( a == NULLDN) && (b == NULLDN) ) {
                return( 0 );
        } else if ( b ) {       /* b longer, so a is less */
                return( -1 );
        } else {                /* a must be longer */
                return( 1 );
        }
        /* NOTREACHED */
}


/*
 * the following should be faster than dn_cmp as it potentially involves
 * fewer RDN comparisons
 */

dn_equal (a,b)
DN a,b;
{
    register DN cur_a, cur_b;
    register int i;
    RDN a_rdn[32], b_rdn[32];	/* max 32 DN components: should be enough */

    for (i = 0, cur_a = a, cur_b = b; cur_a && cur_b;
		i++, cur_a = cur_a->dn_parent, cur_b = cur_b->dn_parent) {
	a_rdn[i] = cur_a->dn_rdn;
	b_rdn[i] = cur_b->dn_rdn;
    }

    if (cur_a || cur_b)
	return 0;

    for (--i; i >= 0; i--)
	if (rdn_cmp(a_rdn[i], b_rdn[i]) != 0)
	    return 0;
    return 1;
}

