/* oid.c - Object Identifier routines */
#ifndef lint
static char *rcsid = "$Header: /xtel/isode/isode/dsap/common/RCS/oid.c,v 9.0 1992/06/16 12:12:39 isode Rel $";
#endif

/*
 * $Header: /xtel/isode/isode/dsap/common/RCS/oid.c,v 9.0 1992/06/16 12:12:39 isode Rel $
 *
 *
 * $Log: oid.c,v $
 * Revision 9.0  1992/06/16  12:12:39  isode
 * Release 8.0
 *
 */

/*
 *                                NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


/* LINTLIBRARY */

#include <memory.h>


#include "util.h"
#include "entry.h"
#ifndef ICR1
#include "isode/cmd_srch.h"
#include "isode/tailor.h"
#else
#include "isode/compat/cmd_srch.h"
#include "isode/compat/tailor.h"
#endif

extern char chrcnv [];

extern LLog * log_dsap;

extern int oid_equal();

FILE * f_table;

static char * get_entry ();
static add_entry ();
char * get_oid();
static char * name2gen ();
int add_entry_aux ();

#define OIDTABLEBASESIZE		100
#define OIDTABLEINCSIZE 		50

oid_table       * OIDTableBasep		= NULLTABLE ;
int		currOIDTableSize  	= 0 ; /* Number of entries possible */
int		NumEntries          	= 0 ; /* Number of entries used */

oid_table_attr  * attrOIDTableBasep 	= NULLTABLE_ATTR ;
int		currAttrOIDTableSize 	= 0 ; /* Number of entries possible */
int 		attrNumEntries		= 0 ; /* Number of entries used */

objectclass     * ocOIDTableBasep   	= NULLOBJECTCLASS ;
int		currOcOIDTableSize 	= 0 ; /* Number of entries possible */
int		ocNumEntries		= 0 ; /* Number of entries used */

unsigned attr_index = 0;

#define GEN  1
#define ATTR 2
#define OC   3


/*
 * OID Hash Table...
 */

#define OBUCKETS	256

struct oidpair {
    
    int	   o_entryNum ;
    int	   o_type ;
    struct oidpair *o_chain;
};

static struct oidpair *Obuckets[OBUCKETS];


/*
 * Character Hash Table...
 */

/*
#define	PBUCKETS	128
#define	PHASH(nm) \
    (((nm)[1]) ? (((chrcnv[((nm)[0])] - chrcnv[((nm)[1])]) & 0x1f) + ((chrcnv[(nm)[2]]) & 0x5f)) \
	       : (chrcnv[(nm)[0]]) & 0x7f)
*/

static int	hashlen ;

/*
 * Hashing : 0-255 key produced by taking account of the upper case first and
 * 	     second to last characters, plus the string length.
 */
#define		PBUCKETS	256
#define PHASH(nm) \
	( (hashlen = strlen(nm)) < 2  ? \
		((unsigned char)((chrcnv[((nm)[0])]))) : \
		  (hashlen & 0x01) == 1 ? \
		    ((unsigned char)((chrcnv[((nm)[0])] & 0xf) + \
    			((hashlen & 0xf) << 4) - (chrcnv[((nm)[hashlen-2])]))) : \
		    ((unsigned char)((chrcnv[((nm)[0])] & 0xf) + \
    			((hashlen & 0xf) << 4) + (chrcnv[((nm)[hashlen-2])]))))

struct pair {
    char   *p_name;
/*  caddr_t p_value;*/
    int     p_entryNum ;
    int     p_type;
    struct pair *p_chain;
};

struct aliases {
	char * a_full;
	char * a_alias;
};

static struct aliases Palias[LOTS];
static int Palias_next = 0;
static struct pair *Pbuckets[PBUCKETS];

static char allow_single_oid = FALSE;

IFP oc_load = NULLIFP;
IFP oc_macro_add = NULLIFP;

unsigned char
OHASH( oid )
OID 	oid ;
{
int	val = 0 ;

	if( oid == NULLOID )
	    return 255 ;

	if( oid != NULLOID && oid->oid_nelem > 2 ) {

	    if( oid->oid_nelem & 0x01 == 1 )
		val = (oid->oid_nelem & 0x0f)
			+ ((oid->oid_elements[oid->oid_nelem - 2 ] & 0x0f) << 4)
			- (oid->oid_elements[oid->oid_nelem - 3 ] & 0x0f)
			- ((oid->oid_elements[oid->oid_nelem - 1 ] & 0x0f) << 4) ;

	    else val = (oid->oid_elements[ oid->oid_nelem - 3 ] & 0x0f)
			+ ((oid->oid_elements[oid->oid_nelem - 1 ] & 0x0f) << 4)
			- (oid->oid_nelem & 0x0f)
			- ((oid->oid_elements[oid->oid_nelem - 2 ] & 0x0f) << 4) ;

	} else if( oid->oid_nelem > 1 ) {

	    if( oid->oid_nelem & 0x01 == 1 )
		val = (oid->oid_elements[ oid->oid_nelem - 2 ] & 0x0f)
			+ ((oid->oid_elements[oid->oid_nelem - 1 ] & 0x0f) << 4) ;
	    else
		val = (oid->oid_elements[ oid->oid_nelem - 1 ] & 0x0f)
			+ ((oid->oid_elements[oid->oid_nelem - 2 ] & 0x0f) << 4) ;
	}

	return val ;
}

int load_oid_table (table)
char * table;
{
register char * name;
char filename [FILNSIZE];
register char * extension;
char *isodetable;

	if( (OIDTableBasep     = (oid_table*)calloc(      1,sizeof(oid_table)      * OIDTABLEBASESIZE )) == NULL ||
	    (attrOIDTableBasep = (oid_table_attr*)calloc( 1,sizeof(oid_table_attr) * OIDTABLEBASESIZE )) == NULL ||
	    (ocOIDTableBasep   = (objectclass*)calloc(    1,sizeof(objectclass)    * OIDTABLEBASESIZE )) == NULL   ) {

	    advise( NULLCP, "oid.c:load_oid_table - malloc failure !" ) ;
	    return NOTOK ;
	} else {
	    currOIDTableSize = currAttrOIDTableSize = currOcOIDTableSize = OIDTABLEBASESIZE ;
	    NumEntries       = attrNumEntries       = ocNumEntries       = 0 ;
	    
	}

	isodetable = isodefile(table, 0);

	(void) strcpy (filename,isodetable);
	extension = &filename[strlen(isodetable)];

	(void) strcpy (extension,".gen");
	if (( f_table = fopen (filename,"r")) == (FILE *) NULL) {
	    bad_file: ;
		LLOG (log_dsap, LLOG_EXCEPTIONS, ("file %s",filename));
		return NOTOK;
	}

	while (1) {     /* break out */
		if ( (name = get_entry ()) == NULLCP)
			break;
		allow_single_oid = TRUE;
		if (! add_entry (name,GEN)) {
		    bad_entry:;
			LLOG (log_dsap,LLOG_EXCEPTIONS,
			      ("Can't add entry to oid table"));
#ifdef DEBUG
			advise( NULLCP, "Can't add entry to oid table" ) ;
#endif			      
			return NOTOK;
	        }
		allow_single_oid = FALSE;
	}
	(void) fclose (f_table);

	(void) strcpy (extension,".at");
	if (( f_table = fopen (filename,"r")) == (FILE *) NULL)
		goto bad_file;

	while (1) {     /* break out */
		if ( (name = get_entry ()) == NULLCP)
			break;
		if (!add_entry (name,ATTR))
			goto bad_entry;
	}
	(void) fclose (f_table);

	(void) strcpy (extension,".oc");
	if (( f_table = fopen (filename,"r")) == (FILE *) NULL)
	    goto bad_file;

	while (1) {     /* break out */
		if ( (name = get_entry ()) == NULLCP)
			break;
		if (!add_entry (name,OC))
			goto bad_entry;
	}
	(void) fclose (f_table);
	return OK;
}


void
add_Obuckets( towho, oid, aliasoid, entryNum )
int	towho ;
OID	oid, aliasoid ;
int	entryNum ;
{
struct 	oidpair * op ;
int	hindex, loopcount ;
OID	thisOID ;

	for( loopcount = 0 ;
		loopcount < 2 && (thisOID = ((loopcount == 0) ? oid : aliasoid))  ;
		++loopcount ) {

	    if ((op = (struct oidpair *) calloc (1, sizeof *op)) == NULL) {
		SLOG (log_dsap, LLOG_EXCEPTIONS, NULLCP,
			("calloc of OID hashed oid structure failed"));
#ifdef DEBUG
		advise( NULLCP, "calloc of OID hashed oid structure failed" ) ;
#endif
		return ;
	    }

	    op->o_entryNum = entryNum ;
	    op->o_type     = towho ;
	    op->o_chain    = Obuckets[hindex = OHASH(thisOID)] ;
	    Obuckets[hindex] = op ;
	}
}

add_entry_aux (a,b,c,d)
char * a;
/*caddr_t b;*/
int b ;
int c ;
char * d;
{
    int	    hindex ;
    register struct pair    *p;

    for (p = Pbuckets[ hindex = PHASH (a)];
	p && lexequ (p -> p_name, a);
	p = p -> p_chain) 
	    ; /* NO-OP */

    if ( p ) {
	LLOG (log_dsap,LLOG_FATAL,("duplicate OID '%s'",a));
#ifdef DEBUG
	advise( NULLCP, "duplicate OID '%s'",a ) ;
#endif
	return FALSE;
    }

    if ((p = (struct pair *) calloc (1, sizeof *p)) == NULL) {
	SLOG (log_dsap, LLOG_EXCEPTIONS, NULLCP,
	      ("calloc of oid hash structure failed"));
#ifdef DEBUG
	advise( NULLCP, "calloc of oid hash structure failed" ) ;
#endif
	return FALSE;
    }

    p -> p_name = a;
    p -> p_entryNum = b;
    p -> p_type = c;
    p -> p_chain = Pbuckets[hindex];
    Pbuckets[hindex] = p;

    if (d != NULLCP) {
	for (p = Pbuckets[PHASH (d)];
	     p && lexequ (p -> p_name, d);
	     p = p -> p_chain) 
		; /* NO-OP */

	if ( p ) {
		LLOG (log_dsap,LLOG_FATAL,("duplicate alias OID '%s'",d));
#ifdef DEBUG
		advise( NULLCP, "duplicate alias OID '%s'",d ) ;
#endif
		return FALSE;
	}

	if ((p = (struct pair *) calloc (1, sizeof *p)) == NULL) {
		SLOG (log_dsap, LLOG_EXCEPTIONS, NULLCP,
	      	   	   ("calloc of alias hash structure failed"));
#ifdef DEBUG
		advise( NULLCP, "calloc of oid hash structure failed" ) ;
#endif
		return FALSE;
    	}

	Palias[Palias_next].a_full = a;
	Palias[Palias_next++].a_alias = d;

    	p -> p_name = d;
    	p -> p_entryNum = b;
    	p -> p_type = c;
    	p -> p_chain = Pbuckets[hindex = PHASH (p -> p_name)];
    	Pbuckets[hindex] = p;
    }

    return TRUE;
}


static add_entry (newname,towho)
char * newname;
int towho;
{
register char *nptr, *ptr, *sep;
OID oid = NULLOID, aliasoid = NULLOID;
oid_table * Current;
char * alias = NULLCP;
int	nEntries = 0 ;

	if ((nptr = index (newname,SEPERATOR)) == 0) {
		LLOG (log_dsap,LLOG_FATAL,("oid missing in %s",newname));
#ifdef DEBUG
		advise( NULLCP, "oid missing in %s", newname ) ;
#endif
		return FALSE;
	}
	*nptr = 0;
	if ((sep = index (newname,COMMA)) != 0) {
		*sep++ = 0;
		alias = strdup(newname);
		newname = sep;
	} 

	switch (towho) {
		case GEN:
			Current = &OIDTableBasep[NumEntries];
			Current->ot_name = strdup(newname);
			if (!add_entry_aux (Current->ot_name,/*(caddr_t)&OIDTableBasep[NumEntries]*/
							nEntries = NumEntries,GEN,alias))
				return FALSE;
			break;
		case ATTR:
			Current = &attrOIDTableBasep[attrNumEntries].oa_ot;
			Current->ot_name = strdup(newname);
			if (!add_entry_aux (Current->ot_name,/*(caddr_t)&attrOIDTableBasep[attrNumEntries]*/
							nEntries = attrNumEntries,ATTR,alias))
				return FALSE;
			break;
		case OC:
			Current = &ocOIDTableBasep[ocNumEntries].oc_ot;
			Current->ot_name = strdup(newname);
			if (!add_entry_aux (Current->ot_name,/*(caddr_t)&ocOIDTableBasep[ocNumEntries]*/
							nEntries = ocNumEntries,OC,alias))
				return FALSE;
			break;
		}
	*nptr = SEPERATOR;
	nptr++;

	if ((sep = index (nptr,SEPERATOR)) != 0)
		*sep++ = 0;

	/* initialise the possibly realloced state.. */
	Current->ot_aliasoid = Current->ot_oid = NULLOID ;

	if ((ptr = index (nptr,COMMA)) != 0) {
		char * p;
		*ptr++ = 0;
		if (( p = get_oid (ptr)) == NULLCP) {
			LLOG (log_dsap,LLOG_FATAL,("invalid alias oid '%s'",ptr));
#ifdef DEBUG
			advise( NULLCP, "invalid alias oid '%s'",ptr ) ;
#endif
			return FALSE;
		}
		if ((oid = str2oid (p)) == NULLOID)
			Current->ot_aliasoid = NULLOID;
		else
			Current->ot_aliasoid = oid_cpy (oid);
	}

	ptr = get_oid (nptr);
	if (ptr == NULLCP) {
		LLOG (log_dsap,LLOG_FATAL,("invalid oid '%s'",nptr));
#ifdef DEBUG
		advise( NULLCP, "invalid oid '%s'",nptr ) ;
#endif
		return FALSE;
	}
	Current->ot_stroid = strdup(ptr);


	if( oid != NULLOID )
	    aliasoid = oid_cpy( oid ) ; /* str2oid() does not create state ! */


	oid = str2oid (Current->ot_stroid);
	if (oid == NULLOID) {
		Current->ot_oid = NULLOID;
		/* only reason for failure is generic oid of length 1 */
#ifdef DEBUG
		advise( NULLCP, "oid.c:add_entry() invalid OID %s = %s", nptr, Current->ot_stroid ) ;
#endif
	} else {
		Current->ot_oid = oid_cpy (oid);
		
		add_Obuckets( towho, oid, aliasoid, nEntries ) ;
	}

	if( aliasoid != NULLOID )
	    oid_free( aliasoid ) ;

	/* now do special work for at and oc types */
	switch (towho) {
		case GEN:
			if( incNumEntries() == NOTOK )
				return FALSE ;
			
			break;
		case ATTR:
			if (sep == 0) {
				LLOG (log_dsap,LLOG_FATAL, ("syntax missing in %s",newname));
#ifdef DEBUG
				advise( NULLCP, "syntax missing in %s",newname ) ;
#endif				
				return FALSE;
			} else {
				if (( ptr = index (sep,SEPERATOR)) != NULLCP) {
					*ptr++ = 0;
					if (lexequ (ptr,"FILE") != 0) {
						LLOG (log_dsap,LLOG_FATAL, ("FILE syntax expected, '%s' found",ptr));
#ifdef DEBUG
						advise( NULLCP, "FILE syntax expected, '%s' found",ptr ) ;
#endif
						return FALSE;
					} else {
						attrOIDTableBasep[attrNumEntries].oa_syntax = str2syntax(sep);
						attrOIDTableBasep[attrNumEntries].oa_syntax += AV_WRITE_FILE;

						if( incAttrNumEntries() == NOTOK )
						    return FALSE ;
					}
				} else {
					attrOIDTableBasep[attrNumEntries].oa_syntax = str2syntax(sep);

					if( incAttrNumEntries() == NOTOK )
					    return FALSE ;					
				}
			}
			break;
		case OC:
			if (oc_load != NULLIFP) {
				if ((*oc_load)(sep,ptr) == OK)
					if( incOcNumEntries() == NOTOK )
						return FALSE ;

			} else if( incOcNumEntries() == NOTOK )
				return FALSE ;
	}
	return TRUE;
}

char * get_oid (str)
char * str;
{
static char * buffer = NULLCP;
register char * ptr;
register char * dotptr;
register char * soid;
char deref = FALSE;
char got_dot = FALSE;

      if (buffer == NULLCP)
	      buffer = smalloc (LINESIZE);
  
      ptr = buffer;

      if ( ! isdigit(*str))
	      if ((dotptr = index (str,DOT)) == 0)
		      return (name2gen(str));

	while (*str != 0) {
	        if (*str == DOT)
		    got_dot = TRUE;

		if ( (! isdigit (*str)) && (*str != DOT) ) {
			if ((dotptr = index (str,DOT)) == 0) {
				*--ptr = 0;
				return (buffer);
			} else
				got_dot = TRUE;

			*dotptr = 0;
			*ptr = 0;
			if ((soid = name2gen(str)) == NULLCP) {
				*dotptr = DOT;
				return (NULLCP);
			}
			*dotptr = DOT;
			str = dotptr;
			if (deref) {
				if ((dotptr = rindex (soid,DOT)) == 0)
					return (NULLCP); /* invalid */
				if ((strncmp (soid,buffer,strlen(buffer))) != 0)
					return (NULLCP);  /* inconsistent */
			}
			deref = TRUE;
			(void) strcpy (buffer,soid);
			ptr = buffer + strlen (soid);
			}
		else 
			*ptr++ = *str++;
	}

	if ( !got_dot && !allow_single_oid )
		return NULLCP;

	*ptr = 0;
	return (buffer);
}

static char * name2gen (nodename)
char * nodename;
{
struct pair *p;
oid_table * ot;

	for (p = Pbuckets[PHASH (nodename)];
		p && lexequ (p -> p_name, nodename);
     		p = p -> p_chain) 
			; /* NO-OP */

	if (p != NULL)
		switch (p -> p_type) {
		    case GEN: 
			ot = (oid_table *)(&OIDTableBasep[p->p_entryNum]) ;
			return (ot->ot_stroid);
		    default: 
			return (NULLCP);
		    }

	return NULLCP;
}

static char * soid2gen (soid)
char * soid;
{
register int i;
register oid_table * tblptr = &OIDTableBasep[0];
	for (i=0;i<NumEntries;i++,tblptr++) {
		if (strcmp (tblptr->ot_stroid, soid) == 0)
			return (tblptr->ot_name);
	}

	return (NULLCP);
}

static char * get_line ()
{
static char * buffer;
static int buflen;
register char * buf;
register char * ptr;
register int done;
register int left;
register int size;

        if (buffer == NULLCP) {
	      buffer = smalloc (LINESIZE);
	      buflen = LINESIZE;
	}

        buf = buffer, ptr = buffer;
	left = buflen;

	/* read line, ignore comments, join lines in '/' found */

	do {
		done = TRUE;
		if (fgets (buf, left, f_table) == NULLCP)
			return (NULLCP);

		StripSpace (buf);
		if (*buf != 0) {
			size = strlen(buf);
			ptr += size - 1;
			left -= size;
			if (*ptr == '\\') {
				buf = ptr;
				done = FALSE;

				if (left <= 20) {
				    buflen += LINESIZE;
				    if ((buffer = realloc(buffer, 
						  (unsigned)buflen)) == NULL)
					return (NULL);
				    size = strlen(buffer);
				    buf = buffer + size - 1;
				    left = buflen - size;
				}
			}
		} else
			done = FALSE;
	} while (done == FALSE);

	return (buffer);
}

static char * get_entry ()
{
register char * buf;
register char * ptr;

	/* read next line - test for macro defs */
	while (1) { /* return out */
		if ((buf = get_line ()) == NULLCP)
			return (NULLCP);

		if ((ptr = index (buf,'=')) != 0) {
			*ptr++ = 0;
			if (oc_macro_add != NULLIFP) {
				(*oc_macro_add) (buf,ptr);
			}
		} else
			return (buf);

	}


}

oid_table_attr *name2attr(nodename)
char * nodename;
{
register int i;
register char * ptr;
char * str;
register oid_table_attr * atrptr = &attrOIDTableBasep[0];

	attr_index = 0;

	if ((ptr = rindex (nodename,DOT)) == 0) {
		struct pair *p;
		for (p = Pbuckets[PHASH (nodename)];
			p && lexequ (p -> p_name, nodename);
	     		p = p -> p_chain) 
				; /* NO-OP */

		if ((p != NULL) && (p->p_type == ATTR)) {
			attr_index = ((oid_table_attr *) (&attrOIDTableBasep[p->p_entryNum])) - atrptr;
			return ( (oid_table_attr *) (&attrOIDTableBasep[p->p_entryNum]));
		} else 
			return (NULLTABLE_ATTR);

	} else {
		if ((str = get_oid (nodename)) == NULLCP) {
			LLOG (log_dsap,LLOG_FATAL,("invalid oid '%s'",nodename));
			return (NULLTABLE_ATTR);
		}
		if (isdigit (*++ptr)) {
			for (i=0;i<attrNumEntries;i++,atrptr++)
				if (lexequ (atrptr->oa_ot.ot_stroid, str) == 0) {
					attr_index = atrptr - &attrOIDTableBasep[0];
					return (atrptr);
				}
			return (NULLTABLE_ATTR);
		} else {
			for (i=0;i<attrNumEntries;i++,atrptr++)
				if (lexequ (atrptr->oa_ot.ot_name, ptr) == 0)
					if (strncmp (str,atrptr->oa_ot.ot_stroid,strlen(str)) == 0) {
						attr_index = atrptr - &attrOIDTableBasep[0];
						return (atrptr);
					} else
						return (NULLTABLE_ATTR);
		}
	}
	return (NULLTABLE_ATTR);
	
}

set_heap (x)
AttributeType x;
{
	if (x == NULLTABLE_ATTR)
		return 0;

	return (attr_index = x - &attrOIDTableBasep[0]);
		
}

oid_table *
oid2gen( oid )
OID	oid ;
{
register int i;
register oid_table * ptr = NULLTABLE ;
register struct oidpair * op ;

	if( oid != NULLOID ) {

	    for( op = Obuckets[OHASH(oid)] ;
	    	 op != NULL ;
		 op = op -> o_chain ) {

		if( op->o_type == GEN &&
		    (ptr = &OIDTableBasep[ op->o_entryNum ]) != NULLTABLE &&
		    	(oid_equal( ptr->ot_oid, oid ) ||
		    	 oid_equal( ptr->ot_aliasoid, oid )) ) {

		     return ptr ;
		}
	    }
	}

	return (NULLTABLE);
}

oid_table_attr *oid2attr(oid)
OID oid;
{
register int i;
register oid_table_attr * ptr = NULLTABLE_ATTR ;
register struct oidpair * op ;

	if( oid != NULLOID ) {

	    for( op = Obuckets[OHASH(oid)] ;
	    	 op != NULL ;
		 op = op -> o_chain ) {

		if( op->o_type == ATTR &&
		    (ptr = (oid_table_attr*)(&attrOIDTableBasep[ op->o_entryNum ])) != NULLTABLE_ATTR &&
		    	(oid_equal( ptr->oa_ot.ot_oid, oid ) ||
		    	 oid_equal( ptr->oa_ot.ot_aliasoid, oid )) ) {

		     return ptr ;
		}
	    }
	}

	return (NULLTABLE_ATTR);
}

objectclass *name2oc(nodename)
register char * nodename;
{
register int i;
register char * ptr;
char * str;
register objectclass * oc = &ocOIDTableBasep[0];

	if ((ptr = rindex (nodename,DOT)) == 0) {
		struct pair *p;
		for (p = Pbuckets[PHASH (nodename)];
			p && lexequ (p -> p_name, nodename);
	     		p = p -> p_chain) 
				; /* NO-OP */

		if ((p != NULL) && (p->p_type == OC))
			return ( (objectclass *) (&ocOIDTableBasep[p->p_entryNum]));
		else 
			return (NULLOBJECTCLASS);
	} else {
		str = get_oid (nodename);
		if (isdigit (*++ptr)) {
			for (i=0;i<ocNumEntries;i++,oc++)
				if (lexequ (oc->oc_ot.ot_stroid, str) == 0)
				return (oc);
			return (NULLOBJECTCLASS);
		} else {
			for (i=0;i<ocNumEntries;i++,oc++)
				if (lexequ (oc->oc_ot.ot_name, ptr) == 0)
					if (strncmp (str,oc->oc_ot.ot_stroid,strlen(str)) == 0)
						return (oc);
					else
						return (NULLOBJECTCLASS);

		}
	}

	return (NULLOBJECTCLASS);
}


objectclass *oid2oc(oid)
OID oid;
{
register int i;
register objectclass * oc = NULLOBJECTCLASS ;
register struct oidpair * op ;

	if( oid != NULLOID ) {

	    for( op = Obuckets[OHASH(oid)] ;
	    	 op != NULL ;
		 op = op -> o_chain ) {

		if( op->o_type == OC &&
		    (oc = (objectclass*)&ocOIDTableBasep[ op->o_entryNum ]) != NULLOBJECTCLASS &&
		    	(oid_equal( oc->oc_ot.ot_oid, oid ) ||
		    	 oid_equal( oc->oc_ot.ot_aliasoid, oid )) ) {

		     return oc ;
		}
	    }
	}

	return (NULLOBJECTCLASS);
}


static char * full_gen (ot)
oid_table * ot;
{
static char * buffer;
register char * ptr;
register char * soid;
register char * str;

        if (buffer == NULLCP)
	      buffer = smalloc (LINESIZE);

	ptr = buffer;

	buffer [0] = '\0';
	str = sprintoid (ot->ot_oid);

	soid   = str;

	while (*str != '\0')
		if ( *str == DOT)  {
			*str = '\0';
			ptr = soid2gen (soid);
			if (ptr == NULLCP) {
				*str++ = DOT;
				continue;
			}
			(void) strcat (buffer,".");
			(void) strcat (buffer,ptr);
			*str++ = DOT;
		} else
			str++;
	
	(void) strcat (buffer,".");
	(void) strcat (buffer,ot->ot_name);
	return (&buffer[1]);
}

static char * part_gen (ot)
oid_table * ot;
{
static char * buffer = NULLCP;
register char * ptr;
register char * soid;
register char * str;
char * last;

        if (buffer == NULLCP)
	      buffer = smalloc (LINESIZE);

	ptr = buffer;

	if (index (ot->ot_name,DOT) == NULLCP)
		return (ot->ot_name);

	str = sprintoid (ot->ot_oid);

	soid = str;
	last = str;

	while (*str != '\0')
		if ( *str == DOT)  {
			*str = '\0';
			ptr = soid2gen (soid);
			if (ptr == NULLCP) {
				*str++ = DOT;
				break;
			} else
				(void) strcpy (buffer,ptr);
			last = str;
			*str++ = DOT;
			
		} else
			str++;

	(void) strcat (buffer,last);
	return (buffer);
}

char *
gen2name( ptr, format )
register oid_table * ptr ;
int	format ;
{
	switch (format) {
		case OIDFULL:
			return (full_gen (ptr));
		case OIDNUM:
			return (ptr->ot_stroid);
		default:
			return (part_gen (ptr));
	}
}


#ifndef attr2name_aux
char *attr2name_aux (oa)
register oid_table_attr *oa;
{
	if ( oa != NULLTABLE_ATTR)
		return (oa->oa_ot.ot_name);
	else {
		LLOG (log_dsap,LLOG_EXCEPTIONS,("NULL table entry"));
		return (NULLCP);
	}
}
#endif

char *attr2name(oa,format)
register oid_table_attr *oa;
int format;
{
int x;

	if ( oa != NULLTABLE_ATTR)
		switch (format) {
		case OIDFULL:
			return (full_gen (&oa->oa_ot));
		case OIDNUM:
			return (oa->oa_ot.ot_stroid);
		default:
			/* look for long name */
			for (x=0; x<Palias_next; x++)
				if (lexequ (Palias[x].a_full,oa->oa_ot.ot_name) == 0)
					return (Palias[x].a_alias);
			return (part_gen (&oa->oa_ot));
		}
	else {
		LLOG (log_dsap,LLOG_EXCEPTIONS,("NULL table entry"));
		return (NULLCP);
	}
}


char *oc2name(oc,format)
register objectclass *oc;
int format;
{
	if ( oc != NULLOBJECTCLASS)
		switch (format) {
		case OIDFULL:
			return (full_gen (&oc->oc_ot));
		case OIDNUM:
			return (oc->oc_ot.ot_stroid);
		default:
			return (part_gen (&oc->oc_ot));
		}
	else
		return (NULLCP);
}

char *oid2name(oid,format)
OID oid;
int format;
{
oid_table_attr * at;
objectclass * oc;
register int i;
register oid_table* ptr = NULLTABLE ;
char * sptr;
register struct oidpair * op ;

	if( oid != NULLOID ) {

	    for( op = Obuckets[OHASH(oid)] ;
	    	 op != NULL ;
		 op = op -> o_chain ) {

		switch( op->o_type ) {

		    case ATTR : if( (at = (oid_table_attr*)&attrOIDTableBasep[ op->o_entryNum ] ) != NULLTABLE_ATTR &&
					(oid_equal( at->oa_ot.ot_oid, oid ) ||
		    			 oid_equal( at->oa_ot.ot_aliasoid, oid )) ) {
		    			
		    		    return( attr2name( at, format ) ) ;
				}
			    	break ;

		    case OC :   if( (oc = (objectclass*)&ocOIDTableBasep[ op->o_entryNum ]) != NULLOBJECTCLASS &&
					(oid_equal( oc->oc_ot.ot_oid, oid ) ||
					 oid_equal( oc->oc_ot.ot_aliasoid, oid )) ) {

				    return( oc2name( oc, format ) ) ; 
		    		}
				break ;
		    case GEN :	if( (ptr = (oid_table*)&OIDTableBasep[ op->o_entryNum ]) != NULLTABLE &&
           				(oid_equal (ptr->ot_oid, oid) ||
       					 oid_equal (ptr->ot_aliasoid, oid )) ) {

				    return( gen2name( ptr, format ) ) ;
				}
				break ;
		} /* switch */
	    }	
	}

	if ((sptr = oid2ode_aux (oid,0)) == NULLCP)
	    parse_error ("Bad OID '%s'",sprintoid (oid));

	return (sptr);

}

OID name2oid (str)
register char * str;
{
register struct pair *p;
OID ptr;

	if (*str == 0)
                return NULLOID;

	for (p = Pbuckets[PHASH (str)];
		p && lexequ (p -> p_name, str);
     		p = p -> p_chain) 
			; /* NO-OP */

	if (p != NULL)
		switch (p -> p_type) {
		    case GEN: {
			oid_table * ot;
			ot = (oid_table *) (&OIDTableBasep[p->p_entryNum]);
			return (oid_cpy(ot->ot_oid));
		    }
		    case ATTR: {
			oid_table_attr * at;
			at = (oid_table_attr *) (&attrOIDTableBasep[p->p_entryNum]) ;
			return (oid_cpy(at->oa_ot.ot_oid)) ;
		    }
		    case OC: {
			objectclass * oc;
			oc = (objectclass *) (&ocOIDTableBasep[p->p_entryNum]) ;
			return (oid_cpy(oc->oc_ot.ot_oid)) ;
		    }
		    default:
			if ( (ptr=ode2oid (str)) == NULLOID)
				return (oid_cpy(str2oid(str)));
			return (oid_cpy(ptr));
		}
	else {
 		/* try general oid lookup */
 		char * x;
 		if ((x=get_oid(str)) != NULLCP)
 			return (oid_cpy(str2oid(x)));
 		
		/* try isobjects */
		if ( (ptr=ode2oid (str)) == NULLOID) {
			if ((ptr=str2oid(str)) == NULLOID) {
				parse_error ("unknown OID '%s'",str);
				return NULLOID;
			}
			return (oid_cpy(ptr));
		}
		return (oid_cpy(ptr));
	}

}

PE oid2pe (o)
OID o;
{ 
/* needed cos of a macro */
	return (oid2prim (o));		
}

oidprint (ps,o,format)
PS ps;
OID o;
int format;
{
extern int oidformat;

	if (format == READOUT)
		ps_printf (ps,"%s",oid2name(o,oidformat));
	else
		ps_printf (ps,"%s",oid2name(o,OIDPART));
}

OID dup_prim2oid (pe)
PE pe;
{ 	
OID oid;

        if (! test_prim_pe (pe,PE_CLASS_UNIV,PE_PRIM_OID))
		return (NULLOID);

	if (( oid = prim2oid(pe)) == NULLOID)
		return (NULLOID);
	
	return (oid_cpy(oid));
}

void	free_Poid_buckets()
{
int i;
struct pair *p, *np;
 
	for (i=0;i<PBUCKETS;i++) 
		for (p = Pbuckets[i]; p != (struct pair *)NULL ; p = np) {
			np = p -> p_chain;
			free (p->p_name);
			free ((char *)p);
		}

	return ;  
}

void	free_Ooid_buckets()
{
int	i;
struct	oidpair *p, *np ;

	for( i=0;i<OBUCKETS;i++) 
		for (p = Obuckets[i]; p != (struct oidpair *)NULL ; p = np) {
			np = p -> o_chain;
			free ((char *)p); /* Free the node itself */
		}

	return ;
}

oid_syntax ()
{
	(void) add_attribute_syntax ("oid",
		(IFP) oid2pe,	(IFP) dup_prim2oid,
		(IFP) name2oid,	oidprint,
		(IFP) oid_cpy,	oid_cmp,
		oid_free,	NULLCP,
		NULLIFP,	FALSE );
}


int
incNumEntries()
{
int	status = NOTOK ;

	if( OIDTableBasep == NULLTABLE || currOIDTableSize <= 0 || NumEntries < 0 ) {

	    advise( NULLCP, "oid.c:incNumEntries() - increment attempted for non-initialised OID data" ) ;

	} else if( (++NumEntries) >= currOIDTableSize ) {

	    if( (OIDTableBasep = (oid_table*)realloc( OIDTableBasep, 
	    		sizeof( oid_table ) * (currOIDTableSize + OIDTABLEINCSIZE) )) == NULLTABLE ) {

		advise( NULLCP, "oid.c:incNumEntries() - realloc failure !" ) ;
	    
	    } else {
		/* Clear down the new memory... */
	        (void)memset( ((char*)OIDTableBasep) + sizeof(oid_table) * currOIDTableSize,
					'\0', sizeof(oid_table) * OIDTABLEINCSIZE ) ;

		currOIDTableSize += OIDTABLEINCSIZE ;
		status = OK ;
	    }

	} else status = OK ;

	return status ;
}


int
incAttrNumEntries()
{
int	status = NOTOK ;

	if( attrOIDTableBasep == NULLTABLE_ATTR || currAttrOIDTableSize <= 0 || attrNumEntries < 0 ) {

	    advise( NULLCP, "oid.c:incAttrNumEntries() - increment attempted for non-initialised ATTR data" ) ;

	} else if( (++attrNumEntries) >= currAttrOIDTableSize ) {

	    if( (attrOIDTableBasep = (oid_table_attr*)realloc( attrOIDTableBasep, 
	    		sizeof( oid_table_attr ) * (currAttrOIDTableSize + OIDTABLEINCSIZE) )) == NULLTABLE_ATTR ) {

		advise( NULLCP, "oid.c:incAttrNumEntries() - realloc failure !" ) ;
	    
	    } else {
		/* Clear down the new memory... */
	        (void)memset( ((char*)attrOIDTableBasep) + sizeof(oid_table_attr) * currAttrOIDTableSize,
					'\0', sizeof(oid_table_attr) * OIDTABLEINCSIZE ) ;

		currAttrOIDTableSize += OIDTABLEINCSIZE ;
		status = OK ;
	    }

	} else status = OK ;

	return status ;
}


int
incOcNumEntries()
{
int	status = NOTOK ;

	if( ocOIDTableBasep == NULLOBJECTCLASS || currOcOIDTableSize <= 0 || ocNumEntries < 0 ) {

	    advise( NULLCP, "oid.c:icmOcNumEntries() - increment attempted for non-initialised OC data" ) ;

	} else if( (++ocNumEntries) >= currOcOIDTableSize ) {

	    if( (ocOIDTableBasep = (objectclass*)realloc( ocOIDTableBasep, 
	    		sizeof( objectclass ) * (currOcOIDTableSize + OIDTABLEINCSIZE) )) == NULLOBJECTCLASS ) {

		advise( NULLCP, "oid.c:incOcNumEntries() - realloc failure !" ) ;
	    
	    } else {
		/* Clear down the new memory... */
	        (void)memset( ((char*)ocOIDTableBasep) + sizeof(objectclass) * currOcOIDTableSize,
					'\0', sizeof(objectclass) * OIDTABLEINCSIZE ) ;

		currOcOIDTableSize += OIDTABLEINCSIZE ;
		status = OK ;
	    }

	} else status = OK ;

	return status ;
}

#ifdef DEBUG
void checkPBuckets()
{
int	b, i, cnt, totcnt=0, gencnt=0, attrcnt=0, occnt=0, mymin=1000000, mymax=0 ;
struct  pair * p ;

	for(b=0;b<PBUCKETS;b++ ) {
	    
	    for( p = Pbuckets[b], cnt=0 ; p != NULL ; p=p->p_chain ) {
 	    	++cnt ;
		switch( p->p_type ) {
			case GEN  : ++gencnt ; break ;
			case ATTR : ++attrcnt ; break ;
			case OC   : ++occnt ; break ;
		}
	    }

	    fprintf( stderr, "PBucket %d=%d\n", b, cnt ) ;
	    totcnt += cnt ;

	    if( cnt < mymin ) mymin = cnt ;
	    if( cnt > mymax ) mymax = cnt ;

	    if( cnt > 5 ) {
	    	for( p = Pbuckets[b] ; p != NULL ; p=p->p_chain)
		    fprintf( stderr, "%s ", p->p_name );

		fprintf( stderr, "\n" ) ;
	    }
	}

	fprintf( stderr, "Buckets=%d TOTAL=%d MEAN=%d MIN=%d MAX=%d\n", PBUCKETS, totcnt, totcnt/PBUCKETS,
			mymin, mymax ) ;

	fprintf( stderr, "Rememeber that these figures include alias counts...\n" ) ;
	fprintf( stderr, "GEN %d ATTR %d OC %d", gencnt, attrcnt, occnt ) ;

	for(b=0;b<PBUCKETS;b++ )
	    for( p = Pbuckets[b], cnt=0 ; p != NULL ; p=p->p_chain )
		if( p->p_type == GEN )
		    fprintf( stderr, "GEN %s\n", ((oid_table*)&OIDTableBasep[ p->p_entryNum ])->ot_name ) ;
	
	for(b=0;b<PBUCKETS;b++ )
	    for( p = Pbuckets[b], cnt=0 ; p != NULL ; p=p->p_chain )
		if( p->p_type == ATTR )
		    fprintf( stderr, "ATTR %s\n", ((oid_table_attr*)&attrOIDTableBasep[ p->p_entryNum ])->oa_ot.ot_name ) ;
	
	for(b=0;b<PBUCKETS;b++ )
	    for( p = Pbuckets[b], cnt=0 ; p != NULL ; p=p->p_chain )
		if( p->p_type == OC )
		    fprintf( stderr, "OC %s\n", ((objectclass*)&ocOIDTableBasep[ p->p_entryNum ])->oc_ot.ot_name ) ;
	return ;
}

void checkOBuckets()
{
int	b, i, cnt, totcnt=0, gencnt=0, attrcnt=0, occnt=0, mymin=1000000, mymax=0 ;
struct  oidpair * p ;

	for(b=0;b<OBUCKETS;b++ ) {
	    
	    for( p = Obuckets[b], cnt=0 ; p != NULL ; p=p->o_chain ) {
 	    	++cnt ;
		switch( p->o_type ) {
			case GEN  : ++gencnt ; break ;
			case ATTR : ++attrcnt ; break ;
			case OC   : ++occnt ; break ;
		}
	    }

	    fprintf( stderr, "OBucket %d=%d\n", b, cnt ) ;
	    totcnt += cnt ;

	    if( cnt < mymin ) mymin = cnt ;
	    if( cnt > mymax ) mymax = cnt ;

	    if( cnt > 5 ) {
	    	for( p = Obuckets[b] ; p != NULL ; p=p->o_chain) {
		
		    switch( p->o_type ) {
		    	case GEN :
		    	fprintf( stderr, "%s ", (&OIDTableBasep[p->o_entryNum])->ot_name );
		    	break ;
		    	case ATTR :
		    	fprintf( stderr, "%s ", (&attrOIDTableBasep[p->o_entryNum])->oa_ot.ot_name );
		    	break ;
		    	case OC :
		    	fprintf( stderr, "%s ", (&ocOIDTableBasep[p->o_entryNum])->oc_ot.ot_name );
		    	break ;
		    }
		}

		fprintf( stderr, "\n" ) ;
	    }
	}

	fprintf( stderr, "Buckets=%d TOTAL=%d MEAN=%d MIN=%d MAX=%d\n", PBUCKETS, totcnt, totcnt/PBUCKETS,
			mymin, mymax ) ;

	fprintf( stderr, "Rememeber that these figures include alias OID counts...\n" ) ;
	fprintf( stderr, "GEN %d ATTR %d OC %d", gencnt, attrcnt, occnt ) ;

	for(b=0;b<OBUCKETS;b++ )
	    for( p = Obuckets[b], cnt=0 ; p != NULL ; p=p->o_chain )
		if( p->o_type == GEN )
		    fprintf( stderr, "GEN %s\n", ((oid_table*)&OIDTableBasep[ p->o_entryNum ])->ot_name ) ;
	
	for(b=0;b<OBUCKETS;b++ )
	    for( p = Obuckets[b], cnt=0 ; p != NULL ; p=p->o_chain )
		if( p->o_type == ATTR )
		    fprintf( stderr, "ATTR %s\n", ((oid_table_attr*)&attrOIDTableBasep[ p->o_entryNum ])->oa_ot.ot_name ) ;
	
	for(b=0;b<OBUCKETS;b++ )
	    for( p = Obuckets[b], cnt=0 ; p != NULL ; p=p->o_chain )
		if( p->o_type == OC )
		    fprintf( stderr, "OC %s\n", ((objectclass*)&ocOIDTableBasep[ p->o_entryNum ])->oc_ot.ot_name ) ;
	
	return ;
}

oid_table_attr *oldOid2attr(oid)
OID oid;
{
register int i;
register oid_table_attr * ptr = &attrOIDTableBasep[0];

	for (i=0;i<attrNumEntries;i++,ptr++) {
		if (oid_equal(ptr->oa_ot.ot_oid, oid))
			return (ptr);
		else if (oid_equal (ptr->oa_ot.ot_aliasoid, oid) )
			return (ptr);
		
	}

	return (NULLTABLE_ATTR);
}


objectclass *oldOid2oc(oid)
OID oid;
{
register int i;
register objectclass * oc = &ocOIDTableBasep[0];

	for (i=0;i<ocNumEntries;i++,oc++) {
		if (oid_equal (oc->oc_ot.ot_oid, oid))
			return (oc);
		else if (oid_equal (oc->oc_ot.ot_aliasoid, oid) )
			return (oc);
	}

	return (NULLOBJECTCLASS);
}

char *oldOid2name(oid,format)
OID oid;
int format;
{
oid_table_attr * at;
objectclass * oc;
register int i;
register oid_table* ptr = &OIDTableBasep[0];
char * sptr;

	/* try attribute first */
	if (( at = oldOid2attr (oid)) != NULLTABLE_ATTR)
		return (attr2name(at,format)) ;

	/* try objectclass */
	if (( oc = oldOid2oc (oid)) != NULLOBJECTCLASS)
		return (oc2name(oc,format)) ;

	/* try gen tables */
	for (i=0; i<NumEntries;i++,ptr++) {
           if ((oid_equal (ptr->ot_oid, oid)) ||
       		oid_equal (ptr->ot_aliasoid, oid)) {
		
		switch (format) {
		case OIDFULL:
			return (full_gen (ptr));
		case OIDNUM:
			return (ptr->ot_stroid);
		default:
			return (part_gen (ptr));
		}
	   }
	}

	if ((sptr = oid2ode_aux (oid,0)) == NULLCP)
		parse_error ("Bad OID '%s'",sprintoid (oid));

	return (sptr);

}


void
testOBuckets()
{
struct timeval  tvs, now;
char *	cp ;
OID	oid = str2oid( "2.37.11.1.4.2.6.2" ) ;
int 	i ;

	(void) gettimeofday (&tvs, (struct timezone *) 0);
	
	for( i=0 ; i<100 ; i++ )
	    cp = oldOid2name( oid, OIDPART ) ;

        (void) gettimeofday (&now, (struct timezone *) 0);
	now.tv_sec -= tvs.tv_sec;
	if ((now.tv_usec -= tvs.tv_usec) < 0)
	    now.tv_sec--, now.tv_usec += 1000000;
	advise (NULLCP,"100 OLD %s retrieved in %d.%06d seconds", cp ? cp : "NULL", now.tv_sec, now.tv_usec);

	(void) gettimeofday (&tvs, (struct timezone *) 0);
	
	for( i=0 ; i<100 ; i++ )
	    cp = oid2name( oid, OIDPART ) ;

        (void) gettimeofday (&now, (struct timezone *) 0);
	now.tv_sec -= tvs.tv_sec;
	if ((now.tv_usec -= tvs.tv_usec) < 0)
	    now.tv_sec--, now.tv_usec += 1000000;
	advise (NULLCP,"100 NEW %s retrieved in %d.%06d seconds", cp ? cp : "NULL", now.tv_sec, now.tv_usec);

	(void) gettimeofday (&tvs, (struct timezone *) 0);
	
	for( i=0 ; i<100 ; i++ )
	    cp = oldOid2name( oid, OIDPART ) ;

        (void) gettimeofday (&now, (struct timezone *) 0);
	now.tv_sec -= tvs.tv_sec;
	if ((now.tv_usec -= tvs.tv_usec) < 0)
	    now.tv_sec--, now.tv_usec += 1000000;
	advise (NULLCP,"100 OLD %s retrieved in %d.%06d seconds", cp ? cp : "NULL", now.tv_sec, now.tv_usec);

	(void) gettimeofday (&tvs, (struct timezone *) 0);
	
	for( i=0 ; i<100 ; i++ )
	    cp = oid2name( oid, OIDPART ) ;

        (void) gettimeofday (&now, (struct timezone *) 0);
	now.tv_sec -= tvs.tv_sec;
	if ((now.tv_usec -= tvs.tv_usec) < 0)
	    now.tv_sec--, now.tv_usec += 1000000;
	advise (NULLCP,"100 NEW %s retrieved in %d.%06d seconds", cp ? cp : "NULL", now.tv_sec, now.tv_usec);

	return ;
}

#endif
