/*
 * Copyright (c) 1993 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* Routines to release a management association */

/*
 * By George Pavlou, April 1990
 */

#include <stdio.h>
#include <sys/types.h>
#include "msap.h"
#include "xmp.h"
#include "midas_xmp.h"

extern fd_set MIDAS_read_fdset;
extern MIDAS_SESSION *session_get();

/* LINTLIBRARY */

int  M_TerminateReq_u (msd, reason, info, mi)
    int msd, reason;
    PE info;
    MSAPIndication* mi; {

    MIDAS_SESSION *sessp;
    MIDAS_STATUS *statp;

    if ((sessp = session_get(msd))
                == (MIDAS_SESSION *)NULL){
        /*assume UCL mode*/
        FD_CLR(msd, &MIDAS_read_fdset);
        return (M_TerminateReq(msd, reason, info, mi));
    }

    /*assume GMD mode*/

    statp = mp_unbind_M(sessp);
    free(sessp);

    if (statp == MIDAS_SUCCESS) return(OK);

    mi = statp->MIDAS_parameter;
    return(NOTOK);
}


int  M_TerminateResp_u (msd, status, reason, info, mi)
int msd, status, reason;
PE info;
MSAPIndication* mi;
{
    FD_CLR(msd, &MIDAS_read_fdset);

    return(M_TerminateResp (msd, status, reason, info, mi));
}



int  M_AbortReq_u (msd, info, mi)
    int msd;
    External* info;
    MSAPIndication* mi; {

    MIDAS_SESSION *sessp;
    MIDAS_STATUS *statp;

    if ((sessp = session_get(msd))
                == (MIDAS_SESSION *)NULL){
        /*assume UCL mode*/
        FD_CLR(msd, &MIDAS_read_fdset);
        return (M_AbortReq(msd, info, mi));
    }

    /*assume GMD mode*/

    statp = mp_unbind_M(sessp);
    free(sessp);

    if (statp == MIDAS_SUCCESS) return(OK);

    mi = statp->MIDAS_parameter;
    return(NOTOK);
}


/*  m_terminate - higher level friendly interface to M_TerminateReq */

int  m_terminate_u (msd)
int msd;
{
    MSAPIndication  mis;

    if (M_TerminateReq_u(msd, ACF_NORMAL, NULLPE, &mis) != OK) {
	fprintf(stderr, "Terminate request failed: reason = %s\n",
			mis.mi_abort.ma_data);
	return NOTOK;
    }
    return OK;
}
