/* Copyright (c) 1993 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*/


#include <stdio.h>
#include <sys/types.h>
#include "msap.h"
#include "xmp.h"
#if defined(SECURITY)
#include "mauth.h"
#include "mintegrity.h"
#endif
#if defined(DEBUG)
#include <string.h>
#endif

#if !defined(_a_)
#if defined(__STDC__) || defined(__cplusplus)
#define _a_(_args_) _args_
#else
#define _a_(_args_) ()
#endif
#endif

extern int debug_test _a_((char *));
int XMP_assoc_fail_u();

/*
 * Set up MSAPAbort structure for error return
 */

int
XMP_assoc_fail_u(source, reason, string, mi)
    int source, reason;
    char *string;
    MSAPIndication* mi;{

    mi->mi_type = MI_ABORT;
    mi->mi_abort.ma_source = source;
    mi->mi_abort.ma_reason = reason;
    mi->mi_abort.ma_info   = NULLEXTERN;
    (void)strncpy(mi->mi_abort.ma_data, string, MA_SIZE);

    return(NOTOK);
}

